searchNodes=[{"doc":"Credo builds upon four building blocks:Credo.CLI - everything related to the command line interface (CLI), which orchestrates the analysisCredo.Execution - a struct which is handed down the pipeline during analysisCredo.Check - the default Credo checksCredo.Code - all analysis tools used by Credo during analysis","ref":"Credo.html","title":"Credo","type":"module"},{"doc":"Runs Credo with the given argv and returns its final Credo.Execution struct.Example:iex&gt; exec = Credo.run([&quot;--only&quot;, &quot;Readability&quot;]) iex&gt; issues = Credo.Execution.get_issues(exec) iex&gt; Enum.count(issues) &gt; 0 true","ref":"Credo.html#run/1","title":"Credo.run/1","type":"function"},{"doc":"","ref":"Credo.html#run/2","title":"Credo.run/2","type":"function"},{"doc":"","ref":"Credo.html#version/0","title":"Credo.version/0","type":"function"},{"doc":"Run code analysis (use --help for options)","ref":"Mix.Tasks.Credo.html","title":"Mix.Tasks.Credo","type":"task"},{"doc":"Generate a new custom check for Credo","ref":"Mix.Tasks.Credo.Gen.Check.html","title":"Mix.Tasks.Credo.Gen.Check","type":"task"},{"doc":"Generate a new config for Credo","ref":"Mix.Tasks.Credo.Gen.Config.html","title":"Mix.Tasks.Credo.Gen.Config","type":"task"},{"doc":"Check modules represent the checks which are run during Credo's analysis.Example:defmodule MyCheck do use Credo.Check, category: :warning, base_priority: :high def run(%SourceFile{} = source_file, params) do # end endThe check can be configured by passing the following options to use Credo.Check::base_priority Sets the checks's base priority (:low, :normal, :high, :higher or :ignore).:category Sets the check's category (:consistency, :design, :readability, :refactor or :warning).:elixir_version Sets the check's version requirement for Elixir (defaults to &gt;= 0.0.1).:explanations Sets explanations displayed for the check, e.g. [ check: &quot;...&quot;, params: [ param1: &quot;Your favorite number&quot;, param2: &quot;Online/Offline mode&quot; ] ]:param_defaults Sets the default values for the check's params (e.g. [param1: 42, param2: &quot;offline&quot;]):tags Sets the tags for this check (list of atoms, e.g. [:tag1, :tag2])Please also note that these options to use Credo.Check are just a convenience to implement the Credo.Check behaviour. You can implement any of these by hand:defmodule MyCheck do use Credo.Check def category, do: :warning def base_priority, do: :high def explanations do [ check: &quot;...&quot;, params: [ param1: &quot;Your favorite number&quot;, param2: &quot;Online/Offline mode&quot; ] ] end def param_defaults, do: [param1: 42, param2: &quot;offline&quot;] def run(%SourceFile{} = source_file, params) do # end endThe run/2 function of a Check module takes two parameters: a source file and a list of parameters for the check. It has to return a list of found issues.","ref":"Credo.Check.html","title":"Credo.Check","type":"behaviour"},{"doc":"Returns the base priority for the check.This can be one of :higher, :high, :normal, :low or :ignore (technically it can also be or an integer, but these are internal representations although that is not recommended).","ref":"Credo.Check.html#c:base_priority/0","title":"Credo.Check.base_priority/0","type":"callback"},{"doc":"Returns the category for the check.","ref":"Credo.Check.html#c:category/0","title":"Credo.Check.category/0","type":"callback"},{"doc":"Returns the required Elixir version for the check.","ref":"Credo.Check.html#c:elixir_version/0","title":"Credo.Check.elixir_version/0","type":"callback"},{"doc":"Returns the exit status for the check.","ref":"Credo.Check.html#c:exit_status/0","title":"Credo.Check.exit_status/0","type":"callback"},{"doc":"","ref":"Credo.Check.html#explanation_for/2","title":"Credo.Check.explanation_for/2","type":"function"},{"doc":"Returns the explanations for the check and params as a keyword list.","ref":"Credo.Check.html#c:explanations/0","title":"Credo.Check.explanations/0","type":"callback"},{"doc":"","ref":"Credo.Check.html#c:format_issue/2","title":"Credo.Check.format_issue/2","type":"callback"},{"doc":"format_issue takes an issue_meta and returns an issue. The resulting issue can be made more explicit by passing the following options to format_issue/2::priority Sets the issue's priority.:trigger Sets the issue's trigger.:line_no Sets the issue's line number. Tries to find column if :trigger is supplied.:column Sets the issue's column.:exit_status Sets the issue's exit_status.:severity Sets the issue's severity.","ref":"Credo.Check.html#format_issue/3","title":"Credo.Check.format_issue/3","type":"function"},{"doc":"Returns the default values for the check's params as a keyword list.","ref":"Credo.Check.html#c:param_defaults/0","title":"Credo.Check.param_defaults/0","type":"callback"},{"doc":"","ref":"Credo.Check.html#c:run/2","title":"Credo.Check.run/2","type":"callback"},{"doc":"Returns wether or not this check runs on all source files.","ref":"Credo.Check.html#c:run_on_all?/0","title":"Credo.Check.run_on_all?/0","type":"callback"},{"doc":"Runs the current check on all source_files by calling run_on_source_file/3.If you are developing a check that has to run on all source files, you can overwrite run_on_all_source_files/3:defmodule MyCheck do use Credo.Check def run_on_all_source_files(exec, source_files, params) do issues = source_files |&gt; do_something_crazy() |&gt; do_something_crazier() append_issues_and_timings(exec, issues) :ok end endCheck out Credo's checks from the consistency category for examples of these kinds of checks.","ref":"Credo.Check.html#c:run_on_all_source_files/3","title":"Credo.Check.run_on_all_source_files/3","type":"callback"},{"doc":"Runs the current check on a single source_file and appends the resulting issues to the current exec.","ref":"Credo.Check.html#c:run_on_source_file/3","title":"Credo.Check.run_on_source_file/3","type":"callback"},{"doc":"Returns the tags for the check.","ref":"Credo.Check.html#c:tags/0","title":"Credo.Check.tags/0","type":"callback"},{"doc":"Converts a given category to an exit status","ref":"Credo.Check.html#to_exit_status/1","title":"Credo.Check.to_exit_status/1","type":"function"},{"doc":"","ref":"Credo.Plugin.html","title":"Credo.Plugin","type":"module"},{"doc":"","ref":"Credo.Plugin.html#append_task/3","title":"Credo.Plugin.append_task/3","type":"function"},{"doc":"","ref":"Credo.Plugin.html#append_task/4","title":"Credo.Plugin.append_task/4","type":"function"},{"doc":"","ref":"Credo.Plugin.html#prepend_task/3","title":"Credo.Plugin.prepend_task/3","type":"function"},{"doc":"","ref":"Credo.Plugin.html#prepend_task/4","title":"Credo.Plugin.prepend_task/4","type":"function"},{"doc":"","ref":"Credo.Plugin.html#register_cli_switch/5","title":"Credo.Plugin.register_cli_switch/5","type":"function"},{"doc":"Registers and initializes a Command module with a given name.","ref":"Credo.Plugin.html#register_command/3","title":"Credo.Plugin.register_command/3","type":"function"},{"doc":"","ref":"Credo.Plugin.html#register_default_config/2","title":"Credo.Plugin.register_default_config/2","type":"function"},{"doc":"Every run of Credo is configured via a Execution struct, which is created and manipulated via the Credo.Execution module.","ref":"Credo.Execution.html","title":"Credo.Execution","type":"module"},{"doc":"The Execution struct is created and manipulated via the Credo.Execution module.","ref":"Credo.Execution.html#__struct__/0","title":"Credo.Execution.__struct__/0","type":"function"},{"doc":"Builds an Execution struct for the the given argv.","ref":"Credo.Execution.html#build/1","title":"Credo.Execution.build/1","type":"function"},{"doc":"Builds an Execution struct for a re-run with the the given argv, noting to just analyse the files_that_changed.","ref":"Credo.Execution.html#build/2","title":"Credo.Execution.build/2","type":"function"},{"doc":"Returns the checks that should be run for a given exec struct.Takes all checks from the checks: field of the exec, matches those against any patterns to include or exclude certain checks given via the command line.","ref":"Credo.Execution.html#checks/1","title":"Credo.Execution.checks/1","type":"function"},{"doc":"Ensures that the given value is a %Credo.Execution{} struct, raises an error otherwise.Example:exec |&gt; mod.init() |&gt; Execution.ensure_execution_struct(&quot;\#{mod}.init/1&quot;)","ref":"Credo.Execution.html#ensure_execution_struct/2","title":"Credo.Execution.ensure_execution_struct/2","type":"function"},{"doc":"Returns the assign with the given name for the given exec struct (or return the given default value).","ref":"Credo.Execution.html#get_assign/3","title":"Credo.Execution.get_assign/3","type":"function"},{"doc":"","ref":"Credo.Execution.html#get_command/2","title":"Credo.Execution.get_command/2","type":"function"},{"doc":"Returns the name of the command, which should be run by the given execution.","ref":"Credo.Execution.html#get_command_name/1","title":"Credo.Execution.get_command_name/1","type":"function"},{"doc":"Returns all config files for the given exec struct.","ref":"Credo.Execution.html#get_config_files/1","title":"Credo.Execution.get_config_files/1","type":"function"},{"doc":"","ref":"Credo.Execution.html#get_given_cli_switch/2","title":"Credo.Execution.get_given_cli_switch/2","type":"function"},{"doc":"Returns all issues for the given exec struct.","ref":"Credo.Execution.html#get_issues/1","title":"Credo.Execution.get_issues/1","type":"function"},{"doc":"Returns all issues for the given exec struct that relate to the given filename.","ref":"Credo.Execution.html#get_issues/2","title":"Credo.Execution.get_issues/2","type":"function"},{"doc":"","ref":"Credo.Execution.html#get_plugin_param/3","title":"Credo.Execution.get_plugin_param/3","type":"function"},{"doc":"Returns the result with the given name for the given exec struct (or return the given default value).","ref":"Credo.Execution.html#get_result/3","title":"Credo.Execution.get_result/3","type":"function"},{"doc":"Returns all source files for the given exec struct.","ref":"Credo.Execution.html#get_source_files/1","title":"Credo.Execution.get_source_files/1","type":"function"},{"doc":"Returns all valid command names.","ref":"Credo.Execution.html#get_valid_command_names/1","title":"Credo.Execution.get_valid_command_names/1","type":"function"},{"doc":"Halts further execution of the pipeline.","ref":"Credo.Execution.html#halt/1","title":"Credo.Execution.halt/1","type":"function"},{"doc":"Puts the given value with the given name as assign into the given exec struct.","ref":"Credo.Execution.html#put_assign/3","title":"Credo.Execution.put_assign/3","type":"function"},{"doc":"","ref":"Credo.Execution.html#put_pipeline/3","title":"Credo.Execution.put_pipeline/3","type":"function"},{"doc":"","ref":"Credo.Execution.html#put_plugin_param/4","title":"Credo.Execution.put_plugin_param/4","type":"function"},{"doc":"Puts the given value with the given name as result into the given exec struct.","ref":"Credo.Execution.html#put_result/3","title":"Credo.Execution.put_result/3","type":"function"},{"doc":"Puts the given source_files into the given exec struct.","ref":"Credo.Execution.html#put_source_files/2","title":"Credo.Execution.put_source_files/2","type":"function"},{"doc":"Sets the issues for the given exec struct, overwriting any existing issues.","ref":"Credo.Execution.html#set_issues/2","title":"Credo.Execution.set_issues/2","type":"function"},{"doc":"Sets the exec values which strict implies (if applicable).","ref":"Credo.Execution.html#set_strict/1","title":"Credo.Execution.set_strict/1","type":"function"},{"doc":"Returns the tags for a given check and its params.","ref":"Credo.Execution.html#tags_for_check/2","title":"Credo.Execution.tags_for_check/2","type":"function"},{"doc":"","ref":"Credo.Execution.html#t:t/0","title":"Credo.Execution.t/0","type":"type"},{"doc":"Issue structs represent all issues found during the code analysis.","ref":"Credo.Issue.html","title":"Credo.Issue","type":"module"},{"doc":"","ref":"Credo.Issue.html#t:t/0","title":"Credo.Issue.t/0","type":"type"},{"doc":"IssueMeta provides helper functions for meta information which a check wants to pass to the issue_for(...) function, i.e. the current SourceFile and check params (by default).","ref":"Credo.IssueMeta.html","title":"Credo.IssueMeta","type":"module"},{"doc":"Returns an issue meta tuple for the given source_file and check_params.","ref":"Credo.IssueMeta.html#for/2","title":"Credo.IssueMeta.for/2","type":"function"},{"doc":"Returns the check params for the given issue_meta.","ref":"Credo.IssueMeta.html#params/1","title":"Credo.IssueMeta.params/1","type":"function"},{"doc":"Returns the source file for the given issue_meta.","ref":"Credo.IssueMeta.html#source_file/1","title":"Credo.IssueMeta.source_file/1","type":"function"},{"doc":"","ref":"Credo.IssueMeta.html#t:t/0","title":"Credo.IssueMeta.t/0","type":"type"},{"doc":"SourceFile structs represent a source file in the codebase.","ref":"Credo.SourceFile.html","title":"Credo.SourceFile","type":"module"},{"doc":"Returns the AST for the given source_file.","ref":"Credo.SourceFile.html#ast/1","title":"Credo.SourceFile.ast/1","type":"function"},{"doc":"Returns the column of the given trigger inside the given line.NOTE: Both line_no and the returned index are 1-based.","ref":"Credo.SourceFile.html#column/3","title":"Credo.SourceFile.column/3","type":"function"},{"doc":"Returns the line at the given line_no.NOTE: line_no is a 1-based index.","ref":"Credo.SourceFile.html#line_at/2","title":"Credo.SourceFile.line_at/2","type":"function"},{"doc":"Returns the snippet at the given line_no between column1 and column2.NOTE: line_no is a 1-based index.","ref":"Credo.SourceFile.html#line_at/4","title":"Credo.SourceFile.line_at/4","type":"function"},{"doc":"Returns the lines of source code for the given source_file.","ref":"Credo.SourceFile.html#lines/1","title":"Credo.SourceFile.lines/1","type":"function"},{"doc":"Returns a SourceFile struct for the given source code and filename.","ref":"Credo.SourceFile.html#parse/2","title":"Credo.SourceFile.parse/2","type":"function"},{"doc":"Returns the source code for the given source_file.","ref":"Credo.SourceFile.html#source/1","title":"Credo.SourceFile.source/1","type":"function"},{"doc":"Returns the source code and filename for the given source_file_or_source.","ref":"Credo.SourceFile.html#source_and_filename/2","title":"Credo.SourceFile.source_and_filename/2","type":"function"},{"doc":"","ref":"Credo.SourceFile.html#timed_out/1","title":"Credo.SourceFile.timed_out/1","type":"function"},{"doc":"","ref":"Credo.SourceFile.html#t:t/0","title":"Credo.SourceFile.t/0","type":"type"},{"doc":"Credo.Code contains a lot of utility or helper functions that deal with the analysis of - you guessed it - code.Whenever a function serves a general purpose in this area, e.g. getting the value of a module attribute inside a given module, we want to extract that function and put it in the Credo.Code namespace, so others can utilize them without reinventing the wheel.","ref":"Credo.Code.html","title":"Credo.Code","type":"module"},{"doc":"Returns an AST for a given String or Credo.SourceFile.","ref":"Credo.Code.html#ast/1","title":"Credo.Code.ast/1","type":"function"},{"doc":"Takes a SourceFile and returns its source code stripped of all Strings and Sigils.","ref":"Credo.Code.html#clean_charlists_strings_and_sigils/1","title":"Credo.Code.clean_charlists_strings_and_sigils/1","type":"function"},{"doc":"Takes a SourceFile and returns its source code stripped of all Strings, Sigils and code comments.","ref":"Credo.Code.html#clean_charlists_strings_sigils_and_comments/2","title":"Credo.Code.clean_charlists_strings_sigils_and_comments/2","type":"function"},{"doc":"Returns true if the given child AST node is part of the larger parent AST node.","ref":"Credo.Code.html#contains_child?/2","title":"Credo.Code.contains_child?/2","type":"function"},{"doc":"Postwalks a given Credo.SourceFile's AST or a given AST.Technically this is just a wrapper around Macro.postwalk/3.","ref":"Credo.Code.html#postwalk/3","title":"Credo.Code.postwalk/3","type":"function"},{"doc":"Prewalks a given Credo.SourceFile's AST or a given AST.Technically this is just a wrapper around Macro.prewalk/3.","ref":"Credo.Code.html#prewalk/3","title":"Credo.Code.prewalk/3","type":"function"},{"doc":"Returns an AST without its metadata.","ref":"Credo.Code.html#remove_metadata/1","title":"Credo.Code.remove_metadata/1","type":"function"},{"doc":"Converts a String or Credo.SourceFile into a List of tuples of {line_no, line}.","ref":"Credo.Code.html#to_lines/1","title":"Credo.Code.to_lines/1","type":"function"},{"doc":"Converts a String or Credo.SourceFile into a List of tokens using the :elixir_tokenizer.","ref":"Credo.Code.html#to_tokens/1","title":"Credo.Code.to_tokens/1","type":"function"},{"doc":"","ref":"Credo.Code.html#to_tokens/2","title":"Credo.Code.to_tokens/2","type":"function"},{"doc":"This module provides helper functions to analyse blocks, e.g. the block taken by the if macro.","ref":"Credo.Code.Block.html","title":"Credo.Code.Block","type":"module"},{"doc":"Returns true if the given ast has an after block.","ref":"Credo.Code.Block.html#after_block?/1","title":"Credo.Code.Block.after_block?/1","type":"function"},{"doc":"Returns a tuple {:ok, after_block} or nil for a given AST node.","ref":"Credo.Code.Block.html#after_block_for/1","title":"Credo.Code.Block.after_block_for/1","type":"function"},{"doc":"Returns the after: block of a given AST node.","ref":"Credo.Code.Block.html#after_block_for!/1","title":"Credo.Code.Block.after_block_for!/1","type":"function"},{"doc":"Returns the do: block of a given AST node.","ref":"Credo.Code.Block.html#all_blocks_for!/1","title":"Credo.Code.Block.all_blocks_for!/1","type":"function"},{"doc":"Returns the children of the do block of the given AST node.","ref":"Credo.Code.Block.html#calls_in_do_block/1","title":"Credo.Code.Block.calls_in_do_block/1","type":"function"},{"doc":"Returns the children of the rescue block of the given AST node.","ref":"Credo.Code.Block.html#calls_in_rescue_block/1","title":"Credo.Code.Block.calls_in_rescue_block/1","type":"function"},{"doc":"Returns true if the given ast has a do block.","ref":"Credo.Code.Block.html#do_block?/1","title":"Credo.Code.Block.do_block?/1","type":"function"},{"doc":"Returns a tuple {:ok, do_block} or nil for a given AST node.","ref":"Credo.Code.Block.html#do_block_for/1","title":"Credo.Code.Block.do_block_for/1","type":"function"},{"doc":"Returns the do: block of a given AST node.","ref":"Credo.Code.Block.html#do_block_for!/1","title":"Credo.Code.Block.do_block_for!/1","type":"function"},{"doc":"Returns true if the given ast has an else block.","ref":"Credo.Code.Block.html#else_block?/1","title":"Credo.Code.Block.else_block?/1","type":"function"},{"doc":"Returns a tuple {:ok, else_block} or nil for a given AST node.","ref":"Credo.Code.Block.html#else_block_for/1","title":"Credo.Code.Block.else_block_for/1","type":"function"},{"doc":"Returns the else block of a given AST node.","ref":"Credo.Code.Block.html#else_block_for!/1","title":"Credo.Code.Block.else_block_for!/1","type":"function"},{"doc":"Returns true if the given ast has an rescue block.","ref":"Credo.Code.Block.html#rescue_block?/1","title":"Credo.Code.Block.rescue_block?/1","type":"function"},{"doc":"Returns a tuple {:ok, rescue_block} or nil for a given AST node.","ref":"Credo.Code.Block.html#rescue_block_for/1","title":"Credo.Code.Block.rescue_block_for/1","type":"function"},{"doc":"Returns the rescue: block of a given AST node.","ref":"Credo.Code.Block.html#rescue_block_for!/1","title":"Credo.Code.Block.rescue_block_for!/1","type":"function"},{"doc":"This module lets you strip charlists from source code.","ref":"Credo.Code.Charlists.html","title":"Credo.Code.Charlists","type":"module"},{"doc":"Replaces all characters inside charlists with the equivalent amount of white-space.","ref":"Credo.Code.Charlists.html#replace_with_spaces/4","title":"Credo.Code.Charlists.replace_with_spaces/4","type":"function"},{"doc":"This module lets you strip heredocs from source code.","ref":"Credo.Code.Heredocs.html","title":"Credo.Code.Heredocs","type":"module"},{"doc":"Replaces all characters inside heredocs with the equivalent amount of white-space.","ref":"Credo.Code.Heredocs.html#replace_with_spaces/5","title":"Credo.Code.Heredocs.replace_with_spaces/5","type":"function"},{"doc":"This module provides helper functions to analyse modules, return the defined funcions or module attributes.","ref":"Credo.Code.Module.html","title":"Credo.Code.Module","type":"module"},{"doc":"Returns the list of aliases defined in a given module source code.","ref":"Credo.Code.Module.html#aliases/1","title":"Credo.Code.Module.aliases/1","type":"function"},{"doc":"","ref":"Credo.Code.Module.html#analyze/1","title":"Credo.Code.Module.analyze/1","type":"function"},{"doc":"Reads an attribute from a module's ast","ref":"Credo.Code.Module.html#attribute/2","title":"Credo.Code.Module.attribute/2","type":"function"},{"doc":"Returns the arity of the given function definition ast","ref":"Credo.Code.Module.html#def_arity/1","title":"Credo.Code.Module.def_arity/1","type":"function"},{"doc":"Returns the function/macro count for the given module's AST","ref":"Credo.Code.Module.html#def_count/1","title":"Credo.Code.Module.def_count/1","type":"function"},{"doc":"Returns the name of the function/macro defined in the given ast","ref":"Credo.Code.Module.html#def_name/1","title":"Credo.Code.Module.def_name/1","type":"function"},{"doc":"Returns the {fun_name, op} tuple of the function/macro defined in the given ast","ref":"Credo.Code.Module.html#def_name_with_op/1","title":"Credo.Code.Module.def_name_with_op/1","type":"function"},{"doc":"","ref":"Credo.Code.Module.html#def_name_with_op/2","title":"Credo.Code.Module.def_name_with_op/2","type":"function"},{"doc":"Returns the name of the functions/macros for the given module's ast","ref":"Credo.Code.Module.html#def_names/1","title":"Credo.Code.Module.def_names/1","type":"function"},{"doc":"Returns the name of the functions/macros for the given module's ast","ref":"Credo.Code.Module.html#def_names_with_op/1","title":"Credo.Code.Module.def_names_with_op/1","type":"function"},{"doc":"Returns the name of the functions/macros for the given module's ast if it has the given arity.","ref":"Credo.Code.Module.html#def_names_with_op/2","title":"Credo.Code.Module.def_names_with_op/2","type":"function"},{"doc":"","ref":"Credo.Code.Module.html#defs/1","title":"Credo.Code.Module.defs/1","type":"function"},{"doc":"","ref":"Credo.Code.Module.html#exception?/1","title":"Credo.Code.Module.exception?/1","type":"function"},{"doc":"Returns the list of modules used in a given module source code.","ref":"Credo.Code.Module.html#modules/1","title":"Credo.Code.Module.modules/1","type":"function"},{"doc":"Returns the name of a module's given ast node.","ref":"Credo.Code.Module.html#name/1","title":"Credo.Code.Module.name/1","type":"function"},{"doc":"","ref":"Credo.Code.Module.html#t:location/0","title":"Credo.Code.Module.location/0","type":"type"},{"doc":"","ref":"Credo.Code.Module.html#t:module_part/0","title":"Credo.Code.Module.module_part/0","type":"type"},{"doc":"This module provides helper functions to process names of functions, module attributes and modules.","ref":"Credo.Code.Name.html","title":"Credo.Code.Name","type":"module"},{"doc":"","ref":"Credo.Code.Name.html#first/1","title":"Credo.Code.Name.first/1","type":"function"},{"doc":"","ref":"Credo.Code.Name.html#full/1","title":"Credo.Code.Name.full/1","type":"function"},{"doc":"","ref":"Credo.Code.Name.html#last/1","title":"Credo.Code.Name.last/1","type":"function"},{"doc":"","ref":"Credo.Code.Name.html#no_case?/1","title":"Credo.Code.Name.no_case?/1","type":"function"},{"doc":"","ref":"Credo.Code.Name.html#parts_count/1","title":"Credo.Code.Name.parts_count/1","type":"function"},{"doc":"","ref":"Credo.Code.Name.html#pascal_case?/1","title":"Credo.Code.Name.pascal_case?/1","type":"function"},{"doc":"","ref":"Credo.Code.Name.html#snake_case?/1","title":"Credo.Code.Name.snake_case?/1","type":"function"},{"doc":"","ref":"Credo.Code.Name.html#snake_case?/2","title":"Credo.Code.Name.snake_case?/2","type":"function"},{"doc":"","ref":"Credo.Code.Name.html#split_pascal_case/1","title":"Credo.Code.Name.split_pascal_case/1","type":"function"},{"doc":"This module provides helper functions to analyse the parameters taken by a function.","ref":"Credo.Code.Parameters.html","title":"Credo.Code.Parameters","type":"module"},{"doc":"Returns the parameter count for the given function's AST","ref":"Credo.Code.Parameters.html#count/1","title":"Credo.Code.Parameters.count/1","type":"function"},{"doc":"Returns the names of all parameters for the given function's AST","ref":"Credo.Code.Parameters.html#names/1","title":"Credo.Code.Parameters.names/1","type":"function"},{"doc":"This is an internal Issue raised by Credo when it finds itself unable to parse the source code in a file.","ref":"Credo.Code.ParserError.html","title":"Credo.Code.ParserError","type":"module"},{"doc":"This module provides helper functions to determine the scope name at a certain point in the analysed code.","ref":"Credo.Code.Scope.html","title":"Credo.Code.Scope","type":"module"},{"doc":"Returns the module part of a scope.iex&gt; Credo.Code.Scope.mod_name(&quot;Credo.Code&quot;) &quot;Credo.Code&quot; iex&gt; Credo.Code.Scope.mod_name(&quot;Credo.Code.ast&quot;) &quot;Credo.Code&quot;","ref":"Credo.Code.Scope.html#mod_name/1","title":"Credo.Code.Scope.mod_name/1","type":"function"},{"doc":"Returns the scope for the given line as a tuple consisting of the call to define the scope (:defmodule, :def, :defp or :defmacro) and the name of the scope.Examples:{:defmodule, &quot;Foo.Bar&quot;} {:def, &quot;Foo.Bar.baz&quot;}","ref":"Credo.Code.Scope.html#name/2","title":"Credo.Code.Scope.name/2","type":"function"},{"doc":"This module lets you strip sigils from source code.","ref":"Credo.Code.Sigils.html","title":"Credo.Code.Sigils","type":"module"},{"doc":"Replaces all characters inside all sigils with the equivalent amount of white-space.","ref":"Credo.Code.Sigils.html#replace_with_spaces/4","title":"Credo.Code.Sigils.replace_with_spaces/4","type":"function"},{"doc":"This module lets you strip strings from source code.","ref":"Credo.Code.Strings.html","title":"Credo.Code.Strings","type":"module"},{"doc":"Replaces all characters inside string literals and string sigils with the equivalent amount of white-space.","ref":"Credo.Code.Strings.html#replace_with_spaces/4","title":"Credo.Code.Strings.replace_with_spaces/4","type":"function"},{"doc":"This module provides helper functions to analyse tokens returned by Credo.Code.to_tokens/1.","ref":"Credo.Code.Token.html","title":"Credo.Code.Token","type":"module"},{"doc":"Returns true if the given token contains a line break.","ref":"Credo.Code.Token.html#eol?/1","title":"Credo.Code.Token.eol?/1","type":"function"},{"doc":"Returns the position of a token in the form{line_no_start, col_start, line_no_end, col_end}","ref":"Credo.Code.Token.html#position/1","title":"Credo.Code.Token.position/1","type":"function"},{"doc":"","ref":"Credo.Code.TokenAstCorrelation.html","title":"Credo.Code.TokenAstCorrelation","type":"module"},{"doc":"","ref":"Credo.Code.TokenAstCorrelation.html#find_tokens_in_ast/2","title":"Credo.Code.TokenAstCorrelation.find_tokens_in_ast/2","type":"function"},{"doc":"","ref":"Credo.Test.Assertions.html","title":"Credo.Test.Assertions","type":"module"},{"doc":"","ref":"Credo.Test.Assertions.html#assert_issue/2","title":"Credo.Test.Assertions.assert_issue/2","type":"function"},{"doc":"","ref":"Credo.Test.Assertions.html#assert_issues/2","title":"Credo.Test.Assertions.assert_issues/2","type":"function"},{"doc":"","ref":"Credo.Test.Assertions.html#assert_trigger/2","title":"Credo.Test.Assertions.assert_trigger/2","type":"function"},{"doc":"","ref":"Credo.Test.Assertions.html#refute_issues/1","title":"Credo.Test.Assertions.refute_issues/1","type":"function"},{"doc":"","ref":"Credo.Test.Assertions.html#to_inspected/1","title":"Credo.Test.Assertions.to_inspected/1","type":"function"},{"doc":"Conveniences for testing Credo custom checks and plugins.This module can be used in your test cases, like this:use Credo.Test.CaseUsing this module will:import all the functions from this modulemake the test case :async by default (use use Credo.Test.Case, async: false to opt out)Testing custom checksSuppose we have a custom check in our project that checks whether or not the &quot;FooBar rules&quot; are applied (one of those very project-specific things).defmodule MyProject.MyCustomChecks.FooBar do use Credo.Check, category: :warning, base_priority: :high def run(%SourceFile{} = source_file, params) do # ... implement all the &quot;FooBar rules&quot; ... end endWhen we want to test this check, we can use Credo.Test.Case for convenience:defmodule MyProject.MyCustomChecks.FooBarTest do use Credo.Test.Case alias MyProject.MyCustomChecks.FooBar test &quot;it should NOT report expected code&quot; do &quot;&quot;&quot; defmodule CredoSampleModule do # ... some good Elixir code ... end &quot;&quot;&quot; |&gt; to_source_file() |&gt; run_check(FooBar) |&gt; refute_issues() end test &quot;it should report code that violates the FooBar rule&quot; do &quot;&quot;&quot; defmodule CredoSampleModule do # ... some Elixir code that violates the FooBar rule ... end &quot;&quot;&quot; |&gt; to_source_file() |&gt; run_check(FooBar) |&gt; assert_issues() end endThis is as simple and mundane as it looks (which is a good thing): We have two tests: one for the good case, one for the bad case. In each, we create a source file representation from a heredoc, run our custom check and assert/refute the issues we expect.Asserting found issuesOnce we get to know domain a little better, we can add more tests, typically testing for other bad cases in which our check should produce issues.Note that there are two assertion functions for this: assert_issue/2 and assert_issues/2, where the first one ensures that there is a single issue and the second asserts that there are at least two issues.Both functions take an optional callback as their second parameter, which is called with the issue or the list of issues found, which makes it convenient to check for the issues properties ...&quot;&quot;&quot; # ... any Elixir code ... &quot;&quot;&quot; |&gt; to_source_file() |&gt; run_check(FooBar) |&gt; assert_issue(fn issue -&gt; assert issue.trigger == &quot;foo&quot; end)... or properties of the list of issues:&quot;&quot;&quot; # ... any Elixir code ... &quot;&quot;&quot; |&gt; to_source_file() |&gt; run_check(FooBar) |&gt; assert_issue(fn issues -&gt; assert Enum.count(issues) == 3 end)Testing checks that analyse multiple source filesFor checks that analyse multiple source files, like Credo's consistency checks, we can use to_source_files/1 to create[ &quot;&quot;&quot; # source file 1 &quot;&quot;&quot;, &quot;&quot;&quot; # source file 2 &quot;&quot;&quot; ] |&gt; to_source_files() |&gt; run_check(FooBar) |&gt; refute_issues()If our check needs named source files, we can always use to_source_file/2 to create individually named source files and combine them into a list:source_file1 = &quot;&quot;&quot; # source file 1 &quot;&quot;&quot; |&gt; to_source_file(&quot;foo.ex&quot;) source_file2 = &quot;&quot;&quot; # source file 2 &quot;&quot;&quot; |&gt; to_source_file(&quot;bar.ex&quot;) [source_file1, source_file2] |&gt; run_check(FooBar) |&gt; assert_issue(fn issue -&gt; assert issue.filename == &quot;foo.ex&quot; end)","ref":"Credo.Test.Case.html","title":"Credo.Test.Case","type":"module"},{"doc":"Asserts the presence of a single issue.","ref":"Credo.Test.Case.html#assert_issue/2","title":"Credo.Test.Case.assert_issue/2","type":"function"},{"doc":"Asserts the presence of more than one issue.","ref":"Credo.Test.Case.html#assert_issues/2","title":"Credo.Test.Case.assert_issues/2","type":"function"},{"doc":"Refutes the presence of any issues.","ref":"Credo.Test.Case.html#refute_issues/1","title":"Credo.Test.Case.refute_issues/1","type":"function"},{"doc":"Runs the given check on the given source_file using the given params.&quot;x = 5&quot; |&gt; to_source_file() |&gt; run_check(MyProject.MyCheck, foo_parameter: &quot;bar&quot;)","ref":"Credo.Test.Case.html#run_check/3","title":"Credo.Test.Case.run_check/3","type":"function"},{"doc":"Converts the given source string to a %SourceFile{}.&quot;x = 5&quot; |&gt; to_source_file()","ref":"Credo.Test.Case.html#to_source_file/1","title":"Credo.Test.Case.to_source_file/1","type":"function"},{"doc":"Converts the given source string to a %SourceFile{} with the given filename.&quot;x = 5&quot; |&gt; to_source_file(&quot;simple.ex&quot;)","ref":"Credo.Test.Case.html#to_source_file/2","title":"Credo.Test.Case.to_source_file/2","type":"function"},{"doc":"Converts the given list of source code strings to a list of %SourceFile{} structs.[&quot;x = 5&quot;, &quot;y = 6&quot;] |&gt; to_source_files()","ref":"Credo.Test.Case.html#to_source_files/1","title":"Credo.Test.Case.to_source_files/1","type":"function"},{"doc":"","ref":"Credo.Test.CheckRunner.html","title":"Credo.Test.CheckRunner","type":"module"},{"doc":"","ref":"Credo.Test.CheckRunner.html#run_check/3","title":"Credo.Test.CheckRunner.run_check/3","type":"function"},{"doc":"","ref":"Credo.Test.SourceFiles.html","title":"Credo.Test.SourceFiles","type":"module"},{"doc":"","ref":"Credo.Test.SourceFiles.html#to_source_file/1","title":"Credo.Test.SourceFiles.to_source_file/1","type":"function"},{"doc":"","ref":"Credo.Test.SourceFiles.html#to_source_file/2","title":"Credo.Test.SourceFiles.to_source_file/2","type":"function"},{"doc":"","ref":"Credo.Test.SourceFiles.html#to_source_files/1","title":"Credo.Test.SourceFiles.to_source_files/1","type":"function"},{"doc":"ConfigComment structs represent comments which follow control Credo's behaviour.The following comments are supported:# credo:disable-for-this-file # credo:disable-for-next-line # credo:disable-for-previous-line # credo:disable-for-lines:&lt;number&gt;","ref":"Credo.Check.ConfigComment.html","title":"Credo.Check.ConfigComment","type":"module"},{"doc":"Returns true if the given issue should be ignored based on the given config_comment","ref":"Credo.Check.ConfigComment.html#ignores_issue?/2","title":"Credo.Check.ConfigComment.ignores_issue?/2","type":"function"},{"doc":"Returns a ConfigComment struct based on the given parameters.","ref":"Credo.Check.ConfigComment.html#new/3","title":"Credo.Check.ConfigComment.new/3","type":"function"},{"doc":"This module provides functions for handling parameters (&quot;params&quot;) given to checks through .credo.exs (i.e. the Credo.ConfigFile).","ref":"Credo.Check.Params.html","title":"Credo.Check.Params","type":"module"},{"doc":"Returns the given field's params value.Example:defmodule SamepleCheck do def param_defaults do [foo: &quot;bar&quot;] end end iex&gt; Credo.Check.Params.get([], :foo, SamepleCheck) &quot;bar&quot; iex&gt; Credo.Check.Params.get([foo: &quot;baz&quot;], :foo, SamepleCheck) &quot;baz&quot;","ref":"Credo.Check.Params.html#get/3","title":"Credo.Check.Params.get/3","type":"function"},{"doc":"This check has a base priority of normal and works with any version of Elixir.ExplanationFunctions from other modules should be used via an alias if the module's namespace is not top-level.While this is completely fine:defmodule MyApp.Web.Search do def twitter_mentions do MyApp.External.TwitterAPI.search(...) end end... you might want to refactor it to look like this:defmodule MyApp.Web.Search do alias MyApp.External.TwitterAPI def twitter_mentions do TwitterAPI.search(...) end endThe thinking behind this is that you can see the dependencies of your module at a glance. So if you are attempting to build a medium to large project, this can help you to get your boundaries/layers/contracts right.As always: This is just a suggestion. Check the configuration options for tweaking or disabling this check.Configuration parametersUse the following parameters to configure this check:excluded_namespaces: List of namespaces to be excluded for this check. Defaults to [&quot;File&quot;, &quot;IO&quot;, &quot;Inspect&quot;, &quot;Kernel&quot;, &quot;Macro&quot;, &quot;Supervisor&quot;, &quot;Task&quot;, &quot;Version&quot;]excluded_lastnames: List of lastnames to be excluded for this check. Defaults to [&quot;Access&quot;, &quot;Agent&quot;, &quot;Application&quot;, &quot;Atom&quot;, &quot;Base&quot;, &quot;Behaviour&quot;, &quot;Bitwise&quot;, &quot;Code&quot;, &quot;Date&quot;, &quot;DateTime&quot;, &quot;Dict&quot;, &quot;Enum&quot;, &quot;Exception&quot;, &quot;File&quot;, &quot;Float&quot;, &quot;GenEvent&quot;, &quot;GenServer&quot;, &quot;HashDict&quot;, &quot;HashSet&quot;, &quot;Integer&quot;, &quot;IO&quot;, &quot;Kernel&quot;, &quot;Keyword&quot;, &quot;List&quot;, &quot;Macro&quot;, &quot;Map&quot;, &quot;MapSet&quot;, &quot;Module&quot;, &quot;NaiveDateTime&quot;, &quot;Node&quot;, &quot;OptionParser&quot;, &quot;Path&quot;, &quot;Port&quot;, &quot;Process&quot;, &quot;Protocol&quot;, &quot;Range&quot;, &quot;Record&quot;, &quot;Regex&quot;, &quot;Registry&quot;, &quot;Set&quot;, &quot;Stream&quot;, &quot;String&quot;, &quot;StringIO&quot;, &quot;Supervisor&quot;, &quot;System&quot;, &quot;Task&quot;, &quot;Time&quot;, &quot;Tuple&quot;, &quot;URI&quot;, &quot;Version&quot;]if_nested_deeper_than: Only raise an issue if a module is nested deeper than this. Defaults to 0if_called_more_often_than: Only raise an issue if a module is called more often than this. Defaults to 0Parameters can be configured via the .credo.exs config file.","ref":"Credo.Check.Design.AliasUsage.html","title":"Credo.Check.Design.AliasUsage","type":"module"},{"doc":"","ref":"Credo.Check.Design.AliasUsage.html#do_run_on_source_file/3","title":"Credo.Check.Design.AliasUsage.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of higher and works with any version of Elixir.ExplanationCode should not be copy-pasted in a codebase when there is room to abstract the copied functionality in a meaningful way.That said, you should by no means &quot;ABSTRACT ALL THE THINGS!&quot;.Sometimes it can serve a purpose to have code be explicit in two places, even if it means the snippets are nearly identical. A good example for this are Database Adapters in a project like Ecto, where you might have nearly identical functions for things like order_by or limit in both the Postgres and MySQL adapters.In this case, introducing an AbstractAdapter just to avoid code duplication might cause more trouble down the line than having a bit of duplicated code.Like all Software Design issues, this is just advice and might not be applicable to your project/situation.Configuration parametersUse the following parameters to configure this check:mass_threshold: The minimum mass which a part of code has to have to qualify for this check. Defaults to 40nodes_threshold: The number of nodes that need to be found to raise an issue. Defaults to 2excluded_macros: List of macros to be excluded for this check. Defaults to []Parameters can be configured via the .credo.exs config file.","ref":"Credo.Check.Design.DuplicatedCode.html","title":"Credo.Check.Design.DuplicatedCode","type":"module"},{"doc":"","ref":"Credo.Check.Design.DuplicatedCode.html#add_masses/1","title":"Credo.Check.Design.DuplicatedCode.add_masses/1","type":"function"},{"doc":"Calculates hash values for all sub nodes in a given +ast+.Returns a map with the hashes as keys and the nodes as values.","ref":"Credo.Check.Design.DuplicatedCode.html#calculate_hashes/4","title":"Credo.Check.Design.DuplicatedCode.calculate_hashes/4","type":"function"},{"doc":"","ref":"Credo.Check.Design.DuplicatedCode.html#create_issue?/2","title":"Credo.Check.Design.DuplicatedCode.create_issue?/2","type":"function"},{"doc":"","ref":"Credo.Check.Design.DuplicatedCode.html#do_run_on_source_file/3","title":"Credo.Check.Design.DuplicatedCode.do_run_on_source_file/3","type":"function"},{"doc":"","ref":"Credo.Check.Design.DuplicatedCode.html#line_no_for/1","title":"Credo.Check.Design.DuplicatedCode.line_no_for/1","type":"function"},{"doc":"Returns the mass (count of instructions) for an AST.","ref":"Credo.Check.Design.DuplicatedCode.html#mass/1","title":"Credo.Check.Design.DuplicatedCode.mass/1","type":"function"},{"doc":"Takes a map of hashes to nodes and prunes those nodes that are just subnodes of others in the same set.Returns the resulting map.","ref":"Credo.Check.Design.DuplicatedCode.html#prune_hashes/2","title":"Credo.Check.Design.DuplicatedCode.prune_hashes/2","type":"function"},{"doc":"Returns a hash-value for a given +ast+.","ref":"Credo.Check.Design.DuplicatedCode.html#to_hash/1","title":"Credo.Check.Design.DuplicatedCode.to_hash/1","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationFIXME comments are used to indicate places where source code needs fixing.Example:# FIXME: this does no longer work, research new API url defp fun do # ... endThe premise here is that FIXME should indeed be fixed as soon as possible and are therefore reported by Credo.Like all Software Design issues, this is just advice and might not be applicable to your project/situation.Configuration parametersUse the following parameters to configure this check:include_doc: Set to true to also include tags from @doc attributes. Defaults to trueParameters can be configured via the .credo.exs config file.","ref":"Credo.Check.Design.TagFIXME.html","title":"Credo.Check.Design.TagFIXME","type":"module"},{"doc":"","ref":"Credo.Check.Design.TagFIXME.html#do_run_on_source_file/3","title":"Credo.Check.Design.TagFIXME.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of 0 and works with any version of Elixir.ExplanationTODO comments are used to remind yourself of source code related things.Example:# TODO: move this to a Helper module defp fun do # ... endThe premise here is that TODO should be dealt with in the near future and are therefore reported by Credo.Like all Software Design issues, this is just advice and might not be applicable to your project/situation.Configuration parametersUse the following parameters to configure this check:include_doc: Set to true to also include tags from @doc attributes. Defaults to trueParameters can be configured via the .credo.exs config file.","ref":"Credo.Check.Design.TagTODO.html","title":"Credo.Check.Design.TagTODO","type":"module"},{"doc":"","ref":"Credo.Check.Design.TagTODO.html#do_run_on_source_file/3","title":"Credo.Check.Design.TagTODO.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of low and works with any version of Elixir.ExplanationAliases which are not completely renamed using the :as option are easier to follow.# preferred def MyModule do alias MyApp.Module1 def my_function(foo) do Module1.run(foo) end end # NOT preferred def MyModule do alias MyApp.Module1, as: M1 def my_function(foo) do # what the heck is `M1`? M1.run(foo) end endLike all Readability issues, this one is not a technical concern. But you can improve the odds of others reading and liking your code by making it easier to follow.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Readability.AliasAs.html","title":"Credo.Check.Readability.AliasAs","type":"module"},{"doc":"","ref":"Credo.Check.Readability.AliasAs.html#do_run_on_source_file/3","title":"Credo.Check.Readability.AliasAs.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of low and works with any version of Elixir.ExplanationAlphabetically ordered lists are more easily scannable by the read.# preferred alias ModuleA alias ModuleB alias ModuleC # NOT preferred alias ModuleA alias ModuleC alias ModuleBAlias should be alphabetically ordered among their group:# preferred alias ModuleC alias ModuleD alias ModuleA alias ModuleB # NOT preferred alias ModuleC alias ModuleD alias ModuleB alias ModuleALike all Readability issues, this one is not a technical concern. But you can improve the odds of others reading and liking your code by making it easier to follow.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Readability.AliasOrder.html","title":"Credo.Check.Readability.AliasOrder","type":"module"},{"doc":"","ref":"Credo.Check.Readability.AliasOrder.html#do_run_on_source_file/3","title":"Credo.Check.Readability.AliasOrder.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationPipes (|&gt;) should not be used with blocks.The code in this example ...list |&gt; Enum.take(5) |&gt; Enum.sort() |&gt; case do [[_h|_t]|_] -&gt; true _ -&gt; false end... should be refactored to look like this:maybe_nested_lists = list |&gt; Enum.take(5) |&gt; Enum.sort() case maybe_nested_lists do [[_h|_t]|_] = true _-&gt; false end... or create a new functionlist |&gt; Enum.take(5) |&gt; Enum.sort() |&gt; contains_nested_list?()Piping to blocks may be harder to read because it can be said that it obscures intentions and increases cognitive load on the reader. Instead, prefer introducing variables to your code or new functions when it may be a sign that your function is getting too complicated and/or has too many concerns.Like all Readability issues, this one is not a technical concern, but you can improve the odds of others reading and understanding the intent of your code by making it easier to follow.Configuration parametersUse the following parameters to configure this check:exclude: Do not raise an issue for these macros and functions. Defaults to []Parameters can be configured via the .credo.exs config file.","ref":"Credo.Check.Readability.BlockPipe.html","title":"Credo.Check.Readability.BlockPipe","type":"module"},{"doc":"","ref":"Credo.Check.Readability.BlockPipe.html#do_run_on_source_file/3","title":"Credo.Check.Readability.BlockPipe.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationFunction, macro, and guard names are always written in snake_case in Elixir.# snake_case def handle_incoming_message(message) do end # not snake_case def handleIncomingMessage(message) do endLike all Readability issues, this one is not a technical concern. But you can improve the odds of others reading and liking your code by making it easier to follow.Configuration parametersUse the following parameters to configure this check:allow_acronyms: Allows acronyms like HTTP or OTP in function names. Defaults to falseParameters can be configured via the .credo.exs config file.","ref":"Credo.Check.Readability.FunctionNames.html","title":"Credo.Check.Readability.FunctionNames","type":"module"},{"doc":"","ref":"Credo.Check.Readability.FunctionNames.html#do_run_on_source_file/3","title":"Credo.Check.Readability.FunctionNames.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of normal and works with any version of Elixir.ExplanationWhen implementing behaviour callbacks, @impl true indicates that a function implements a callback, but a better way is to note the actual behaviour being implemented, for example @impl MyBehaviour. This not only improves readability, but adds extra validation in cases where multiple behaviours are implemented in a single module.Instead of:@impl true def my_funcion() do ...use:@impl MyBehaviour def my_funcion() do ...Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Readability.ImplTrue.html","title":"Credo.Check.Readability.ImplTrue","type":"module"},{"doc":"","ref":"Credo.Check.Readability.ImplTrue.html#do_run_on_source_file/3","title":"Credo.Check.Readability.ImplTrue.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationNumbers can contain underscores for readability purposes. These do not affect the value of the number, but can help read large numbers more easily.141592654 # how large is this number? 141_592_654 # ah, it&#39;s in the hundreds of millions!Like all Readability issues, this one is not a technical concern. But you can improve the odds of others reading and liking your code by making it easier to follow.Configuration parametersUse the following parameters to configure this check:only_greater_than: The check only reports numbers greater than this. Defaults to 9999Parameters can be configured via the .credo.exs config file.","ref":"Credo.Check.Readability.LargeNumbers.html","title":"Credo.Check.Readability.LargeNumbers","type":"module"},{"doc":"","ref":"Credo.Check.Readability.LargeNumbers.html#do_run_on_source_file/3","title":"Credo.Check.Readability.LargeNumbers.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of low and works with any version of Elixir.ExplanationChecks for the length of lines.Ignores function definitions and (multi-)line strings by default.Configuration parametersUse the following parameters to configure this check:max_length: The maximum number of characters a line may consist of. Defaults to 120ignore_definitions: Set to true to ignore lines including function definitions. Defaults to trueignore_specs: Set to true to ignore lines including @specs. Defaults to falseignore_strings: Set to true to ignore lines that are strings or in heredocs. Defaults to trueignore_urls: Set to true to ignore lines that contain urls. Defaults to trueParameters can be configured via the .credo.exs config file.","ref":"Credo.Check.Readability.MaxLineLength.html","title":"Credo.Check.Readability.MaxLineLength","type":"module"},{"doc":"","ref":"Credo.Check.Readability.MaxLineLength.html#do_run_on_source_file/3","title":"Credo.Check.Readability.MaxLineLength.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationModule attribute names are always written in snake_case in Elixir.snake_case@inbox_name &quot;incoming&quot;not snake_case@inboxName &quot;incoming&quot;Like all Readability issues, this one is not a technical concern. But you can improve the odds of others reading and liking your code by making it easier to follow.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Readability.ModuleAttributeNames.html","title":"Credo.Check.Readability.ModuleAttributeNames","type":"module"},{"doc":"","ref":"Credo.Check.Readability.ModuleAttributeNames.html#do_run_on_source_file/3","title":"Credo.Check.Readability.ModuleAttributeNames.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of 0 and works with any version of Elixir.ExplanationEvery module should contain comprehensive documentation.# preferred defmodule MyApp.Web.Search do @moduledoc &quot;&quot;&quot; This module provides a public API for all search queries originating in the web layer. &quot;&quot;&quot; end # also okay: explicitly say there is no documentation defmodule MyApp.Web.Search do @moduledoc false endMany times a sentence or two in plain english, explaining why the module exists, will suffice. Documenting your train of thought this way will help both your co-workers and your future-self.Other times you will want to elaborate even further and show some examples of how the module's functions can and should be used.In some cases however, you might not want to document things about a module, e.g. it is part of a private API inside your project. Since Elixir prefers explicitness over implicit behaviour, you should &quot;tag&quot; these modules with@moduledoc falseto make it clear that there is no intention in documenting it.Configuration parametersUse the following parameters to configure this check:ignore_names: All modules matching this regex (or list of regexes) will be ignored. Defaults to [~r/(\\\\.\\\\w+Controller|\\\\.Endpoint|\\\\.Repo|\\\\.Router|\\\\.\\\\w+Socket|\\\\.\\\\w+View)$/]Parameters can be configured via the .credo.exs config file.","ref":"Credo.Check.Readability.ModuleDoc.html","title":"Credo.Check.Readability.ModuleDoc","type":"module"},{"doc":"","ref":"Credo.Check.Readability.ModuleDoc.html#do_run_on_source_file/3","title":"Credo.Check.Readability.ModuleDoc.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationModule names are always written in PascalCase in Elixir.# PascalCase defmodule MyApp.WebSearchController do # ... end # not PascalCase defmodule MyApp.Web_searchController do # ... endLike all Readability issues, this one is not a technical concern. But you can improve the odds of other reading and liking your code by making it easier to follow.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Readability.ModuleNames.html","title":"Credo.Check.Readability.ModuleNames","type":"module"},{"doc":"","ref":"Credo.Check.Readability.ModuleNames.html#do_run_on_source_file/3","title":"Credo.Check.Readability.ModuleNames.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of low and works with any version of Elixir.ExplanationMulti alias expansion makes module uses harder to search for in large code bases.# preferred alias Module.Foo alias Module.Bar # NOT preferred alias Module.{Foo, Bar}Like all Readability issues, this one is not a technical concern. But you can improve the odds of others reading and liking your code by making it easier to follow.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Readability.MultiAlias.html","title":"Credo.Check.Readability.MultiAlias","type":"module"},{"doc":"","ref":"Credo.Check.Readability.MultiAlias.html#do_run_on_source_file/3","title":"Credo.Check.Readability.MultiAlias.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationBecause if and unless are macros, the preferred style is to not use parentheses around conditions.# preferred if valid?(username) do # ... end # NOT preferred if( valid?(username) ) do # ... endLike all Readability issues, this one is not a technical concern. But you can improve the odds of others reading and liking your code by making it easier to follow.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Readability.ParenthesesInCondition.html","title":"Credo.Check.Readability.ParenthesesInCondition","type":"module"},{"doc":"","ref":"Credo.Check.Readability.ParenthesesInCondition.html#do_run_on_source_file/3","title":"Credo.Check.Readability.ParenthesesInCondition.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of low and works with any version of Elixir.ExplanationEither use parentheses or not when defining a function with no arguments.By default, this check enforces no parentheses, so zero-arity function and macro definitions should look like this:def summer? do # ... endIf the :parens param is set to true for this check, then the check enforces zero-arity function and macro definitions to have parens:def summer?() do # ... endLike all Readability issues, this one is not a technical concern. But you can improve the odds of others reading and liking your code by making it easier to follow.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Readability.ParenthesesOnZeroArityDefs.html","title":"Credo.Check.Readability.ParenthesesOnZeroArityDefs","type":"module"},{"doc":"","ref":"Credo.Check.Readability.ParenthesesOnZeroArityDefs.html#do_run_on_source_file/3","title":"Credo.Check.Readability.ParenthesesOnZeroArityDefs.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationPredicate functions/macros should be named accordingly:For functions, they should end in a question mark. # preferred defp user?(cookie) do end defp has_attachment?(mail) do end # NOT preferred defp is_user?(cookie) do end defp is_user(cookie) do endFor guard-safe macros they should have the prefix is_ and not end in a question mark. # preferred defmacro is_user(cookie) do end # NOT preferred defmacro is_user?(cookie) do end defmacro user?(cookie) do endLike all Readability issues, this one is not a technical concern. But you can improve the odds of others reading and liking your code by making it easier to follow.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Readability.PredicateFunctionNames.html","title":"Credo.Check.Readability.PredicateFunctionNames","type":"module"},{"doc":"","ref":"Credo.Check.Readability.PredicateFunctionNames.html#do_run_on_source_file/3","title":"Credo.Check.Readability.PredicateFunctionNames.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of low and works with any version of Elixir.ExplanationPrefer using an implicit try rather than explicit try if you try to rescue anything the function does.For example, this:def failing_function(first) do try do to_string(first) rescue _ -&gt; :rescued end endCan be rewritten without try as below:def failing_function(first) do to_string(first) rescue _ -&gt; :rescued endLike all Readability issues, this one is not a technical concern. The code will behave identical in both ways.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Readability.PreferImplicitTry.html","title":"Credo.Check.Readability.PreferImplicitTry","type":"module"},{"doc":"","ref":"Credo.Check.Readability.PreferImplicitTry.html#do_run_on_source_file/3","title":"Credo.Check.Readability.PreferImplicitTry.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and requires Elixir &lt; 1.7.0-dev.ExplanationPrefer unquoted atoms unless quotes are necessary. This is helpful because a quoted atom can be easily mistaken for a string.# prefered :x [x: 1] %{x: 1} # NOT preferred :&quot;x&quot; [&quot;x&quot;: 1] %{&quot;x&quot;: 1}The primary case where this can become an issue is when using atoms or strings for keys in a Map or Keyword list.For example, this:%{&quot;x&quot;: 1}Can easily be mistaken for this:%{&quot;x&quot; =&gt; 1}Because a string key cannot be used to access a value with the equivalent atom key, this can lead to subtle bugs which are hard to discover.Like all Readability issues, this one is not a technical concern. The code will behave identical in both ways.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Readability.PreferUnquotedAtoms.html","title":"Credo.Check.Readability.PreferUnquotedAtoms","type":"module"},{"doc":"","ref":"Credo.Check.Readability.PreferUnquotedAtoms.html#do_run_on_source_file/3","title":"Credo.Check.Readability.PreferUnquotedAtoms.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of low and works with any version of Elixir.ExplanationFiles should not have two or more consecutive blank lines.Like all Readability issues, this one is not a technical concern. But you can improve the odds of others reading and liking your code by making it easier to follow.Configuration parametersUse the following parameters to configure this check:max_blank_lines: The maximum number of tolerated consecutive blank lines. Defaults to 1Parameters can be configured via the .credo.exs config file.","ref":"Credo.Check.Readability.RedundantBlankLines.html","title":"Credo.Check.Readability.RedundantBlankLines","type":"module"},{"doc":"","ref":"Credo.Check.Readability.RedundantBlankLines.html#do_run_on_source_file/3","title":"Credo.Check.Readability.RedundantBlankLines.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationDon't use ; to separate statements and expressions. Statements and expressions should be separated by lines.# preferred a = 1 b = 2 # NOT preferred a = 1; b = 2Like all Readability issues, this one is not a technical concern. But you can improve the odds of others reading and liking your code by making it easier to follow.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Readability.Semicolons.html","title":"Credo.Check.Readability.Semicolons","type":"module"},{"doc":"","ref":"Credo.Check.Readability.Semicolons.html#do_run_on_source_file/3","title":"Credo.Check.Readability.Semicolons.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of low and works with any version of Elixir.ExplanationAll instances of alias should be consecutive within a file. Likewise, all instances of require should be consecutive within a file.For example:defmodule Foo do require Logger alias Foo.Bar alias Foo.Baz require Integer # ... endshould be changed to:defmodule Foo do require Integer require Logger alias Foo.Bar alias Foo.Baz # ... endLike all Readability issues, this one is not a technical concern. But you can improve the odds of others reading and liking your code by making it easier to follow.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Readability.SeparateAliasRequire.html","title":"Credo.Check.Readability.SeparateAliasRequire","type":"module"},{"doc":"","ref":"Credo.Check.Readability.SeparateAliasRequire.html#do_run_on_source_file/3","title":"Credo.Check.Readability.SeparateAliasRequire.do_run_on_source_file/3","type":"function"},{"doc":"","ref":"Credo.Check.Readability.SeparateAliasRequire.html#message/1","title":"Credo.Check.Readability.SeparateAliasRequire.message/1","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationPipes (|&gt;) should only be used when piping data through multiple calls.So while this is fine:list |&gt; Enum.take(5) |&gt; Enum.shuffle |&gt; evaluate()The code in this example ...list |&gt; evaluate()... should be refactored to look like this:evaluate(list)Using a single |&gt; to invoke functions makes the code harder to read. Instead, write a function call when a pipeline is only one function long.Like all Readability issues, this one is not a technical concern. But you can improve the odds of others reading and liking your code by making it easier to follow.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Readability.SinglePipe.html","title":"Credo.Check.Readability.SinglePipe","type":"module"},{"doc":"","ref":"Credo.Check.Readability.SinglePipe.html#do_run_on_source_file/3","title":"Credo.Check.Readability.SinglePipe.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of 0 and works with any version of Elixir.ExplanationYou can use white-space after commas to make items of lists, tuples and other enumerations easier to separate from one another.# preferred alias Project.{Alpha, Beta} def some_func(first, second, third) do list = [1, 2, 3, 4, 5] # ... end # NOT preferred - items are harder to separate alias Project.{Alpha,Beta} def some_func(first,second,third) do list = [1,2,3,4,5] # ... endLike all Readability issues, this one is not a technical concern. But you can improve the odds of others reading and liking your code by making it easier to follow.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Readability.SpaceAfterCommas.html","title":"Credo.Check.Readability.SpaceAfterCommas","type":"module"},{"doc":"","ref":"Credo.Check.Readability.SpaceAfterCommas.html#do_run_on_source_file/3","title":"Credo.Check.Readability.SpaceAfterCommas.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of 0 and works with any version of Elixir.ExplanationFunctions, callbacks and macros need typespecs.Adding typespecs gives tools like Dialyzer more information when performing checks for type errors in function calls and definitions.@spec add(integer, integer) :: integer def add(a, b), do: a + bFunctions with multiple arities need to have a spec defined for each arity:@spec foo(integer) :: boolean @spec foo(integer, integer) :: boolean def foo(a), do: a &gt; 0 def foo(a, b), do: a &gt; bThe check only considers whether the specification is present, it doesn't perform any actual type checking.Like all Readability issues, this one is not a technical concern. But you can improve the odds of others reading and liking your code by making it easier to follow.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Readability.Specs.html","title":"Credo.Check.Readability.Specs","type":"module"},{"doc":"","ref":"Credo.Check.Readability.Specs.html#do_run_on_source_file/3","title":"Credo.Check.Readability.Specs.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of low and works with any version of Elixir.ExplanationProvide module parts in a required order.# preferred defmodule MyMod do @moduledoc &quot;moduledoc&quot; use Foo import Bar alias Baz require Qux endLike all Readability issues, this one is not a technical concern. But you can improve the odds of others reading and liking your code by making it easier to follow.Configuration parametersUse the following parameters to configure this check:order: List of atoms identifying the desired order of module parts.Supported values are::moduledoc - @moduledoc module attribute:shortdoc - @shortdoc module attribute:behaviour - @behaviour module attribute:use - use expression:import - import expression:alias - alias expression:require - require expression:defstruct - defstruct expression:opaque - @opaque module attribute:type - @type module attribute:typep - @typep module attribute:callback - @callback module attribute:macrocallback - @macrocallback module attribute:optional_callbacks - @optional_callbacks module attribute:module_attribute - other module attribute:public_fun - public function:private_fun - private function or a public function marked with @doc false:public_macro - public macro:private_macro - private macro or a public macro marked with @doc false:callback_impl - public function or macro marked with @impl:public_guard - public guard:private_guard - private guard or a public guard marked with @doc false:module - inner module definition (defmodule expression inside a module) Notice that the desired order always starts from the top. For example, if you provide the order ~w/public_fun private_fun/a, it means that everything else (e.g. @moduledoc) must appear after function definitions. Defaults to [:shortdoc, :moduledoc, :behaviour, :use, :import, :alias, :require]ignore: List of atoms identifying the module parts which are not checked, and may therefore appear anywhere in the module. Supported values are the same as in the :order param. Defaults to []Parameters can be configured via the .credo.exs config file.","ref":"Credo.Check.Readability.StrictModuleLayout.html","title":"Credo.Check.Readability.StrictModuleLayout","type":"module"},{"doc":"","ref":"Credo.Check.Readability.StrictModuleLayout.html#do_run_on_source_file/3","title":"Credo.Check.Readability.StrictModuleLayout.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of low and works with any version of Elixir.ExplanationIf you used quoted strings that contain quotes, you might want to consider switching to the use of sigils instead.# okay &quot;&lt;a href=\\&quot;http://elixirweekly.net\\&quot;&gt;#\\{text}&lt;/a&gt;&quot; # not okay, lots of escaped quotes &quot;&lt;a href=\\&quot;http://elixirweekly.net\\&quot; target=\\&quot;_blank\\&quot;&gt;#\\{text}&lt;/a&gt;&quot; # refactor to ~S(&lt;a href=&quot;http://elixirweekly.net&quot; target=&quot;_blank&quot;&gt;#\\{text}&lt;/a&gt;)This allows us to remove the noise which results from the need to escape quotes within quotes.Like all Readability issues, this one is not a technical concern. But you can improve the odds of others reading and liking your code by making it easier to follow.Configuration parametersUse the following parameters to configure this check:maximum_allowed_quotes: The maximum amount of escaped quotes you want to tolerate. Defaults to 3Parameters can be configured via the .credo.exs config file.","ref":"Credo.Check.Readability.StringSigils.html","title":"Credo.Check.Readability.StringSigils","type":"module"},{"doc":"","ref":"Credo.Check.Readability.StringSigils.html#do_run_on_source_file/3","title":"Credo.Check.Readability.StringSigils.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of low and works with any version of Elixir.ExplanationFiles should end in a trailing blank line.This is mostly for historical reasons: every text file should end with a \\n, or newline since this acts as eol or the end of the line character.See also: http://pubs.opengroup.org/onlinepubs/9699919799/basedefs/V1_chap03.html#tag_03_206Most text editors ensure this &quot;final newline&quot; automatically.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Readability.TrailingBlankLine.html","title":"Credo.Check.Readability.TrailingBlankLine","type":"module"},{"doc":"","ref":"Credo.Check.Readability.TrailingBlankLine.html#do_run_on_source_file/3","title":"Credo.Check.Readability.TrailingBlankLine.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of low and works with any version of Elixir.ExplanationThere should be no white-space (i.e. tabs, spaces) at the end of a line.Most text editors provide a way to remove them automatically.Configuration parametersUse the following parameters to configure this check:ignore_strings: Set to false to check lines that are strings or in heredocs Defaults to trueParameters can be configured via the .credo.exs config file.","ref":"Credo.Check.Readability.TrailingWhiteSpace.html","title":"Credo.Check.Readability.TrailingWhiteSpace","type":"module"},{"doc":"","ref":"Credo.Check.Readability.TrailingWhiteSpace.html#do_run_on_source_file/3","title":"Credo.Check.Readability.TrailingWhiteSpace.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of low and works with any version of Elixir.ExplanationAlias expansion is useful but when aliasing a single module, it can be harder to read with unnecessary braces.# preferred alias ModuleA.Foo alias ModuleA.{Foo, Bar} # NOT preferred alias ModuleA.{Foo}Like all Readability issues, this one is not a technical concern. But you can improve the odds of others reading and liking your code by making it easier to follow.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Readability.UnnecessaryAliasExpansion.html","title":"Credo.Check.Readability.UnnecessaryAliasExpansion","type":"module"},{"doc":"","ref":"Credo.Check.Readability.UnnecessaryAliasExpansion.html#do_run_on_source_file/3","title":"Credo.Check.Readability.UnnecessaryAliasExpansion.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationVariable names are always written in snake_case in Elixir.# snake_case: incoming_result = handle_incoming_message(message) # not snake_case incomingResult = handle_incoming_message(message)Like all Readability issues, this one is not a technical concern. But you can improve the odds of others reading and liking your code by making it easier to follow.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Readability.VariableNames.html","title":"Credo.Check.Readability.VariableNames","type":"module"},{"doc":"","ref":"Credo.Check.Readability.VariableNames.html#do_run_on_source_file/3","title":"Credo.Check.Readability.VariableNames.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of low and works with any version of Elixir.ExplanationAvoid using custom tags for error reporting from with macros.This code injects placeholder tags such as :resource and :authz for the purpose of error reporting.with {:resource, {:ok, resource}} &lt;- {:resource, Resource.fetch(user)}, {:authz, :ok} &lt;- {:authz, Resource.authorize(resource, user)} do do_something_with(resource) else {:resource, _} -&gt; {:error, :not_found} {:authz, _} -&gt; {:error, :unauthorized} endInstead, extract each validation into a separate helper function which returns error information immediately:defp find_resource(user) do with :error &lt;- Resource.fetch(user), do: {:error, :not_found} end defp authorize(resource, user) do with :error &lt;- Resource.authorize(resource, user), do: {:error, :unauthorized} endAt this point, the validation chain in with becomes clearer and easier to understand:with {:ok, resource} &lt;- find_resource(user), :ok &lt;- authorize(resource, user), do: do_something(user)Like all Readability issues, this one is not a technical concern. But you can improve the odds of others reading and liking your code by making it easier to follow.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Readability.WithCustomTaggedTuple.html","title":"Credo.Check.Readability.WithCustomTaggedTuple","type":"module"},{"doc":"","ref":"Credo.Check.Readability.WithCustomTaggedTuple.html#do_run_on_source_file/3","title":"Credo.Check.Readability.WithCustomTaggedTuple.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of 0 and works with any version of Elixir.ExplanationThe ABC size describes a metric based on assignments, branches and conditions.A high ABC size is a hint that a function might be doing &quot;more&quot; than it should.As always: Take any metric with a grain of salt. Since this one was originally introduced for C, C++ and Java, we still have to see whether or not this can be a useful metric in a declarative language like Elixir.Configuration parametersUse the following parameters to configure this check:max_size: The maximum ABC size a function should have. Defaults to 30excluded_functions: All functions listed will be ignored. Defaults to []Parameters can be configured via the .credo.exs config file.","ref":"Credo.Check.Refactor.ABCSize.html","title":"Credo.Check.Refactor.ABCSize","type":"module"},{"doc":"Returns the ABC size for the block inside the given AST, which is expected to represent a function or macro definition.iex&gt; {:def, [line: 1], ...&gt; [ ...&gt; {:first_fun, [line: 1], nil}, ...&gt; [do: {:=, [line: 2], [{:x, [line: 2], nil}, 1]}] ...&gt; ] ...&gt; } |&gt; Credo.Check.Refactor.ABCSize.abc_size 1.0","ref":"Credo.Check.Refactor.ABCSize.html#abc_size_for/2","title":"Credo.Check.Refactor.ABCSize.abc_size_for/2","type":"function"},{"doc":"","ref":"Credo.Check.Refactor.ABCSize.html#do_run_on_source_file/3","title":"Credo.Check.Refactor.ABCSize.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of low and works with any version of Elixir.ExplanationWhen building up large lists, it is faster to prepend than append. Therefore: It is sometimes best to prepend to the list during iteration and call Enum.reverse/1 at the end, as it is quite fast.Example:list = list_so_far ++ [new_item] # refactoring it like this can make the code faster: list = [new_item] ++ list_so_far # ... Enum.reverse(list)Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Refactor.AppendSingleItem.html","title":"Credo.Check.Refactor.AppendSingleItem","type":"module"},{"doc":"","ref":"Credo.Check.Refactor.AppendSingleItem.html#do_run_on_source_file/3","title":"Credo.Check.Refactor.AppendSingleItem.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of 0 and works with any version of Elixir.ExplanationPLEASE NOTE: This check is deprecated as it might do more harm than good.Related discussion: https://github.com/rrrene/credo/issues/65Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Refactor.CaseTrivialMatches.html","title":"Credo.Check.Refactor.CaseTrivialMatches","type":"module"},{"doc":"","ref":"Credo.Check.Refactor.CaseTrivialMatches.html#do_run_on_source_file/3","title":"Credo.Check.Refactor.CaseTrivialMatches.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of 0 and works with any version of Elixir.ExplanationEach cond statement should have 3 or more statements including the &quot;always true&quot; statement.Consider an if/else construct if there is only one condition and the &quot;always true&quot; statement, since it will more accessible to programmers new to the codebase (and possibly new to Elixir).Example:cond do x == y -&gt; 0 true -&gt; 1 end # should be written as if x == y do 0 else 1 endConfiguration parametersThere are no parameters for this check.","ref":"Credo.Check.Refactor.CondStatements.html","title":"Credo.Check.Refactor.CondStatements","type":"module"},{"doc":"","ref":"Credo.Check.Refactor.CondStatements.html#do_run_on_source_file/3","title":"Credo.Check.Refactor.CondStatements.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of 0 and works with any version of Elixir.ExplanationCyclomatic complexity is a software complexity metric closely correlated with coding errors.If a function feels like it's gotten too complex, it more often than not also has a high CC value. So, if anything, this is useful to convince team members and bosses of a need to refactor parts of the code based on &quot;objective&quot; metrics.Configuration parametersUse the following parameters to configure this check:max_complexity: The maximum cyclomatic complexity a function should have. Defaults to 9Parameters can be configured via the .credo.exs config file.","ref":"Credo.Check.Refactor.CyclomaticComplexity.html","title":"Credo.Check.Refactor.CyclomaticComplexity","type":"module"},{"doc":"Returns the Cyclomatic Complexity score for the block inside the given AST, which is expected to represent a function or macro definition.iex&gt; {:def, [line: 1], ...&gt; [ ...&gt; {:first_fun, [line: 1], nil}, ...&gt; [do: {:=, [line: 2], [{:x, [line: 2], nil}, 1]}] ...&gt; ] ...&gt; } |&gt; Credo.Check.Refactor.CyclomaticComplexity.complexity_for 1.0","ref":"Credo.Check.Refactor.CyclomaticComplexity.html#complexity_for/1","title":"Credo.Check.Refactor.CyclomaticComplexity.complexity_for/1","type":"function"},{"doc":"","ref":"Credo.Check.Refactor.CyclomaticComplexity.html#do_run_on_source_file/3","title":"Credo.Check.Refactor.CyclomaticComplexity.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of low and works with any version of Elixir.ExplanationHaving double negations in your code can obscure the parameter's original value.# NOT preferred !!varThis will return false for false and nil, and true for anything else.At first this seems like an extra clever shorthand to cast anything truthy to true and anything non-truthy to false. But in most scenarios you want to be explicit about your input parameters (because it is easier to reason about edge-cases, code-paths and tests). Also: nil and false do mean two different things.A scenario where you want this kind of flexibility, however, is parsing external data, e.g. a third party JSON-API where a value is sometimes null and sometimes false and you want to normalize that before handing it down in your program.In these case, you would be better off making the cast explicit by introducing a helper function:# preferred defp present?(nil), do: false defp present?(false), do: false defp present?(_), do: trueThis makes your code more explicit than relying on the implications of !!.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Refactor.DoubleBooleanNegation.html","title":"Credo.Check.Refactor.DoubleBooleanNegation","type":"module"},{"doc":"","ref":"Credo.Check.Refactor.DoubleBooleanNegation.html#do_run_on_source_file/3","title":"Credo.Check.Refactor.DoubleBooleanNegation.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of 0 and works with any version of Elixir.ExplanationA function can take as many parameters as needed, but even in a functional language there can be too many parameters.Can optionally ignore private functions (check configuration options).Configuration parametersUse the following parameters to configure this check:max_arity: The maximum number of parameters which a function should take. Defaults to 8ignore_defp: Set to true to ignore private functions. Defaults to falseParameters can be configured via the .credo.exs config file.","ref":"Credo.Check.Refactor.FunctionArity.html","title":"Credo.Check.Refactor.FunctionArity","type":"module"},{"doc":"","ref":"Credo.Check.Refactor.FunctionArity.html#do_run_on_source_file/3","title":"Credo.Check.Refactor.FunctionArity.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationLong quote blocks are generally an indication that too much is done inside them.Let's look at why this is problematic:defmodule MetaCommand do def __using__(opts \\\\ []) do modes = opts[:modes] command_name = opts[:command_name] quote do def run(filename) do contents = if File.exists?(filename) do {:ok, file} = File.open(filename, unquote(modes)) {:ok, contents} = IO.read(file, :line) File.close(file) contents else &quot;&quot; end case contents do &quot;&quot; -&gt; # ... unquote(command_name) &lt;&gt; rest -&gt; # ... end end # ... end end endA cleaner solution would be to call &quot;regular&quot; functions outside the quote block to perform the actual work.defmodule MyMetaCommand do def __using__(opts \\\\ []) do modes = opts[:modes] command_name = opts[:command_name] quote do def run(filename) do MyMetaCommand.run_on_file(filename, unquote(modes), unquote(command_name)) end # ... end end def run_on_file(filename, modes, command_name) do contents = # actual implementation end endThis way it is easier to reason about what is actually happening. And to debug it.Configuration parametersUse the following parameters to configure this check:max_line_count: The maximum number of lines a quote block should be allowed to have. Defaults to 150ignore_comments: Ignores comments when counting the lines of a quote block. Defaults to falseParameters can be configured via the .credo.exs config file.","ref":"Credo.Check.Refactor.LongQuoteBlocks.html","title":"Credo.Check.Refactor.LongQuoteBlocks","type":"module"},{"doc":"","ref":"Credo.Check.Refactor.LongQuoteBlocks.html#do_run_on_source_file/3","title":"Credo.Check.Refactor.LongQuoteBlocks.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and requires Elixir &lt; 1.8.0.ExplanationEnum.into/3 is more efficient than Enum.map/2 |&gt; Enum.into/2.This should be refactored:[:apple, :banana, :carrot] |&gt; Enum.map(&amp;({&amp;1, to_string(&amp;1)})) |&gt; Enum.into(%{})to look like this:Enum.into([:apple, :banana, :carrot], %{}, &amp;({&amp;1, to_string(&amp;1)}))The reason for this is performance, because the separate calls to Enum.map/2 and Enum.into/2 require two iterations whereas Enum.into/3 only requires one.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Refactor.MapInto.html","title":"Credo.Check.Refactor.MapInto","type":"module"},{"doc":"","ref":"Credo.Check.Refactor.MapInto.html#do_run_on_source_file/3","title":"Credo.Check.Refactor.MapInto.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of 0 and works with any version of Elixir.ExplanationPattern matching should only ever be used for simple assignments inside if and unless clauses.While this fine:# okay, simple wildcard assignment: if contents = File.read!(&quot;foo.txt&quot;) do do_something() endthe following should be avoided, since it mixes a pattern match with a condition and do/else blocks.# considered too &quot;complex&quot;: if {:ok, contents} = File.read(&quot;foo.txt&quot;) do do_something() end # also considered &quot;complex&quot;: if allowed? &amp;&amp; ( contents = File.read!(&quot;foo.txt&quot;) ) do do_something() endIf you want to match for something and execute another block otherwise, consider using a case statement:case File.read(&quot;foo.txt&quot;) do {:ok, contents} -&gt; do_something() _ -&gt; do_something_else() endConfiguration parametersThere are no parameters for this check.","ref":"Credo.Check.Refactor.MatchInCondition.html","title":"Credo.Check.Refactor.MatchInCondition","type":"module"},{"doc":"","ref":"Credo.Check.Refactor.MatchInCondition.html#do_run_on_source_file/3","title":"Credo.Check.Refactor.MatchInCondition.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of normal and works with any version of Elixir.ExplanationThis module might be doing too much. Consider limiting the number of module dependencies.As always: This is just a suggestion. Check the configuration options for tweaking or disabling this check.Configuration parametersUse the following parameters to configure this check:max_deps: Maximum number of module dependencies. Defaults to 10dependency_namespaces: List of dependency namespaces to include in this check Defaults to []excluded_namespaces: List of namespaces to exclude from this check Defaults to []excluded_paths: List of paths or regex to exclude from this check Defaults to [~r/\\/test\\//, ~r/^test\\//]Parameters can be configured via the .credo.exs config file.","ref":"Credo.Check.Refactor.ModuleDependencies.html","title":"Credo.Check.Refactor.ModuleDependencies","type":"module"},{"doc":"","ref":"Credo.Check.Refactor.ModuleDependencies.html#do_run_on_source_file/3","title":"Credo.Check.Refactor.ModuleDependencies.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationUnless blocks should avoid having a negated condition.The code in this example ...unless !allowed? do proceed_as_planned() end... should be refactored to look like this:if allowed? do proceed_as_planned() endThe reason for this is not a technical but a human one. It is pretty difficult to wrap your head around a block of code that is executed if a negated condition is NOT met. See what I mean?Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Refactor.NegatedConditionsInUnless.html","title":"Credo.Check.Refactor.NegatedConditionsInUnless","type":"module"},{"doc":"","ref":"Credo.Check.Refactor.NegatedConditionsInUnless.html#do_run_on_source_file/3","title":"Credo.Check.Refactor.NegatedConditionsInUnless.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationAn if block with a negated condition should not contain an else block.So while this is fine:if not allowed? do raise &quot;Not allowed!&quot; endThe code in this example ...if not allowed? do raise &quot;Not allowed!&quot; else proceed_as_planned() end... should be refactored to look like this:if allowed? do proceed_as_planned() else raise &quot;Not allowed!&quot; endThe same goes for negation through ! instead of not.The reason for this is not a technical but a human one. It is easier to wrap your head around a positive condition and then thinking &quot;and else we do ...&quot;.In the above example raising the error in case something is not allowed might seem so important to put it first. But when you revisit this code a while later or have to introduce a colleague to it, you might be surprised how much clearer things get when the &quot;happy path&quot; comes first.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Refactor.NegatedConditionsWithElse.html","title":"Credo.Check.Refactor.NegatedConditionsWithElse","type":"module"},{"doc":"","ref":"Credo.Check.Refactor.NegatedConditionsWithElse.html#do_run_on_source_file/3","title":"Credo.Check.Refactor.NegatedConditionsWithElse.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of low and works with any version of Elixir.ExplanationWe should avoid negating the is_nil predicate function. Here are a couple of examples: The code here ...def fun(%{external_id: external_id, id: id}) when not is_nil(external_id) do ... end... can be refactored to look like this:def fun(%{external_id: nil, id: id}) do ... end def fun(%{external_id: external_id, id: id}) do ... end... or even better, can match on what you were expecting on the first place:def fun(%{external_id: external_id, id: id}) when is_binary(external_id) do ... end def fun(%{external_id: nil, id: id}) do ... end def fun(%{external_id: external_id, id: id}) do ... endSimilar to negating unless blocks, the reason for this check is not technical, but a human one. If we can use the positive, more direct and human friendly case, we should.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Refactor.NegatedIsNil.html","title":"Credo.Check.Refactor.NegatedIsNil","type":"module"},{"doc":"","ref":"Credo.Check.Refactor.NegatedIsNil.html#do_run_on_source_file/3","title":"Credo.Check.Refactor.NegatedIsNil.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of 0 and works with any version of Elixir.ExplanationCode should not be nested more than once inside a function.defmodule CredoSampleModule do def some_function(parameter1, parameter2) do Enum.reduce(var1, list, fn({_hash, nodes}, list) -&gt; filenames = nodes |&gt; Enum.map(&amp;(&amp;1.filename)) Enum.reduce(list, [], fn(item, acc) -&gt; if item.filename do item # &lt;-- this is nested 3 levels deep end acc ++ [item] end) end) end endAt this point it might be a good idea to refactor the code to separate the different loops and conditions.Configuration parametersUse the following parameters to configure this check:max_nesting: The maximum number of levels code should be nested. Defaults to 2Parameters can be configured via the .credo.exs config file.","ref":"Credo.Check.Refactor.Nesting.html","title":"Credo.Check.Refactor.Nesting","type":"module"},{"doc":"","ref":"Credo.Check.Refactor.Nesting.html#do_run_on_source_file/3","title":"Credo.Check.Refactor.Nesting.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of 0 and works with any version of Elixir.ExplanationCyclomatic complexity is a software complexity metric closely correlated with coding errors.If a function feels like it's gotten too complex, it more often than not also has a high CC value. So, if anything, this is useful to convince team members and bosses of a need to refactor parts of the code based on &quot;objective&quot; metrics.Configuration parametersUse the following parameters to configure this check:max_complexity: The maximum cyclomatic complexity a function should have. Defaults to 9Parameters can be configured via the .credo.exs config file.","ref":"Credo.Check.Refactor.PerceivedComplexity.html","title":"Credo.Check.Refactor.PerceivedComplexity","type":"module"},{"doc":"Returns the Cyclomatic Complexity score for the block inside the given AST, which is expected to represent a function or macro definition.iex&gt; {:def, [line: 1], ...&gt; [ ...&gt; {:first_fun, [line: 1], nil}, ...&gt; [do: {:=, [line: 2], [{:x, [line: 2], nil}, 1]}] ...&gt; ] ...&gt; } |&gt; Credo.Check.Refactor.CyclomaticComplexity.complexity_for 1.0","ref":"Credo.Check.Refactor.PerceivedComplexity.html#complexity_for/1","title":"Credo.Check.Refactor.PerceivedComplexity.complexity_for/1","type":"function"},{"doc":"","ref":"Credo.Check.Refactor.PerceivedComplexity.html#do_run_on_source_file/3","title":"Credo.Check.Refactor.PerceivedComplexity.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of 0 and works with any version of Elixir.ExplanationPipes (|&gt;) can become more readable by starting with a &quot;raw&quot; value.So while this is easily comprehendable:list |&gt; Enum.take(5) |&gt; Enum.shuffle |&gt; pick_winner()This might be harder to read:Enum.take(list, 5) |&gt; Enum.shuffle |&gt; pick_winner()As always: This is just a suggestion. Check the configuration options for tweaking or disabling this check.Configuration parametersUse the following parameters to configure this check:excluded_functions: All functions listed will be ignored. Defaults to []excluded_argument_types: All pipes with argument types listed will be ignored. Defaults to []Parameters can be configured via the .credo.exs config file.","ref":"Credo.Check.Refactor.PipeChainStart.html","title":"Credo.Check.Refactor.PipeChainStart","type":"module"},{"doc":"","ref":"Credo.Check.Refactor.PipeChainStart.html#do_run_on_source_file/3","title":"Credo.Check.Refactor.PipeChainStart.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationAn unless block should not contain an else block.So while this is fine:unless allowed? do raise &quot;Not allowed!&quot; endThis should be refactored:unless allowed? do raise &quot;Not allowed!&quot; else proceed_as_planned() endto look like this:if allowed? do proceed_as_planned() else raise &quot;Not allowed!&quot; endThe reason for this is not a technical but a human one. The else in this case will be executed when the condition is met, which is the opposite of what the wording seems to apply.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Refactor.UnlessWithElse.html","title":"Credo.Check.Refactor.UnlessWithElse","type":"module"},{"doc":"","ref":"Credo.Check.Refactor.UnlessWithElse.html#do_run_on_source_file/3","title":"Credo.Check.Refactor.UnlessWithElse.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of 0 and works with any version of Elixir.ExplanationYou might want to refrain from rebinding variables.Although technically fine, rebinding to the same name can lead to less precise naming.Consider this example:def find_a_good_time do time = MyApp.DateTime.now time = MyApp.DateTime.later(time, 5, :days) {:ok, time} = verify_available_time(time) time endWhile there is nothing wrong with this, many would consider the following implementation to be easier to comprehend:def find_a_good_time do today = DateTime.now proposed_time = DateTime.later(today, 5, :days) {:ok, verified_time} = verify_available_time(proposed_time) verified_time endIn some rare cases you might really want to rebind a variable. This can be enabled &quot;opt-in&quot; on a per-variable basis by setting the :allow_bang option to true and adding a bang suffix sigil to your variable.def uses_mutating_parameters(params!) do params! = do_a_thing(params!) params! = do_another_thing(params!) params! = do_yet_another_thing(params!) endConfiguration parametersUse the following parameters to configure this check:allow_bang: Variables with a bang suffix will be ignored. Defaults to falseParameters can be configured via the .credo.exs config file.","ref":"Credo.Check.Refactor.VariableRebinding.html","title":"Credo.Check.Refactor.VariableRebinding","type":"module"},{"doc":"","ref":"Credo.Check.Refactor.VariableRebinding.html#do_run_on_source_file/3","title":"Credo.Check.Refactor.VariableRebinding.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.Explanationwith statements are useful when you need to chain a sequence of pattern matches, stopping at the first one that fails.However, there are a few cases where a with can be used incorrectly.Starting or ending with non-pattern-matching clausesIf the with starts or ends with clauses that are not &lt;- clauses, then those clauses should be moved either outside of the with (if they're the first ones) or inside the body of the with (if they're the last ones). For example look at this code:with ref = make_ref(), {:ok, user} &lt;- User.create(ref), Logger.debug(&quot;Created user: \#{inspect(user)}&quot;) do user endThis with should be refactored like this:ref = make_ref() with {:ok, user} &lt;- User.create(ref) do Logger.debug(&quot;Created user: \#{inspect(user)}&quot;) user endUsing only one pattern matching clause with elseIf the with has a single pattern matching clause and no else branch, it means that if the clause doesn't match than the whole with will return the value of that clause. However, if that with has also an else clause, then you're using with exactly like a case and a case should be used instead. Take this code:with {:ok, user} &lt;- User.create(make_ref()) do user else {:error, :db_down} -&gt; raise &quot;DB is down!&quot; {:error, reason} -&gt; raise &quot;error: \#{inspect(reason)}&quot; endIt can be rewritten with a clearer use of case:case User.create(make_ref()) do {:ok, user} -&gt; user {:error, :db_down} -&gt; raise &quot;DB is down!&quot; {:error, reason} -&gt; raise &quot;error: \#{inspect(reason)}&quot; endLike all Readability issues, this one is not a technical concern. But you can improve the odds of others reading and liking your code by making it easier to follow.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Refactor.WithClauses.html","title":"Credo.Check.Refactor.WithClauses","type":"module"},{"doc":"","ref":"Credo.Check.Refactor.WithClauses.html#do_run_on_source_file/3","title":"Credo.Check.Refactor.WithClauses.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationModule attributes are evaluated at compile time and not at run time. As a result, certain configuration read calls made in your module attributes may work as expected during local development, but may break once in a deployed context.This check analyzes all of the module attributes present within a module, and validates that there are no unsafe calls.These unsafe calls include:Application.fetch_env/2Application.fetch_env!/2Application.get_all_env/1Application.get_env/3Application.get_env/2As of Elixir 1.10 you can leverage Application.compile_env/3 and Application.compile_env!/2 if you wish to set configuration at compile time using module attributes.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Warning.ApplicationConfigInModuleAttribute.html","title":"Credo.Check.Warning.ApplicationConfigInModuleAttribute","type":"module"},{"doc":"","ref":"Credo.Check.Warning.ApplicationConfigInModuleAttribute.html#do_run_on_source_file/3","title":"Credo.Check.Warning.ApplicationConfigInModuleAttribute.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationBoolean operations with identical values on the left and right side are most probably a logical fallacy or a copy-and-paste error.Examples:x &amp;&amp; x x || x x and x x or xEach of these cases behaves the same as if you were just writing x.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Warning.BoolOperationOnSameValues.html","title":"Credo.Check.Warning.BoolOperationOnSameValues","type":"module"},{"doc":"","ref":"Credo.Check.Warning.BoolOperationOnSameValues.html#do_run_on_source_file/3","title":"Credo.Check.Warning.BoolOperationOnSameValues.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationChecking if the size of the enum is 0 can be very expensive, since you are determining the exact count of elements.Checking if an enum is empty should be done by usingEnum.empty?(enum)orlist == []Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Warning.ExpensiveEmptyEnumCheck.html","title":"Credo.Check.Warning.ExpensiveEmptyEnumCheck","type":"module"},{"doc":"","ref":"Credo.Check.Warning.ExpensiveEmptyEnumCheck.html#do_run_on_source_file/3","title":"Credo.Check.Warning.ExpensiveEmptyEnumCheck.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationWhile calls to IEx.pry might appear in some parts of production code, most calls to this function are added during debugging sessions.This check warns about those calls, because they might have been committed in error.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Warning.IExPry.html","title":"Credo.Check.Warning.IExPry","type":"module"},{"doc":"","ref":"Credo.Check.Warning.IExPry.html#do_run_on_source_file/3","title":"Credo.Check.Warning.IExPry.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationWhile calls to IO.inspect might appear in some parts of production code, most calls to this function are added during debugging sessions.This check warns about those calls, because they might have been committed in error.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Warning.IoInspect.html","title":"Credo.Check.Warning.IoInspect","type":"module"},{"doc":"","ref":"Credo.Check.Warning.IoInspect.html#do_run_on_source_file/3","title":"Credo.Check.Warning.IoInspect.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and requires Elixir &lt; 1.7.0.ExplanationEnsures laziness of Logger calls.You will want to wrap expensive logger calls into a zero argument function (fn -&gt; &quot;string that gets logged&quot; end).Example:# preferred Logger.debug fn -&gt; &quot;This happened: \#{expensive_calculation(arg1, arg2)}&quot; end # NOT preferred # the interpolation is executed whether or not the info is logged Logger.debug &quot;This happened: \#{expensive_calculation(arg1, arg2)}&quot;Configuration parametersUse the following parameters to configure this check:ignore: Do not raise an issue for these Logger calls. Defaults to [:error, :warn, :info]Parameters can be configured via the .credo.exs config file.","ref":"Credo.Check.Warning.LazyLogging.html","title":"Credo.Check.Warning.LazyLogging","type":"module"},{"doc":"","ref":"Credo.Check.Warning.LazyLogging.html#do_run_on_source_file/3","title":"Credo.Check.Warning.LazyLogging.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationOS child processes inherit the environment of their parent process. This includes sensitive configuration parameters, such as credentials. To minimize the risk of such values leaking, clear or overwrite them when spawning executables.The functions System.cmd/2 and System.cmd/3 allow environment variables be cleared by setting their value to nil:System.cmd(&quot;env&quot;, [], env: %{&quot;DB_PASSWORD&quot; =&gt; nil})Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Warning.LeakyEnvironment.html","title":"Credo.Check.Warning.LeakyEnvironment","type":"module"},{"doc":"","ref":"Credo.Check.Warning.LeakyEnvironment.html#do_run_on_source_file/3","title":"Credo.Check.Warning.LeakyEnvironment.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of normal and works with any version of Elixir.ExplanationMap.get/2 can lead into runtime errors if the result is passed into a pipe without a proper default value. This happens when the next function in the pipe cannot handle nil values correctly.Example:%{foo: [1, 2 ,3], bar: [4, 5, 6]} |&gt; Map.get(:missing_key) |&gt; Enum.each(&amp;IO.puts/1)This will cause a Protocol.UndefinedError, since nil isn't Enumerable. Often times while iterating over enumerables zero iterations is preferrable to being forced to deal with an exception. Had there been a [] default parameter this could have been averted.If you are sure the value exists and can't be nil, please use Map.fetch!/2. If you are not sure, Map.get/3 can help you provide a safe default value.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Warning.MapGetUnsafePass.html","title":"Credo.Check.Warning.MapGetUnsafePass","type":"module"},{"doc":"","ref":"Credo.Check.Warning.MapGetUnsafePass.html#do_run_on_source_file/3","title":"Credo.Check.Warning.MapGetUnsafePass.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationMix is a build tool and, as such, it is not expected to be available in production. Therefore, it is recommended to access Mix.env only in configuration files and inside mix.exs, never in your application code (lib).(from the Elixir docs)Configuration parametersUse the following parameters to configure this check:excluded_paths: List of paths or regex to exclude from this check Defaults to []Parameters can be configured via the .credo.exs config file.","ref":"Credo.Check.Warning.MixEnv.html","title":"Credo.Check.Warning.MixEnv","type":"module"},{"doc":"","ref":"Credo.Check.Warning.MixEnv.html#do_run_on_source_file/3","title":"Credo.Check.Warning.MixEnv.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationOperations on the same values always yield the same result and therefore make little sense in production code.Examples:x == x # always returns true x &lt;= x # always returns true x &gt;= x # always returns true x != x # always returns false x &gt; x # always returns false y / y # always returns 1 y - y # always returns 0In practice they are likely the result of a debugging session or were made by mistake.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Warning.OperationOnSameValues.html","title":"Credo.Check.Warning.OperationOnSameValues","type":"module"},{"doc":"","ref":"Credo.Check.Warning.OperationOnSameValues.html#do_run_on_source_file/3","title":"Credo.Check.Warning.OperationOnSameValues.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationSome numerical operations always yield the same result and therefore make little sense in production code.Examples:x * 1 # always returns x x * 0 # always returns 0In practice they are likely the result of a debugging session or were made by mistake.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Warning.OperationWithConstantResult.html","title":"Credo.Check.Warning.OperationWithConstantResult","type":"module"},{"doc":"","ref":"Credo.Check.Warning.OperationWithConstantResult.html#do_run_on_source_file/3","title":"Credo.Check.Warning.OperationWithConstantResult.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of 0 and works with any version of Elixir.ExplanationUsing Kernel.raise inside of a rescue block creates a new stacktrace.Most of the time, this is not what you want to do since it obscures the cause of the original error.Example:# preferred try do raise &quot;oops&quot; rescue error -&gt; Logger.warn(&quot;An exception has occurred&quot;) reraise error, System.stacktrace end # NOT preferred try do raise &quot;oops&quot; rescue error -&gt; Logger.warn(&quot;An exception has occurred&quot;) raise error endConfiguration parametersThere are no parameters for this check.","ref":"Credo.Check.Warning.RaiseInsideRescue.html","title":"Credo.Check.Warning.RaiseInsideRescue","type":"module"},{"doc":"","ref":"Credo.Check.Warning.RaiseInsideRescue.html#do_run_on_source_file/3","title":"Credo.Check.Warning.RaiseInsideRescue.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationSpawning external commands can lead to command injection vulnerabilities.Use a safe API where arguments are passed as an explicit list, rather than unsafe APIs that run a shell to parse the arguments from a single string.Safe APIs include:System.cmd/2,3:erlang.open_port/2, passing {:spawn_executable, file_name} as the first parameter, and any arguments using the :args optionUnsafe APIs include::os.cmd/1,2:erlang.open_port/2, passing {:spawn, command} as the first parameterConfiguration parametersThere are no parameters for this check.","ref":"Credo.Check.Warning.UnsafeExec.html","title":"Credo.Check.Warning.UnsafeExec","type":"module"},{"doc":"","ref":"Credo.Check.Warning.UnsafeExec.html#do_run_on_source_file/3","title":"Credo.Check.Warning.UnsafeExec.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationCreating atoms from unknown or external sources dynamically is a potentially unsafe operation because atoms are not garbage-collected by the runtime.Creating an atom from a string or charlist should be done by usingString.to_existing_atom(string)orList.to_existing_atom(charlist)Module aliases should be constructed usingModule.safe_concat(prefix, suffix)orModule.safe_concat([prefix, infix, suffix])Jason.decode/Jason.decode! should be called using keys: :atoms! (not keys: :atoms):Jason.decode(str, keys: :atoms!)or :keys should be omitted (which defaults to :strings):Jason.decode(str)Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Warning.UnsafeToAtom.html","title":"Credo.Check.Warning.UnsafeToAtom","type":"module"},{"doc":"","ref":"Credo.Check.Warning.UnsafeToAtom.html#do_run_on_source_file/3","title":"Credo.Check.Warning.UnsafeToAtom.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationWith the exception of Enum.each/2, the result of a call to the Enum module's functions has to be used.While this is correct ...def prepend_my_username(my_username, usernames) do valid_usernames = Enum.reject(usernames, &amp;is_nil/1) [my_username] ++ valid_usernames end... we forgot to save the downcased username in this example:# This is bad because it does not modify the usernames variable! def prepend_my_username(my_username, usernames) do Enum.reject(usernames, &amp;is_nil/1) [my_username] ++ valid_usernames endSince Elixir variables are immutable, Enum operations never work on the variable you pass in, but return a new variable which has to be used somehow (the exception being Enum.each/2 which iterates a list and returns :ok).Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Warning.UnusedEnumOperation.html","title":"Credo.Check.Warning.UnusedEnumOperation","type":"module"},{"doc":"","ref":"Credo.Check.Warning.UnusedEnumOperation.html#do_run_on_source_file/3","title":"Credo.Check.Warning.UnusedEnumOperation.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationThe result of a call to the File module's functions has to be used.While this is correct ...def read_from_cwd(filename) do # TODO: use Path.join/2 filename = File.cwd!() &lt;&gt; &quot;/&quot; &lt;&gt; filename File.read(filename) end... we forgot to save the result in this example:def read_from_cwd(filename) do File.cwd!() &lt;&gt; &quot;/&quot; &lt;&gt; filename File.read(filename) endSince Elixir variables are immutable, many File operations don't work on the variable you pass in, but return a new variable which has to be used somehow.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Warning.UnusedFileOperation.html","title":"Credo.Check.Warning.UnusedFileOperation","type":"module"},{"doc":"","ref":"Credo.Check.Warning.UnusedFileOperation.html#do_run_on_source_file/3","title":"Credo.Check.Warning.UnusedFileOperation.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationThe result of a call to the Keyword module's functions has to be used.While this is correct ...def clean_and_verify_options!(keywords) do keywords = Keyword.delete(keywords, :debug) if Enum.length(keywords) == 0, do: raise &quot;OMG!!!1&quot; keywords end... we forgot to save the result in this example:def clean_and_verify_options!(keywords) do Keyword.delete(keywords, :debug) if Enum.length(keywords) == 0, do: raise &quot;OMG!!!1&quot; keywords endKeyword operations never work on the variable you pass in, but return a new variable which has to be used somehow.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Warning.UnusedKeywordOperation.html","title":"Credo.Check.Warning.UnusedKeywordOperation","type":"module"},{"doc":"","ref":"Credo.Check.Warning.UnusedKeywordOperation.html#do_run_on_source_file/3","title":"Credo.Check.Warning.UnusedKeywordOperation.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationThe result of a call to the List module's functions has to be used.While this is correct ...def sort_usernames(usernames) do usernames = List.flatten(usernames) List.sort(usernames) end... we forgot to save the result in this example:def sort_usernames(usernames) do List.flatten(usernames) List.sort(usernames) endList operations never work on the variable you pass in, but return a new variable which has to be used somehow.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Warning.UnusedListOperation.html","title":"Credo.Check.Warning.UnusedListOperation","type":"module"},{"doc":"","ref":"Credo.Check.Warning.UnusedListOperation.html#do_run_on_source_file/3","title":"Credo.Check.Warning.UnusedListOperation.do_run_on_source_file/3","type":"function"},{"doc":"","ref":"Credo.Check.Warning.UnusedOperation.html","title":"Credo.Check.Warning.UnusedOperation","type":"module"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationThe result of a call to the Path module's functions has to be used.While this is correct ...def read_from_cwd(filename) do filename = Path.join(cwd, filename) File.read(filename) end... we forgot to save the result in this example:def read_from_cwd(filename) do Path.join(cwd, filename) File.read(filename) endPath operations never work on the variable you pass in, but return a new variable which has to be used somehow.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Warning.UnusedPathOperation.html","title":"Credo.Check.Warning.UnusedPathOperation","type":"module"},{"doc":"","ref":"Credo.Check.Warning.UnusedPathOperation.html#do_run_on_source_file/3","title":"Credo.Check.Warning.UnusedPathOperation.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationThe result of a call to the Regex module's functions has to be used.While this is correct ...def extract_username_and_salute(regex, string) do [string] = Regex.run(regex, string) &quot;Hi \#{string}&quot; end... we forgot to save the downcased username in this example:def extract_username_and_salute(regex, string) do Regex.run(regex, string) &quot;Hi \#{string}&quot; endRegex operations never work on the variable you pass in, but return a new variable which has to be used somehow.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Warning.UnusedRegexOperation.html","title":"Credo.Check.Warning.UnusedRegexOperation","type":"module"},{"doc":"","ref":"Credo.Check.Warning.UnusedRegexOperation.html#do_run_on_source_file/3","title":"Credo.Check.Warning.UnusedRegexOperation.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationThe result of a call to the String module's functions has to be used.While this is correct ...def salutation(username) do username = String.downcase(username) &quot;Hi \#{username}&quot; end... we forgot to save the downcased username in this example:# This is bad because it does not modify the username variable! def salutation(username) do String.downcase(username) &quot;Hi \#{username}&quot; endSince Elixir variables are immutable, String operations never work on the variable you pass in, but return a new variable which has to be used somehow.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Warning.UnusedStringOperation.html","title":"Credo.Check.Warning.UnusedStringOperation","type":"module"},{"doc":"","ref":"Credo.Check.Warning.UnusedStringOperation.html#do_run_on_source_file/3","title":"Credo.Check.Warning.UnusedStringOperation.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationThe result of a call to the Tuple module's functions has to be used.While this is correct ...def remove_magic_item!(tuple) do tuple = Tuple.delete_at(tuple, 0) if Enum.length(tuple) == 0, do: raise &quot;OMG!!!1&quot; tuple end... we forgot to save the result in this example:def remove_magic_item!(tuple) do Tuple.delete_at(tuple, 0) if Enum.length(tuple) == 0, do: raise &quot;OMG!!!1&quot; tuple endTuple operations never work on the variable you pass in, but return a new variable which has to be used somehow.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Warning.UnusedTupleOperation.html","title":"Credo.Check.Warning.UnusedTupleOperation","type":"module"},{"doc":"","ref":"Credo.Check.Warning.UnusedTupleOperation.html#do_run_on_source_file/3","title":"Credo.Check.Warning.UnusedTupleOperation.do_run_on_source_file/3","type":"function"},{"doc":"A behavior for modules that walk through source files and identify consistency issues.When defining a consistency check, you would typically use this structure for the main module, responsible for formatting issue messages:defmodule Credo.Check.Consistency.SomeCheck do use Credo.Check, run_on_all: true @collector Credo.Check.Consistency.SomeCheck.Collector def run(source_files, exec, params) when is_list(source_files) do issue_formatter = &amp;issues_for/3 @collector.find_and_append_issues(source_files, exec, params, issue_formatter) end defp issues_for(expected, source_file, params) do issue_meta = IssueMeta.for(source_file, params) issue_locations = @collector.find_locations_not_matching(expected, source_file) Enum.map(issue_locations, fn(location) -&gt; format_issue issue_meta, message: ... # write an issue message end) endThe actual analysis would be performed by another module implementing the Credo.Check.Consistency.Collector behavior:defmodule Credo.Check.Consistency.SomeCheck.Collector do use Credo.Check.Consistency.Collector def collect_matches(source_file, params) do # ... end def find_locations_not_matching(expected, source_file) do # ... end endRead further for more information on collect_matches/2, find_locations_not_matching/2, and issue_formatter.","ref":"Credo.Check.Consistency.Collector.html","title":"Credo.Check.Consistency.Collector","type":"behaviour"},{"doc":"","ref":"Credo.Check.Consistency.Collector.html#append_issue_via_issue_service/2","title":"Credo.Check.Consistency.Collector.append_issue_via_issue_service/2","type":"function"},{"doc":"When you call @collector.find_and_append_issues/4 inside the check module, the collector first counts the occurrences of different matches (e.g. :with_space and :without_space for a space around operators check) per each source file.collect_matches/2 produces a map of matches as keys and their frequencies as values (e.g. %{with_space: 50, without_space: 40}).The maps for individual source files are then merged, producing a map that reflects frequency trends for the whole codebase.","ref":"Credo.Check.Consistency.Collector.html#c:collect_matches/2","title":"Credo.Check.Consistency.Collector.collect_matches/2","type":"callback"},{"doc":"","ref":"Credo.Check.Consistency.Collector.html#find_issues/4","title":"Credo.Check.Consistency.Collector.find_issues/4","type":"function"},{"doc":"issue_formatter may call the @collector.find_locations_not_matching/2 function to obtain additional metadata for each occurrence of an unexpected match in a given file.An example implementation that returns a list of line numbers on which unexpected occurrences were found:def find_locations_not_matching(expected, source_file) do traverse(source_file, fn(match, line_no, acc) -&gt; if match != expected do acc ++ [line_no] else acc end end) end defp traverse(source_file, fun), do: ...","ref":"Credo.Check.Consistency.Collector.html#c:find_locations_not_matching/2","title":"Credo.Check.Consistency.Collector.find_locations_not_matching/2","type":"callback"},{"doc":"","ref":"Credo.Check.Consistency.Collector.html#t:issue_formatter/0","title":"Credo.Check.Consistency.Collector.issue_formatter/0","type":"type"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationException names should end with a common suffix like &quot;Error&quot;.Try to name your exception modules consistently:defmodule BadCodeError do defexception [:message] end defmodule ParserError do defexception [:message] endInconsistent use should be avoided:defmodule BadHTTPResponse do defexception [:message] end defmodule HTTPHeaderException do defexception [:message] endWhile this is not necessarily a concern for the correctness of your code, you should use a consistent style throughout your codebase.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Consistency.ExceptionNames.html","title":"Credo.Check.Consistency.ExceptionNames","type":"module"},{"doc":"","ref":"Credo.Check.Consistency.ExceptionNames.html#do_run_on_source_file/3","title":"Credo.Check.Consistency.ExceptionNames.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationWindows and Linux/macOS systems use different line-endings in files.It seems like a good idea not to mix these in the same codebase.While this is not necessarily a concern for the correctness of your code, you should use a consistent style throughout your codebase.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Consistency.LineEndings.html","title":"Credo.Check.Consistency.LineEndings","type":"module"},{"doc":"","ref":"Credo.Check.Consistency.LineEndings.html#do_run_on_source_file/3","title":"Credo.Check.Consistency.LineEndings.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationWhen using alias, import, require or use for multiple names from the same namespace, you have two options:Use single instructions per name:alias Ecto.Query alias Ecto.Schema alias Ecto.Multior use one multi instruction per namespace:alias Ecto.{Query, Schema, Multi}While this is not necessarily a concern for the correctness of your code, you should use a consistent style throughout your codebase.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Consistency.MultiAliasImportRequireUse.html","title":"Credo.Check.Consistency.MultiAliasImportRequireUse","type":"module"},{"doc":"","ref":"Credo.Check.Consistency.MultiAliasImportRequireUse.html#do_run_on_source_file/3","title":"Credo.Check.Consistency.MultiAliasImportRequireUse.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationWhen capturing a parameter using pattern matching you can either put the parameter name before or after the value i.e.def parse({:ok, values} = pair)ordef parse(pair = {:ok, values})Neither of these is better than the other, but it seems a good idea not to mix the two patterns in the same codebase.While this is not necessarily a concern for the correctness of your code, you should use a consistent style throughout your codebase.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Consistency.ParameterPatternMatching.html","title":"Credo.Check.Consistency.ParameterPatternMatching","type":"module"},{"doc":"","ref":"Credo.Check.Consistency.ParameterPatternMatching.html#do_run_on_source_file/3","title":"Credo.Check.Consistency.ParameterPatternMatching.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationUse spaces around operators like +, -, * and /. This is the preferred way, although other styles are possible, as long as it is applied consistently.# preferred 1 + 2 * 4 # also okay 1+2*4While this is not necessarily a concern for the correctness of your code, you should use a consistent style throughout your codebase.Configuration parametersUse the following parameters to configure this check:ignore: List of operators to be ignored for this check. Defaults to [:|]Parameters can be configured via the .credo.exs config file.","ref":"Credo.Check.Consistency.SpaceAroundOperators.html","title":"Credo.Check.Consistency.SpaceAroundOperators","type":"module"},{"doc":"","ref":"Credo.Check.Consistency.SpaceAroundOperators.html#do_run_on_source_file/3","title":"Credo.Check.Consistency.SpaceAroundOperators.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationDon't use spaces after (, [, and { or before }, ], and ). This is the preferred way, although other styles are possible, as long as it is applied consistently.# preferred Helper.format({1, true, 2}, :my_atom) # also okay Helper.format( { 1, true, 2 }, :my_atom )While this is not necessarily a concern for the correctness of your code, you should use a consistent style throughout your codebase.Configuration parametersUse the following parameters to configure this check:allow_empty_enums: Allows [], %{} and similar empty enum values to be used regardless of spacing throughout the codebase. Defaults to falseParameters can be configured via the .credo.exs config file.","ref":"Credo.Check.Consistency.SpaceInParentheses.html","title":"Credo.Check.Consistency.SpaceInParentheses","type":"module"},{"doc":"","ref":"Credo.Check.Consistency.SpaceInParentheses.html#do_run_on_source_file/3","title":"Credo.Check.Consistency.SpaceInParentheses.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationTabs should be used consistently.NOTE: This check does not verify the indentation depth, but checks whether or not soft/hard tabs are used consistently across all source files.It is very common to use 2 spaces wide soft-tabs, but that is not a strict requirement and you can use hard-tabs if you like that better.While this is not necessarily a concern for the correctness of your code, you should use a consistent style throughout your codebase.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Consistency.TabsOrSpaces.html","title":"Credo.Check.Consistency.TabsOrSpaces","type":"module"},{"doc":"","ref":"Credo.Check.Consistency.TabsOrSpaces.html#do_run_on_source_file/3","title":"Credo.Check.Consistency.TabsOrSpaces.do_run_on_source_file/3","type":"function"},{"doc":"This check has a base priority of high and works with any version of Elixir.ExplanationElixir allows us to use _ as a name for variables that are not meant to be used. But it’s a common practice to give these variables meaningful names anyway (_user instead of _), but some people prefer to name them all _.A single style should be present in the same codebase.Configuration parametersThere are no parameters for this check.","ref":"Credo.Check.Consistency.UnusedVariableNames.html","title":"Credo.Check.Consistency.UnusedVariableNames","type":"module"},{"doc":"","ref":"Credo.Check.Consistency.UnusedVariableNames.html#do_run_on_source_file/3","title":"Credo.Check.Consistency.UnusedVariableNames.do_run_on_source_file/3","type":"function"},{"doc":"Credo.CLI is the entrypoint for both the Mix task and the escript.","ref":"Credo.CLI.html","title":"Credo.CLI","type":"module"},{"doc":"Runs Credo with the given argv and exits the process.See Credo.run/1 if you want to run Credo programmatically.","ref":"Credo.CLI.html#main/1","title":"Credo.CLI.main/1","type":"function"},{"doc":"Command is used to describe commands which can be executed from the command line.The default command is Credo.CLI.Command.Suggest.SuggestCommand.A basic command that writes &quot;Hello World&quot; can be implemented like this:defmodule HelloWorldCommand do use Credo.CLI.Command def call(_exec, _opts) do Credo.CLI.Output.UI.puts([:yellow, &quot;Hello &quot;, :orange, &quot;World&quot;]) end end","ref":"Credo.CLI.Command.html","title":"Credo.CLI.Command","type":"behaviour"},{"doc":"Runs the Command.","ref":"Credo.CLI.Command.html#c:call/2","title":"Credo.CLI.Command.call/2","type":"callback"},{"doc":"","ref":"Credo.CLI.Command.html#t:t/0","title":"Credo.CLI.Command.t/0","type":"type"},{"doc":"This module can be used to handle filenames given at the command line.","ref":"Credo.CLI.Filename.html","title":"Credo.CLI.Filename","type":"module"},{"doc":"Returns true if a given filename contains a pos_suffix.iex&gt; Credo.CLI.Filename.contains_line_no?(&quot;lib/credo/sources.ex:39:8&quot;) true iex&gt; Credo.CLI.Filename.contains_line_no?(&quot;lib/credo/sources.ex:39&quot;) true iex&gt; Credo.CLI.Filename.contains_line_no?(&quot;lib/credo/sources.ex&quot;) false","ref":"Credo.CLI.Filename.html#contains_line_no?/1","title":"Credo.CLI.Filename.contains_line_no?/1","type":"function"},{"doc":"Returns a suffix for a filename, which contains a line and column value.iex&gt; Credo.CLI.Filename.pos_suffix(39, 8) &quot;:39:8&quot; iex&gt; Credo.CLI.Filename.pos_suffix(39, nil) &quot;:39&quot;These are used in this way: lib/credo/sources.ex:39:8","ref":"Credo.CLI.Filename.html#pos_suffix/2","title":"Credo.CLI.Filename.pos_suffix/2","type":"function"},{"doc":"Removes the pos_suffix for a filename.iex&gt; Credo.CLI.Filename.remove_line_no_and_column(&quot;lib/credo/sources.ex:39:8&quot;) &quot;lib/credo/sources.ex&quot;","ref":"Credo.CLI.Filename.html#remove_line_no_and_column/1","title":"Credo.CLI.Filename.remove_line_no_and_column/1","type":"function"},{"doc":"Adds a pos_suffix to a filename.iex&gt; Credo.CLI.Filename.with(&quot;test/file.exs&quot;, %{:line_no =&gt; 1, :column =&gt; 2}) &quot;test/file.exs:1:2&quot;","ref":"Credo.CLI.Filename.html#with/2","title":"Credo.CLI.Filename.with/2","type":"function"},{"doc":"The Options struct represents the options given on the command line.The Options struct is stored as part of the Execution struct.","ref":"Credo.CLI.Options.html","title":"Credo.CLI.Options","type":"module"},{"doc":"Returns a Options struct for the given parameters.iex&gt; Credo.CLI.Options.parse([&quot;alice&quot;, &quot;--debug&quot;], &quot;.&quot;, [&quot;alice&quot;, &quot;bob&quot;, &quot;eve&quot;], [], [debug: :boolean], []) %Credo.CLI.Options{args: [], command: &quot;alice&quot;, path: &quot;.&quot;, switches: %{debug: true}, unknown_args: [], unknown_switches: []} iex&gt; Credo.CLI.Options.parse([&quot;alice&quot;, &quot;--friend&quot;, &quot;bob&quot;, &quot;--friend&quot;, &quot;eve&quot;], &quot;.&quot;, [&quot;alice&quot;, &quot;bob&quot;, &quot;eve&quot;], [], [friend: :keep], []) %Credo.CLI.Options{args: [], command: &quot;alice&quot;, path: &quot;.&quot;, switches: %{friend: [&quot;bob&quot;, &quot;eve&quot;]}, unknown_args: [], unknown_switches: []} iex&gt; Credo.CLI.Options.parse([&quot;alice&quot;, &quot;--friend&quot;, &quot;bob&quot;, &quot;--friend&quot;, &quot;eve&quot;], &quot;.&quot;, [&quot;alice&quot;, &quot;bob&quot;, &quot;eve&quot;], [], [friend: [:string, :keep]], []) %Credo.CLI.Options{args: [], command: &quot;alice&quot;, path: &quot;.&quot;, switches: %{friend: [&quot;bob&quot;, &quot;eve&quot;]}, unknown_args: [], unknown_switches: []}","ref":"Credo.CLI.Options.html#parse/6","title":"Credo.CLI.Options.parse/6","type":"function"},{"doc":"This module provides helper functions regarding command line output.","ref":"Credo.CLI.Output.html","title":"Credo.CLI.Output","type":"module"},{"doc":"","ref":"Credo.CLI.Output.html#check_color/1","title":"Credo.CLI.Output.check_color/1","type":"function"},{"doc":"","ref":"Credo.CLI.Output.html#check_tag/2","title":"Credo.CLI.Output.check_tag/2","type":"function"},{"doc":"","ref":"Credo.CLI.Output.html#complain_about_invalid_source_files/1","title":"Credo.CLI.Output.complain_about_invalid_source_files/1","type":"function"},{"doc":"","ref":"Credo.CLI.Output.html#complain_about_timed_out_source_files/1","title":"Credo.CLI.Output.complain_about_timed_out_source_files/1","type":"function"},{"doc":"Returns a suitable foreground color for a given background_color.iex&gt; Credo.CLI.Output.foreground_color(:yellow) :black iex&gt; Credo.CLI.Output.foreground_color(:blue) :white","ref":"Credo.CLI.Output.html#foreground_color/1","title":"Credo.CLI.Output.foreground_color/1","type":"function"},{"doc":"","ref":"Credo.CLI.Output.html#issue_color/1","title":"Credo.CLI.Output.issue_color/1","type":"function"},{"doc":"","ref":"Credo.CLI.Output.html#print_skipped_checks/1","title":"Credo.CLI.Output.print_skipped_checks/1","type":"function"},{"doc":"","ref":"Credo.CLI.Output.html#priority_arrow/1","title":"Credo.CLI.Output.priority_arrow/1","type":"function"},{"doc":"","ref":"Credo.CLI.Output.html#priority_name/1","title":"Credo.CLI.Output.priority_name/1","type":"function"},{"doc":"","ref":"Credo.CLI.Output.html#term_columns/1","title":"Credo.CLI.Output.term_columns/1","type":"function"},{"doc":"","ref":"Credo.CLI.Command.Diff.DiffCommand.FilterIssues.html","title":"Credo.CLI.Command.Diff.DiffCommand.FilterIssues","type":"module"},{"doc":"Callback implementation for Credo.Execution.Task.call/2.","ref":"Credo.CLI.Command.Diff.DiffCommand.FilterIssues.html#call/2","title":"Credo.CLI.Command.Diff.DiffCommand.FilterIssues.call/2","type":"function"},{"doc":"","ref":"Credo.CLI.Command.Diff.DiffCommand.FilterIssues.html#error/2","title":"Credo.CLI.Command.Diff.DiffCommand.FilterIssues.error/2","type":"function"},{"doc":"","ref":"Credo.CLI.Command.Diff.DiffCommand.GetGitDiff.html","title":"Credo.CLI.Command.Diff.DiffCommand.GetGitDiff","type":"module"},{"doc":"Callback implementation for Credo.Execution.Task.call/2.","ref":"Credo.CLI.Command.Diff.DiffCommand.GetGitDiff.html#call/2","title":"Credo.CLI.Command.Diff.DiffCommand.GetGitDiff.call/2","type":"function"},{"doc":"","ref":"Credo.CLI.Command.Diff.DiffCommand.GetGitDiff.html#error/2","title":"Credo.CLI.Command.Diff.DiffCommand.GetGitDiff.error/2","type":"function"},{"doc":"","ref":"Credo.CLI.Command.Diff.DiffCommand.GetGitDiff.html#run_credo_and_store_resulting_execution/1","title":"Credo.CLI.Command.Diff.DiffCommand.GetGitDiff.run_credo_and_store_resulting_execution/1","type":"function"},{"doc":"This module can be used to easily delegate print-statements for different formats to different modules.Example:use Credo.CLI.Output.FormatDelegator, default: Credo.CLI.Command.Suggest.Output.Default, flycheck: Credo.CLI.Command.Suggest.Output.FlyCheck, oneline: Credo.CLI.Command.Suggest.Output.Oneline, json: Credo.CLI.Command.Suggest.Output.Json","ref":"Credo.CLI.Output.FormatDelegator.html","title":"Credo.CLI.Output.FormatDelegator","type":"module"},{"doc":"This module provides functions used to create the UI.&gt;&gt;&gt; alias Credo.CLI.Output.UI &gt;&gt;&gt; UI.puts &quot;This is a test.&quot; This is a test. nil &gt;&gt;&gt; alias Credo.CLI.Output.UI &gt;&gt;&gt; UI.warn &quot;This is a warning.&quot; This is a warning. nil","ref":"Credo.CLI.Output.UI.html","title":"Credo.CLI.Output.UI","type":"module"},{"doc":"Returns the edge (┃) which is used in much of Credo's output as a binary.","ref":"Credo.CLI.Output.UI.html#edge/0","title":"Credo.CLI.Output.UI.edge/0","type":"function"},{"doc":"","ref":"Credo.CLI.Output.UI.html#edge/2","title":"Credo.CLI.Output.UI.edge/2","type":"function"},{"doc":"See Credo.CLI.Output.Shell.puts/0.","ref":"Credo.CLI.Output.UI.html#puts/0","title":"Credo.CLI.Output.UI.puts/0","type":"function"},{"doc":"See Credo.CLI.Output.Shell.puts/1.","ref":"Credo.CLI.Output.UI.html#puts/1","title":"Credo.CLI.Output.UI.puts/1","type":"function"},{"doc":"","ref":"Credo.CLI.Output.UI.html#puts/2","title":"Credo.CLI.Output.UI.puts/2","type":"function"},{"doc":"","ref":"Credo.CLI.Output.UI.html#puts_edge/2","title":"Credo.CLI.Output.UI.puts_edge/2","type":"function"},{"doc":"Truncate a line to fit within a specified maximum length. Truncation is indicated by a trailing ellipsis (…), and you can override this using an optional third argument.iex&gt; Credo.CLI.Output.UI.truncate(nil, 7) &quot;&quot; iex&gt; Credo.CLI.Output.UI.truncate(&quot; 7 chars\\n&quot;, 7) &quot; 7 ch…&quot; iex&gt; Credo.CLI.Output.UI.truncate(&quot; more than 7\\n&quot;, 7) &quot; more…&quot; iex&gt; Credo.CLI.Output.UI.truncate(&quot; more than 7\\n&quot;, 7, &quot; ...&quot;) &quot; m ...&quot;","ref":"Credo.CLI.Output.UI.html#truncate/2","title":"Credo.CLI.Output.UI.truncate/2","type":"function"},{"doc":"","ref":"Credo.CLI.Output.UI.html#truncate/3","title":"Credo.CLI.Output.UI.truncate/3","type":"function"},{"doc":"","ref":"Credo.CLI.Output.UI.html#use_colors/1","title":"Credo.CLI.Output.UI.use_colors/1","type":"function"},{"doc":"See Credo.CLI.Output.Shell.warn/1.","ref":"Credo.CLI.Output.UI.html#warn/1","title":"Credo.CLI.Output.UI.warn/1","type":"function"},{"doc":"","ref":"Credo.CLI.Output.UI.html#wrap_at/2","title":"Credo.CLI.Output.UI.wrap_at/2","type":"function"},{"doc":"","ref":"Credo.ConfigBuilder.html","title":"Credo.ConfigBuilder","type":"module"},{"doc":"","ref":"Credo.ConfigBuilder.html#parse/1","title":"Credo.ConfigBuilder.parse/1","type":"function"},{"doc":"","ref":"Credo.ConfigFile.html","title":"Credo.ConfigFile","type":"module"},{"doc":"ConfigFile structs represent all loaded and merged config files in a run.","ref":"Credo.ConfigFile.html#__struct__/0","title":"Credo.ConfigFile.__struct__/0","type":"function"},{"doc":"Merges the given structs from left to right, meaning that later entries overwrites earlier ones.merge(base, other)Any options in other will overwrite those in base.The files: field is merged, meaning that you can define included and/or excluded and only override the given one.The checks: field is merged.","ref":"Credo.ConfigFile.html#merge/1","title":"Credo.ConfigFile.merge/1","type":"function"},{"doc":"","ref":"Credo.ConfigFile.html#merge/2","title":"Credo.ConfigFile.merge/2","type":"function"},{"doc":"","ref":"Credo.ConfigFile.html#merge_checks/2","title":"Credo.ConfigFile.merge_checks/2","type":"function"},{"doc":"","ref":"Credo.ConfigFile.html#merge_files/2","title":"Credo.ConfigFile.merge_files/2","type":"function"},{"doc":"Returns the provided config_file merged into the default configuration.config_file: full path to the custom configuration fileconfig_name: name of the configuration to loadsafe: if +true+, the config files are loaded using static analysis rather than `Code.eval_string/1`","ref":"Credo.ConfigFile.html#read_from_file_path/5","title":"Credo.ConfigFile.read_from_file_path/5","type":"function"},{"doc":"Returns Execution struct representing a consolidated Execution for all .credo.exs files in relevant_directories/1 merged into the default configuration.config_name: name of the configuration to loadsafe: if +true+, the config files are loaded using static analysis rather than `Code.eval_string/1`","ref":"Credo.ConfigFile.html#read_or_default/4","title":"Credo.ConfigFile.read_or_default/4","type":"function"},{"doc":"Returns all parent directories of the given dir as well as each ./config sub-directory.","ref":"Credo.ConfigFile.html#relevant_directories/1","title":"Credo.ConfigFile.relevant_directories/1","type":"function"},{"doc":"The ExecutionTiming module can help in timing the execution of code parts and storing those timing inside the Credo.Execution struct.","ref":"Credo.Execution.ExecutionTiming.html","title":"Credo.Execution.ExecutionTiming","type":"module"},{"doc":"Returns all timings for the given exec.","ref":"Credo.Execution.ExecutionTiming.html#all/1","title":"Credo.Execution.ExecutionTiming.all/1","type":"function"},{"doc":"Adds a timing piped from run/2 to the given exec (using the given values of tags, started_at and duration).","ref":"Credo.Execution.ExecutionTiming.html#append/3","title":"Credo.Execution.ExecutionTiming.append/3","type":"function"},{"doc":"Adds a timing to the given exec using the given values of tags, started_at and duration.","ref":"Credo.Execution.ExecutionTiming.html#append/4","title":"Credo.Execution.ExecutionTiming.append/4","type":"function"},{"doc":"Returns all timings for the given exec and tag_name.","ref":"Credo.Execution.ExecutionTiming.html#by_tag/2","title":"Credo.Execution.ExecutionTiming.by_tag/2","type":"function"},{"doc":"Returns all timings for the given exec and tag_name where the tag's value also matches the given regex.","ref":"Credo.Execution.ExecutionTiming.html#by_tag/3","title":"Credo.Execution.ExecutionTiming.by_tag/3","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Credo.Execution.ExecutionTiming.html#child_spec/1","title":"Credo.Execution.ExecutionTiming.child_spec/1","type":"function"},{"doc":"Returns the latest timestamp plus its duration for the given exec.","ref":"Credo.Execution.ExecutionTiming.html#ended_at/1","title":"Credo.Execution.ExecutionTiming.ended_at/1","type":"function"},{"doc":"Groups all timings for the given exec and tag_name.","ref":"Credo.Execution.ExecutionTiming.html#grouped_by_tag/2","title":"Credo.Execution.ExecutionTiming.grouped_by_tag/2","type":"function"},{"doc":"Runs the given fun and prints the time it took with the given label.iex&gt; Credo.Execution.ExecutionTiming.inspect(&quot;foo&quot;, fn -&gt; some_complicated_stuff() end) foo: 51284","ref":"Credo.Execution.ExecutionTiming.html#inspect/2","title":"Credo.Execution.ExecutionTiming.inspect/2","type":"function"},{"doc":"Returns the current timestamp in the same format (microseconds) as the returned starting times of run/1.","ref":"Credo.Execution.ExecutionTiming.html#now/0","title":"Credo.Execution.ExecutionTiming.now/0","type":"function"},{"doc":"Runs the given fun and returns a tuple of {started_at, duration, result}.iex&gt; Credo.Execution.ExecutionTiming.run(fn -&gt; some_complicated_stuff() end) {1540540119448181, 51284, [:whatever, :fun, :returned]}","ref":"Credo.Execution.ExecutionTiming.html#run/1","title":"Credo.Execution.ExecutionTiming.run/1","type":"function"},{"doc":"Same as run/1 but takes fun and args separately.","ref":"Credo.Execution.ExecutionTiming.html#run/2","title":"Credo.Execution.ExecutionTiming.run/2","type":"function"},{"doc":"Returns the earliest timestamp for the given exec.","ref":"Credo.Execution.ExecutionTiming.html#started_at/1","title":"Credo.Execution.ExecutionTiming.started_at/1","type":"function"},{"doc":"","ref":"Credo.Execution.Task.html","title":"Credo.Execution.Task","type":"behaviour"},{"doc":"","ref":"Credo.Execution.Task.html#c:call/2","title":"Credo.Execution.Task.call/2","type":"callback"},{"doc":"Runs a given task if the Execution wasn't halted and ensures that the result is also an Execution struct.","ref":"Credo.Execution.Task.html#run/3","title":"Credo.Execution.Task.run/3","type":"function"},{"doc":"","ref":"Credo.Execution.Task.html#t:t/0","title":"Credo.Execution.Task.t/0","type":"type"},{"doc":"This module is used to find and read all source files for analysis.","ref":"Credo.Sources.html","title":"Credo.Sources","type":"module"},{"doc":"Finds sources for a given Credo.Execution.Through the files key, configs may contain a list of included and excluded patterns. For included, patterns can be file paths, directory paths and globs. For excluded, patterns can also be specified as regular expressions.iex&gt; Sources.find(%Credo.Execution{files: %{excluded: [&quot;not_me.ex&quot;], included: [&quot;*.ex&quot;]}}) iex&gt; Sources.find(%Credo.Execution{files: %{excluded: [~r/messy/], included: [&quot;lib/mix&quot;, &quot;root.ex&quot;]}})","ref":"Credo.Sources.html#find/1","title":"Credo.Sources.find/1","type":"function"},{"doc":"Finds sources in a given directory using a list of included and excluded patterns. For included, patterns can be file paths, directory paths and globs. For excluded, patterns can also be specified as regular expressions.iex&gt; Sources.find_in_dir(&quot;/home/rrrene/elixir&quot;, [&quot;*.ex&quot;], [&quot;not_me.ex&quot;]) iex&gt; Sources.find_in_dir(&quot;/home/rrrene/elixir&quot;, [&quot;*.ex&quot;], [~r/messy/])","ref":"Credo.Sources.html#find_in_dir/3","title":"Credo.Sources.find_in_dir/3","type":"function"},{"doc":"","ref":"Credo.Watcher.html","title":"Credo.Watcher","type":"module"},{"doc":"","ref":"Credo.Watcher.html#run/1","title":"Credo.Watcher.run/1","type":"function"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Credo now requires Elixir 1.7 or newerRefactor check runner (much faster now for common scenarios)Add param allow_acronyms to check Credo.Check.Readability.FunctionNamesAdd name of check to message when printing issues with --verboseAdd support for &quot;dynamic&quot; tagging for checks via .credo.exs# Overwrite all tags for `FooCheck` {FooCheck, [tags: [:my_tag]]} # Add tags for `FooCheck` {SomeCredoCheck, [tags: [:__initial__, :my_tag]]}Tags can then be used as usual, via the CLI switch --checks-with[out]-tag:# Only run checks tagged `:my_tag` during analysis $ mix credo --checks-with-tag my_tag # Exclude all checks tagged `:my_tag` from analysis $ mix credo --checks-without-tag my_tagNew switch to enable file watcherYou can now ask Credo to re-run on file changes: $ mix credo --watchNew diff commandYou can now ask Credo to only report changes in files that were changed since a given Git ref: $ mix credo diff HEAD^ $ mix credo diff masterYou can, of course, combine this with the new --watch switch to iteratively fix issues that have come up since the last release: $ mix credo diff v1.4.0 --watchNew general check param :filesYou can now include/exclude specific files or patterns for specific checks.The syntax is the same as for the top-level :files key:# check included for Elixir files in lib/ only {Credo.Check.Consistency.ExceptionNames, files: %{included: [&quot;lib/**/*.ex&quot;]}}, # check excluded for a specific file {Credo.Check.Warning.IExPry, files: %{excluded: [&quot;lib/debug_server.ex&quot;]}}, # check included for all Elixir script files, but excluded for test scripts {Credo.Check.Warning.IoInspect, files: %{included: [&quot;**/*.exs&quot;], excluded: [&quot;**/*_test.exs&quot;]}},This means that you can now also include/exclude specific files or patterns for your custom checks by default.The syntax is the same as with all other check params:defmodule MyApp.Check.SomethingAboutTests do use Credo.Check, base_priority: :normal, explanations: [ check: &quot;&quot;&quot; ... &quot;&quot;&quot; ], param_defaults: [ files: %{included: [&quot;**/*_test.exs&quot;]} ]Please note that these params do not &quot;override&quot; the top-level config, but are applied to the result of the top-level config's resolution.New checksThese new checks can now be enabled:Credo.Check.Readability.BlockPipeCredo.Check.Readability.ImplTrueCredo.Check.Readability.SeparateAliasRequireAdditionally, Credo.Check.Warning.ApplicationConfigInModuleAttribute is a new check which warns about reading environment variables into module attributes at compile-time and is enabled by default.","ref":"changelog.html#1-5-0","title":"Changelog - 1.5.0","type":"extras"},{"doc":"Credo's schema for pre-release names changes: There is now a . after the rc like in many other Elixir projects.Add support for explaining checks (in addition to issues), i.e.$ mix credo explain Credo.Check.Design.AliasUsageAdd support for tags on checksChecks can now declare tags via the __using__ macro, i.e.defmodule MyCheck do use Credo.Check, tags: [:foo] def run(%SourceFile{} = source_file, params) do # end endTags can be used via the CLI switch --checks-with[out]-tag:# Only run checks tagged `:foo` during analysis $ mix credo --checks-with-tag foo # Exclude all checks tagged `:foo` from analysis $ mix credo --checks-without-tag fooAdd validation of check params in configIf a param is not found, Credo checks for mispellings and suggests corrections:$ mix credo ** (config) Credo.Check.Design.AliasUsage: unknown param `fi_called_more_often_than`. Did you mean `if_called_more_often_than`?Add auto-generated check docsAdd new documentation on Hex with extra guides and CHANGELOG","ref":"changelog.html#1-4-0","title":"Changelog - 1.4.0","type":"extras"},{"doc":"Support non-ascii characters in variable namesFix false positive in Credo.Check.Readability.ParenthesesOnZeroArityDefs","ref":"changelog.html#1-3-2","title":"Changelog - 1.3.2","type":"extras"},{"doc":"Fix new check (Credo.Check.Readability.StrictModuleLayout)Ignore module attributes in UnsafeToAtom","ref":"changelog.html#1-3-1","title":"Changelog - 1.3.1","type":"extras"},{"doc":"Enable Credo.Check.Readability.UnnecessaryAliasExpansion check by defaultFix bugs when removing heredocs and charlists from sourcesFix false positive on TrailingWhiteSpaceAdd ignore: [:fun1, :fun2] param to all UnusedOperation* checks; to ignore unused Enum.reduce/3 operations, use{Credo.Check.Warning.UnusedEnumOperation, [ignore: [:reduce]]},New switch to re-enable disabled checksUse --enable-disabled-checks [pattern] to re-enable checks that were disabled in the config using {CheckModule, false}. This comes in handy when using checks on a case-by-case basisAs with other check-related switches, pattern is a comma-delimted list of patterns:$ mix credo info --enable-disabled-checks Credo.Check.Readability.Specs,Credo.Check.Refactor.DoubleBooleanNegationOf course, we can have the same effect by choosing the pattern less explicitly:$ mix credo info --enable-disabled-checks specs,doubleNew API for custom checksThis deprecates the mandatory use of @explanation and @default_params module attributes for checks.Before v1.3 you had to define module attributes named @explanation and @default_params before calling use Credo.Check.Now you can pass :explanations (plural) and :param_defaults options directly to use Credo.Check.defmodule MyCheck do use Credo.Check, category: :warning, base_priority: :high, param_defaults: [param1: 42, param2: &quot;offline&quot;], explanations: [ check: &quot;...&quot;, params: [ param1: &quot;Your favorite number&quot;, param2: &quot;Online/Offline mode&quot; ] ] def run(%SourceFile{} = source_file, params) do # end endPlease note that these options are also just a convenience to implement the functions specified by the Credo.Check behaviour. You can alternatively implement the respective functions yourself:defmodule MyCheck do use Credo.Check def category, do: :warning def base_priority, do: :high def explanations do [ check: &quot;...&quot;, params: [ param1: &quot;Your favorite number&quot;, param2: &quot;Online/Offline mode&quot; ] ] end def param_defaults, do: [param1: 42, param2: &quot;offline&quot;] def run(%SourceFile{} = source_file, params) do # end endNew checksCredo.Check.Readability.StrictModuleLayoutCredo.Check.Readability.WithCustomTaggedTupleCredo.Check.Warning.LeakyEnvironmentCredo.Check.Warning.UnsafeExec","ref":"changelog.html#1-3-0","title":"Changelog - 1.3.0","type":"extras"},{"doc":"Fix performance bottleneck in Credo.Service.ETSTableHelper","ref":"changelog.html#1-2-3","title":"Changelog - 1.2.3","type":"extras"},{"doc":"Fix token interpretation of Floats","ref":"changelog.html#1-2-2","title":"Changelog - 1.2.2","type":"extras"},{"doc":"Actually enable the new check (Credo.Check.Warning.MixEnv)","ref":"changelog.html#1-2-1","title":"Changelog - 1.2.1","type":"extras"},{"doc":"Commands can now have their own pipelines, so that plugins can extend them.Add pipelines to SuggestCommand and ListCommandCredo.Plugin.append_task/4 and Credo.Plugin.prepend_task/4 let you append/prepend tasks to Command's pipelines.Validate options given to use Credo.CheckFix TrailingWhiteSpace check on WindowsFix MultiAlias to work with submodule expansionFix UnusedVariableNames bugFix Heredocs.replace_with_spaces/5 bugFix InterpolationHelper.replace_interpolations/2 bugFix crash in AliasAs check when MODULE is aliasedFix speed pitfall in Scope.name/2New config option: parse_timeoutImproved default settings for umbrella appsNew checksCredo.Check.Warning.MixEnv","ref":"changelog.html#1-2-0","title":"Changelog - 1.2.0","type":"extras"},{"doc":"Add JSON output to categories and explain commandsInclude number of executed checks in summaryFix wrong trigger in SinglePipe","ref":"changelog.html#1-1-5","title":"Changelog - 1.1.5","type":"extras"},{"doc":"Fix name parsing bug in UnusedVariableNamesFix bug when redefining operators in FunctionNamesFix false positive in Specs","ref":"changelog.html#1-1-4","title":"Changelog - 1.1.4","type":"extras"},{"doc":"Improve warning message about skipped checksFix false positive in FunctionNamesFix typespec in IssueMetaAdd AliasAs check to list of optional checks","ref":"changelog.html#1-1-3","title":"Changelog - 1.1.3","type":"extras"},{"doc":"Fix bug in Heredocs regarding indentationFix bug in FunctionNames when using unquote/1 in guardsFix bug in FunctionNames when defining sigil_ functions for uppercase sigils","ref":"changelog.html#1-1-2","title":"Changelog - 1.1.2","type":"extras"},{"doc":"Fix incompatibilities between Elixir 1.9, Credo.Code.Token and Credo.Code.InterpolationHelperFix error in Heredocs with certain UTF-8 charsNew param for ParenthesesOnZeroArityDefs: use [parens: true] to force presence of parentheses on zero arity defs","ref":"changelog.html#1-1-1","title":"Changelog - 1.1.1","type":"extras"},{"doc":"Credo now requires Elixir 1.5 and Erlang/OTP 19Fix false negative in DuplicatedCodePipeChainStart has been made opt-inPlugin SupportCredo now supports plugins that run alongside Credo's own analysis. While Credo provided the ability to write custom checks since v0.4.0, users can now access the complete toolset of Credo to create their own commands, require compilation, run external tools and still include the results in Credo's standard report.Please refer to Credo's README as well as the Credo Demo Plugin for further information on how to get started.New checksCredo.Check.Refactor.WithClauses","ref":"changelog.html#1-1-0","title":"Changelog - 1.1.0","type":"extras"},{"doc":"Fix bug due to commented-out heredocsFix variable explanation for VariableRebinding checkAdd MultiAlias check to experimental checks","ref":"changelog.html#1-0-5","title":"Changelog - 1.0.5","type":"extras"},{"doc":"Ignore heredocs in RedundantBlankLinesFix bug in StringSigilsMinor refactorings","ref":"changelog.html#1-0-4","title":"Changelog - 1.0.4","type":"extras"},{"doc":"Fix bug in Name.full/1Fix bug in UI.truncate/2Disable LazyLogging for Elixir &gt;= 1.7Add UnnecessaryAliasExpansion check to experimental checks","ref":"changelog.html#1-0-3","title":"Changelog - 1.0.3","type":"extras"},{"doc":"Fix false positive in MapIntoDisable MapInto for Elixir 1.8 and higherEnsure issues are sorted by filename, line number and column numberWarn about ineffective check filter patternsAdd ModuleDependencies check to experimental checks","ref":"changelog.html#1-0-2","title":"Changelog - 1.0.2","type":"extras"},{"doc":"Compilation warnings for Elixir 1.8Fix StringSigils to not crash with strings containing non-UTF8 characters","ref":"changelog.html#1-0-1","title":"Changelog - 1.0.1","type":"extras"},{"doc":"Improve documentationAdd error handling for malformed config filesWrite all warnings to :stderrFix false positive for charlists in PipeChainStartRemove deprecated --one-line switchDeactivate checks DuplicatedCode and DoubleBooleanNegation by defaultBREAKING CHANGESThese changes concern people writing their own checks for Credo.Credo.Check.CodeHelper was removed. Please use the corresponding functions inside the Credo.Code namespace.","ref":"changelog.html#1-0-0","title":"Changelog - 1.0.0","type":"extras"},{"doc":"Fix bug in AliasOrder","ref":"changelog.html#0-10-2","title":"Changelog - 0.10.2","type":"extras"},{"doc":"Fixed &quot;unnecessary atom quotes&quot; compiler warning during analysisHandle timeouts when reading source filesIgnore function calls for OperationOnSameValuesDo not treat |&gt; as an operator in SpaceAroundOperatorsFix AliasOrder bug for multi alias statementsFix multiple false positives for SpaceAroundOperators... and lots of important little fixes to issue messages, docs and the like!","ref":"changelog.html#0-10-1","title":"Changelog - 0.10.1","type":"extras"},{"doc":"Switch poison for jasonAdd command-line switch to load a custom configuration file (--config-file)Add a debug report in HTML format when running Credo using --debugAdd node_modules/ to default file excludesAdd :ignore_urls param for MaxLineLengthReport violation for not as well as ! in Refactor.NegatedConditionWithElseFix false positive on LargeNumbersFix NegatedConditionWithElse for not/2 as wellDisable PreferUnquotedAtoms for Elixir &gt;= 1.7.0New checksCredo.Check.Refactor.MapInto","ref":"changelog.html#0-10-0","title":"Changelog - 0.10.0","type":"extras"},{"doc":"Fix bug in ScopeFix false positive in MatchInConditionTestFix false positive in UnusedEnumOperationFix custom tasks by resolving config before validating itAdd text support to --min-priority CLI switch (you can now set it to low/normal/high)New checksCredo.Check.Readability.AliasOrder","ref":"changelog.html#0-9-3","title":"Changelog - 0.9.3","type":"extras"},{"doc":"Add :ignore_comments param to LongQuoteBlocksFix false positive in UnusedPathOperation","ref":"changelog.html#0-9-2","title":"Changelog - 0.9.2","type":"extras"},{"doc":"Fix false positive in SpaceAroundOperatorsFix false positive in UnusedEnumOperation","ref":"changelog.html#0-9-1","title":"Changelog - 0.9.1","type":"extras"},{"doc":"Add JSON supportEnsure compatibility with Elixir 1.6Format codebase using Elixir 1.6 FormatterRework internals in preparation of 1.0 releaseCredo now requires Elixir 1.4Include test directory in default configAdd excluded_argument_types to PipeChainStartEmit warnings for non-existing checks, which are referenced in configImprove VariableNamesModuleDoc now raises an issue for empty strings in @moduledoc tagsFix bug on ModuleNamesFix false positive in VariableRebindingFix false positive in SpaceAroundOperatorsFix false positive on BoolOperationOnSameValuesFix false positive on SpaceAfterCommasFix false positive on MaxLineLengthFix false positive in ParenthesesInConditionRemove NameRedeclarationBy* checksRemove support for @lint attributes","ref":"changelog.html#0-9-0","title":"Changelog - 0.9.0","type":"extras"},{"doc":"Maintenance release","ref":"changelog.html#0-8-10","title":"Changelog - 0.8.10","type":"extras"},{"doc":"Fix false positive in ParenthesesInConditionFix Code.to_tokens/1 for Elixir 1.6Fix documentation for several checksNew checksCredo.Check.Warning.ExpensiveEmptyEnumCheck","ref":"changelog.html#0-8-9","title":"Changelog - 0.8.9","type":"extras"},{"doc":"Fix false positive for LargeNumbersFix SpaceAroundOperators for @type module attributesIgnore def arguments and specs for OperationOnSameValuesFix crash in ParenthesesOnZeroArityDefs for variables named defpFix false positives for TagHelper","ref":"changelog.html#0-8-8","title":"Changelog - 0.8.8","type":"extras"},{"doc":"Fix false positive in ModuleAttributeNamesFix false positives in unused return checksFix underlining in &quot;list&quot; actionFix CLI argument parsing for mix credo.gen.checkFix loading of custom checksPrevent error when run against empty umbrella projectsPrevent output for tests","ref":"changelog.html#0-8-7","title":"Changelog - 0.8.7","type":"extras"},{"doc":"Fix false positive in SpaceAfterCommasFix false positive in SpaceAroundOperatorsFix bug with extracting explain command argsAllow anonymous functions to be piped as raw values","ref":"changelog.html#0-8-6","title":"Changelog - 0.8.6","type":"extras"},{"doc":"Speed up scope counting in CLI summary","ref":"changelog.html#0-8-5","title":"Changelog - 0.8.5","type":"extras"},{"doc":"Remove CheckForUpdates for goodFix RaiseInsideRescue for implicit try","ref":"changelog.html#0-8-4","title":"Changelog - 0.8.4","type":"extras"},{"doc":"Do not run CheckForUpdates on CI systems and in editor integrations","ref":"changelog.html#0-8-3","title":"Changelog - 0.8.3","type":"extras"},{"doc":"Refactor all consistency checks, providing a nice speed improvement (thx @little-bobby-tables)Improve Elixir 1.5 compatibility","ref":"changelog.html#0-8-2","title":"Changelog - 0.8.2","type":"extras"},{"doc":"Fix misleading issue message for LongQuoteBlocks","ref":"changelog.html#0-8-1","title":"Changelog - 0.8.1","type":"extras"},{"doc":"Load source files in parallelImprove high memory consumptionFix comment handling of Charlists, Sigils and StringsLazyLogging now only checks for debug calls by defaultAdd --mute-exit-status CLI switch, which mutes Credo's exit status (this will be used for integration tests as it means that any non-zero exit status results from a runtime error of Credo)Add default param values to mix explain outputTagTODO and TagFIXME now also report tags from doc-related module attributes (@doc, @moduledoc, @shortdoc)Fix false positives for TrailingWhiteSpaceFix compiler warnings for SigilsBREAKING CHANGESThese changes concern people writing their own checks for Credo.Credo.SourceFile struct was refactored: source, lines and ast are now stored in ETS tables.Credo.Config struct was replaced by Credo.Execution.run/3 callbacks for Credo.Check are now run/4 callbacks as they have to receive the execution's Credo.Execution struct.Config Comments replace @lint attributes@lint attributes are deprecated and will be removed in Credo 0.9.0 because they are causing a compiler warning in Elixir &gt;= 1.4.Users of Credo can now disable individual lines or files for all or just specific checks.For now, config comments let you exclude individual files completely# credo:disable-for-this-file defmodule SomeApp.ThirdPartyCode do endor deactivate specific lines:def my_fun do # credo:disable-for-next-line IO.inspect :this_is_actually_okay endor add the check module to exclude just that one check:def my_fun do # credo:disable-for-next-line Credo.Check.Warning.IoInspect IO.inspect :this_is_actually_okay endor use a Regex to be more flexible which checks to exclude:def my_fun do # credo:disable-for-next-line /IoInspect/ IO.inspect :this_is_actually_okay endHere's a list with the syntax options:# credo:disable-for-this-file - to disable for the entire file# credo:disable-for-next-line - to disable for the next line# credo:disable-for-previous-line - to disable for the previous line# credo:disable-for-lines:&lt;count&gt; - to disable for the given number of lines (negative for previous lines)New checksCredo.Check.Refactor.LongQuoteBlocks","ref":"changelog.html#0-8-0","title":"Changelog - 0.8.0","type":"extras"},{"doc":"Fix false positives in SpacesAroundOperatorsFix --all CLI switchAlways enforce strict mode for &lt;filename&gt;:&lt;line_no&gt;Improve docs on checksDisable MultiAliasImportRequireUse by defaultDisabled checksCredo.Check.Consistency.MultiAliasImportRequireUse","ref":"changelog.html#0-7-4","title":"Changelog - 0.7.4","type":"extras"},{"doc":"Fix filename annotation when using --read-from-stdinFix filename handling on WindowsFix consistency checks triggered by contents of sigilsFix consistency checks triggered by contents of charlistsNew checkCredo.Check.Warning.LazyLogging","ref":"changelog.html#0-7-3","title":"Changelog - 0.7.3","type":"extras"},{"doc":"Fix @lint attribute deprecation hintFix filename handling bug for WindowsFix flycheck formattingAdd param to ignore strings/heredocs in TrailingWhiteSpaceNew checkCredo.Check.Readability.SpaceAfterCommas","ref":"changelog.html#0-7-2","title":"Changelog - 0.7.2","type":"extras"},{"doc":"Fix --config_nameCLI switchFix UI.wrap_at/2 for Unicode stringsFix false positive for ModuleNames","ref":"changelog.html#0-7-1","title":"Changelog - 0.7.1","type":"extras"},{"doc":"Added deprecation hint about @lint attributesFixed file inclusion/exclusion bugFixed false positives in SpaceAroundOperatorsDeprecated NameRedeclarationBy* checksFixed false positives in PipeChainStartChanged AppendSingleItem's priority and make it opt-inRenamed NoParenthesesWhenZeroArity to ParenthesesOnZeroArityDefsFixed a bug in ParenthesesOnZeroArityDefsAdded/deprecated checksCredo.Check.Warning.MapGetUnsafePassCredo.Check.Refactor.AppendSingleItemCredo.Check.Readability.SemicolonsSwitched some checks to opt-in by defaultCredo.Check.Readability.SpecsCredo.Check.Refactor.ABCSizeCredo.Check.Refactor.VariableRebindingCredo.Check.Warning.MapGetUnsafePassCredo.Check.Warning.NameRedeclarationByAssignmentCredo.Check.Warning.NameRedeclarationByCaseCredo.Check.Warning.NameRedeclarationByDefCredo.Check.Warning.NameRedeclarationByFn","ref":"changelog.html#0-7-0","title":"Changelog - 0.7.0","type":"extras"},{"doc":"Fixed false positives for StringSigils in heredocsFixed a bug in SourceFile.column","ref":"changelog.html#0-6-1","title":"Changelog - 0.6.1","type":"extras"},{"doc":"Do not warn about ParenthesesInCondition in one-line if callAdd --no-strict CLI switchFixed exit status for mix credo listFixed exclusion of checks set to low priorityNew Checksconsistency/multi_alias_import_require_usereadability/no_parentheses_when_zero_arityreadability/redundant_blank_linesreadability/single_pipereadability/specsreadability/string_sigilsrefactor/double_boolean_negationrefactor/variable_rebinding","ref":"changelog.html#0-6-0","title":"Changelog - 0.6.0","type":"extras"},{"doc":"Fix crash in CheckForUpdates","ref":"changelog.html#0-5-3","title":"Changelog - 0.5.3","type":"extras"},{"doc":"Add ability to specify strict in .credo.exs config fileAdd no_case? to variable name checksAdd Module.name utility methodFix bug in NameRedeclarationByDefFix bug in LargeNumbers","ref":"changelog.html#0-5-2","title":"Changelog - 0.5.2","type":"extras"},{"doc":"Use Hex.pm API to retrieve update information for Credo","ref":"changelog.html#0-5-1","title":"Changelog - 0.5.1","type":"extras"},{"doc":"See below","ref":"changelog.html#0-5-0","title":"Changelog - 0.5.0","type":"extras"},{"doc":"Fix compiler error due to usage of undocumented Hex APIs (sorry)","ref":"changelog.html#0-4-14","title":"Changelog - 0.4.14","type":"extras"},{"doc":"Prevent crashing when parsing non-UTF-8 source filesFix yet another issue with finding sourcesFix false positives for PipeChainStartFix false positives for AbcSizeRemove dead codeUpdate deps","ref":"changelog.html#0-4-13","title":"Changelog - 0.4.13","type":"extras"},{"doc":"Prevent ModuleDoc from checking nested modules for ignored modulesFix issue with ParenthesesInConditionFix issue with PipChainStartFix issue with reading from stdinLog errors to stderr","ref":"changelog.html#0-4-12","title":"Changelog - 0.4.12","type":"extras"},{"doc":"Fix compatibility issues with Elixir &lt; 1.2Fix yet another issue with finding sources","ref":"changelog.html#0-4-11","title":"Changelog - 0.4.11","type":"extras"},{"doc":"Fix another issue with finding sources","ref":"changelog.html#0-4-10","title":"Changelog - 0.4.10","type":"extras"},{"doc":"Fix issues with finding sourcesDon't enforce @moduledoc requirement for Mixfile or Test modules","ref":"changelog.html#0-4-9","title":"Changelog - 0.4.9","type":"extras"},{"doc":"Add exclude_functions option to PipeChainStartNo longer report issues in case of ambiguous aliases in AliasUsageFix false positives for LargeNumbers in Elixir &gt;= 1.3.2 (again)Lots of refactorings","ref":"changelog.html#0-4-8","title":"Changelog - 0.4.8","type":"extras"},{"doc":"Ignore module attributes like @spec in AliasUsageImprove source file loading","ref":"changelog.html#0-4-7","title":"Changelog - 0.4.7","type":"extras"},{"doc":"Add ignore_specs option to MaxLineLengthFix false positives for LargeNumbers in Elixir &gt;= 1.3.2Fix compiler warnings in preparation for Elixir v1.4","ref":"changelog.html#0-4-6","title":"Changelog - 0.4.6","type":"extras"},{"doc":"Warnings about redeclaring names of Kernel or local functions now only consider function of arity zero.Warnings for operations with constant result now ignore division by 1Better explanation how to configure checks in explain output","ref":"changelog.html#0-4-5","title":"Changelog - 0.4.5","type":"extras"},{"doc":"New check: readability/parentheses_in_condition","ref":"changelog.html#0-4-4","title":"Changelog - 0.4.4","type":"extras"},{"doc":"Fix compatibility issues in Credo.CLI.Command.GenCheck for Elixir &lt; 1.2","ref":"changelog.html#0-4-3","title":"Changelog - 0.4.3","type":"extras"},{"doc":"Fix outdated comments regarding .credo.exs in READMEFix name generator including &quot;Lib.&quot; prefix for custom checks","ref":"changelog.html#0-4-2","title":"Changelog - 0.4.2","type":"extras"},{"doc":"Maintenance release because I apparently don't understand how merging works :sweat:","ref":"changelog.html#0-4-1","title":"Changelog - 0.4.1","type":"extras"},{"doc":"Custom check supportAdds support for custom checks in your projects.Using two new mix commands mix credo.gen.config and mix credo.gen.check you can generate the boilerplate to include custom checks in your projects.BREAKING CHANGE: Checks listed in .credo.exsPrior to v0.4.0, .credo.exs contained the full list of checks specific to your projectStarting with v0.4.0 the check list in credo.exs will be merged with the standard check list, with your definitions overwriting the defaultsPRO: you can customize individual tasks to your liking and still benefit from additional standard checks with each new releaseCON: this means checks have to be disabled explicitly in .credo.exsNew Checksreadability/large_numberswarning/bool_operation_on_same_valueswarning/unused_file_operationwarning/unused_path_operationwarning/unused_regex_operationMinor ImprovementsReady for Elixir 1.3Checks for new Credo versions automatically, like Hex does (can be disabled)Umbrella apps work out of the box nowDuplicatedCode can now ignore macro callsModuleDoc now ignores modules declaring exceptionsModuleDoc now allows modules to be ignored based on their nameMatchInCondition now allows &quot;simple&quot; wildcard assignments in conditionalsChecks analysing all files in the codebase sequentially (consistency checks) are now run in parallelIf --only is given, all issues are shown (mix credo --only MaxLineLength previously yielded no results, since all issues needed --strict to actually be displayed)","ref":"changelog.html#0-4-0","title":"Changelog - 0.4.0","type":"extras"},{"doc":"Fix false positives for NameRedeclarationByDef.Fix false positives for UnusedEnumOperation.","ref":"changelog.html#0-3-13","title":"Changelog - 0.3.13","type":"extras"},{"doc":"Fix false positives for SpaceInParentheses.Fix false positive for SpaceAroundOperators.","ref":"changelog.html#0-3-12","title":"Changelog - 0.3.12","type":"extras"},{"doc":"Fix a bug with checks on function names when declaring a variable with the name def, defp or defmacro.","ref":"changelog.html#0-3-11","title":"Changelog - 0.3.11","type":"extras"},{"doc":"Fix a bug resulting in UnicodeConversionError for code containing UTF-8 comments.","ref":"changelog.html#0-3-10","title":"Changelog - 0.3.10","type":"extras"},{"doc":"Fix a bug in AliasUsage.","ref":"changelog.html#0-3-9","title":"Changelog - 0.3.9","type":"extras"},{"doc":"Fix false positives for AliasUsage.","ref":"changelog.html#0-3-8","title":"Changelog - 0.3.8","type":"extras"},{"doc":"Fix false positive for SpaceAroundOperators.","ref":"changelog.html#0-3-7","title":"Changelog - 0.3.7","type":"extras"},{"doc":"Fix false positives for SpaceAroundOperators and PipeChainStart.Add option to read from STDIN for better editor integration","ref":"changelog.html#0-3-6","title":"Changelog - 0.3.6","type":"extras"},{"doc":"Remove superfluous call to IO.inspect.Update deps requirements to make HexFaktor happy.","ref":"changelog.html#0-3-5","title":"Changelog - 0.3.5","type":"extras"},{"doc":"Fix false positives for SpaceAroundOperators in binary pattern matches.Fix a bug when supplying a single file via the CLI.","ref":"changelog.html#0-3-4","title":"Changelog - 0.3.4","type":"extras"},{"doc":"Fix false positives for SpaceAroundOperators and SpaceInParentheses.","ref":"changelog.html#0-3-3","title":"Changelog - 0.3.3","type":"extras"},{"doc":"mix do credo, &lt;something-else&gt; was broken and never ran &lt;something-else&gt;, even if credo succeeded (exited with exit status 0). Now it runs &lt;something-else&gt; as long as credo succeeds.","ref":"changelog.html#0-3-2","title":"Changelog - 0.3.2","type":"extras"},{"doc":"Fix compiler warningsImprove copywriting for consistency checks (thx @vdaniuk)","ref":"changelog.html#0-3-1","title":"Changelog - 0.3.1","type":"extras"},{"doc":"Per-function lint supportAdds support for @lint attributes used to configure linting for specific functions.For now, this lets you exclude functions completely@lint false def my_fun do endor deactivate specific checks with the same syntax used in the config file:@lint {Credo.Check.Design.TagTODO, false} def my_fun do endor use a Regex instead of the check module to exclude multiple checks at once:@lint {~r/Refactor/, false} def my_fun do endFinally, you can supply multiple tuples as a list and combine the above:@lint [{Credo.Check.Design.TagTODO, false}, {~r/Refactor/, false}] def my_fun do endNew Checksconsistency/space_around_operatorsconsistency/space_in_parenthesesMinor ImprovementsAdd --format CLI switchInclude experimental Flycheck support via --format=flycheckDeprecate --one-line CLI switch, use --format=oneline insteadAdd convenience alias --ignore for --ignore-checksFix colors for terminals with light backgrounds (thx @lucasmazza)","ref":"changelog.html#0-3-0","title":"Changelog - 0.3.0","type":"extras"},{"doc":"Fix false positives for UnusedEnumOperation checks (thx @kbaird)","ref":"changelog.html#0-2-6","title":"Changelog - 0.2.6","type":"extras"},{"doc":"Fix error occuring when a project has exactly one defexception moduleChange the tag for Refactoring Opportunities from &quot;[R]&quot; to &quot;[F]&quot; (thx @rranelli)","ref":"changelog.html#0-2-5","title":"Changelog - 0.2.5","type":"extras"},{"doc":"Remove unused alias to avoid warning during compilation","ref":"changelog.html#0-2-4","title":"Changelog - 0.2.4","type":"extras"},{"doc":"Improves docs and UI wording (thx @crack and @jessejanderson)","ref":"changelog.html#0-2-3","title":"Changelog - 0.2.3","type":"extras"},{"doc":"Adds a missing word to the output of the categories command (thx @bakkdoor)","ref":"changelog.html#0-2-2","title":"Changelog - 0.2.2","type":"extras"},{"doc":"Fixes a problem with CaseTrivialMatches crashing","ref":"changelog.html#0-2-1","title":"Changelog - 0.2.1","type":"extras"},{"doc":"Error StatusCredo now fails with an exit status != 0 if it shows any issues. This will enable usage of Credo inside CI systems/build chains.The exit status of each check is customizable and exit statuses of all encountered checks are collected, uniqued and summed:issues |&gt; Enum.map(&amp;(&amp;1.exit_status)) |&gt; Enum.uniq |&gt; Enum.reduce(0, &amp;(&amp;1+&amp;2))This way you can reason about the encountered issues right from the exit status.Default values for the checks are based on their category:consistency: 1 design: 2 readability: 4 refactor: 8 warning: 16So an exit status of 12 tells you that you have only Readability Issues and Refactoring Opportunities, but e.g. no Warnings.New Checksreadability/module_docrefactor/case_trivial_matchesrefactor/cond_statementsrefactor/function_arityrefactor/match_in_conditionrefactor/pipe_chain_startwarning/operation_with_constant_resultwarning/unused_enum_operationwarning/unused_keyword_operationwarning/unused_list_operationwarning/unused_tuple_operationMinor ImprovementsThere are two new aliases for command line switches:you can use --only as alias for --checksyou can use --strict as alias for --all-prioritiesmix credo --only &lt;checkname&gt; will always display a full list of results (you no longer need to specify --all separately)mix credo explain &lt;file:line_number&gt; now also explains the available configuration parameters for the issue/checkThe ExceptionNames check no longer fails if only a single exception module is found (#22).","ref":"changelog.html#0-2-0","title":"Changelog - 0.2.0","type":"extras"},{"doc":"Apply many fixes in anticipation of Elixir v1.2 (thx @c-rack)Improve docsWrap long issue descriptions in suggest command","ref":"changelog.html#0-1-10","title":"Changelog - 0.1.10","type":"extras"},{"doc":"Add missing -A alias for --all-prioritiesImprove wording in the CLI a bit","ref":"changelog.html#0-1-9","title":"Changelog - 0.1.9","type":"extras"},{"doc":"Add apps/ to default directories","ref":"changelog.html#0-1-8","title":"Changelog - 0.1.8","type":"extras"},{"doc":"Bugfix to NameRedeclarationBy\\* checksSources.exclude had a bug when excluding directories","ref":"changelog.html#0-1-7","title":"Changelog - 0.1.7","type":"extras"},{"doc":"Rename CLI switch --pedantic to --all-priorities (alias is -A)Fix a bug in SourceFile.column (#7)Improve README section about basic usage, commands and issues","ref":"changelog.html#0-1-6","title":"Changelog - 0.1.6","type":"extras"},{"doc":"Multiple Hex releases due to the fact that I apparently don't understand how deps compilation works :sweat:","ref":"changelog.html#0-1-1-0-1-5","title":"Changelog - 0.1.1 - 0.1.5","type":"extras"},{"doc":"Initial release","ref":"changelog.html#0-1-0","title":"Changelog - 0.1.0","type":"extras"},{"doc":"OverviewCredo is a static code analysis tool for the Elixir language with a focus on teaching and code consistency.credo can show you refactoring opportunities in your code, complex code fragments, warn you about common mistakes, show inconsistencies in your naming scheme and - if needed - help you enforce a desired coding style.The basic functionality will be familiar to you if you used a linter like JavaScript's ESLint, Ruby's RuboCop or C#'s Stylecop before.Contrary to the aforementioned tools, Credo puts a strong emphasis on teaching and code consistency.To get started, you might want to check out these guides:InstallationBasic usageConfiguration via .credo.exsOnce you are familiar with the basics, look into these topics:Adding custom checksTesting custom checksPluginsAny incorrect or unclear information in these docs should be considered a bug. In case you find something, you can help maintaining these docs by filing an issue on GitHub and/or opening a pull request.","ref":"overview.html","title":"Overview","type":"extras"},{"doc":"InstallationThe easiest way to add Credo to your project is by using Mix.Add :credo as a dependency to your project's mix.exs:defp deps do [ {:credo, &quot;~&gt; 1.4&quot;, only: [:dev, :test], runtime: false} ] endAnd run:$ mix deps.get","ref":"installation.html","title":"Installation","type":"extras"},{"doc":"Basic UsageTo run credo in the current project, just type:$ mix credoThis will run the code analysis and suggest places to edit your code.If you want to enforce a style guide and need a more traditional linting experience, try$ mix credo --strictYou will get output like this:┃ Refactoring opportunities ┃ ┃ [F] ↗ Avoid negated conditions in if-else blocks. ┃ lib/credo/check.ex:306 #(Credo.Check.deprecated_def_explanations) ┃ [F] ↗ Avoid negated conditions in if-else blocks. ┃ lib/credo/check.ex:285 #(Credo.Check.deprecated_def_default_params)Since Credo is all about teaching people, you can find out more about that particular entry. Just copy the &lt;filename&gt;:&lt;line-number&gt;[:column] combo into the command:$ mix credo lib/credo/check.ex:306The result is an explanation of the issue:┃ ┃ [F] Category: refactor ┃ ↗ Priority: high ┃ ┃ Avoid negated conditions in if-else blocks. ┃ lib/credo/check.ex:306 (Credo.Check.deprecated_def_explanations) ┃ ┃ __ CODE IN QUESTION ┃ ┃ 304 explanation = Module.get_attribute(env.module, :explanation) ┃ 305 ┃ 306 if not is_nil(explanation) do ┃ 307 # deprecated - remove once we ditch @explanation ┃ 308 quote do ┃ ┃ __ WHY IT MATTERS ┃ ┃ An `if` block with a negated condition should not contain an else block. ┃ ┃ So while this is fine: ┃ ┃ if not allowed? do ┃ raise &quot;Not allowed!&quot; ┃ end ┃ ┃ The code in this example ... ┃ ┃ if not allowed? do ┃ raise &quot;Not allowed!&quot; ┃ else ┃ proceed_as_planned() ┃ end ┃ ┃ ... should be refactored to look like this: ┃ ┃ if allowed? do ┃ proceed_as_planned() ┃ else ┃ raise &quot;Not allowed!&quot; ┃ end ┃ ┃ The same goes for negation through `!` instead of `not`. ┃ ┃ The reason for this is not a technical but a human one. It is easier to wrap ┃ your head around a positive condition and then thinking &quot;and else we do ...&quot;. ┃ ┃ In the above example raising the error in case something is not allowed ┃ might seem so important to put it first. But when you revisit this code a ┃ while later or have to introduce a colleague to it, you might be surprised ┃ how much clearer things get when the &quot;happy path&quot; comes first.Credo can also provide the output of every command as JSON:$ mix credo lib/credo/check.ex:306 --format json { &quot;explanations&quot;: [ { &quot;category&quot;: &quot;refactor&quot;, &quot;check&quot;: &quot;Elixir.Credo.Check.Refactor.NegatedConditionsWithElse&quot;, &quot;column&quot;: null, &quot;explanation_for_issue&quot;: &quot;An `if` block with a negated condition should not contain an else block.\\n\\nSo while this is fine:\\n\\n if not allowed? do\\n raise \\&quot;Not allowed!\\&quot;\\n end\\n\\nThe code in this example ...\\n\\n if not allowed? do\\n raise \\&quot;Not allowed!\\&quot;\\n else\\n proceed_as_planned()\\n end\\n\\n... should be refactored to look like this:\\n\\n if allowed? do\\n proceed_as_planned()\\n else\\n raise \\&quot;Not allowed!\\&quot;\\n end\\n\\nThe same goes for negation through `!` instead of `not`.\\n\\nThe reason for this is not a technical but a human one. It is easier to wrap\\nyour head around a positive condition and then thinking \\&quot;and else we do ...\\&quot;.\\n\\nIn the above example raising the error in case something is not allowed\\nmight seem so important to put it first. But when you revisit this code a\\nwhile later or have to introduce a colleague to it, you might be surprised\\nhow much clearer things get when the \\&quot;happy path\\&quot; comes first.\\n&quot;, &quot;filename&quot;: &quot;lib/credo/check.ex&quot;, &quot;line_no&quot;: 306, &quot;message&quot;: &quot;Avoid negated conditions in if-else blocks.&quot;, &quot;priority&quot;: 12, &quot;related_code&quot;: [ [304, &quot; explanation = Module.get_attribute(env.module, explanation)&quot;], [305, &quot;&quot;], [306, &quot; if not is_nil(explanation) do&quot;], [307, &quot; # deprecated - remove once we ditch @explanation&quot;], [308, &quot; quote do&quot;] ], &quot;scope&quot;: &quot;Credo.Check.deprecated_def_explanations&quot;, &quot;trigger&quot;: &quot;!&quot; } ] }Using Credo as stand aloneIf you do not want or are not allowed to include Credo in the current project, you can also install it as an archive. For this, you also need to install bunt:git clone git@github.com:rrrene/bunt.git cd bunt mix archive.build mix archive.install cd - git clone git@github.com:rrrene/credo.git cd credo mix deps.get mix archive.build mix archive.installImportant: You have to install bunt as well:git clone https://github.com/rrrene/bunt cd bunt mix archive.build mix archive.installYou will now be able to invoke credo as usual through Mix with mix credo. This option is especially handy so credo can be used by external editors.","ref":"basic_usage.html","title":"Basic Usage","type":"extras"},{"doc":"Like any code linter, Credo reports issues. Contrary to many other linters these issues are not created equal. Each issue is assigned a priority, based on a base priority set by the config and a dynamic component based on violation severity and location in the source code.These priorities hint at the importance of each issue and are displayed in the command-line interface using arrows: ↑ ↗ → ↘ ↓By default, only issues with a positive priority are part of the report (↑ ↗ →).","ref":"basic_usage.html#issues","title":"Basic Usage - Issues","type":"extras"},{"doc":"suggest (default command)suggest is the default command of Credo. It suggests issues to fix in your code, but it cuts the list to a digestable count. If you want to see the full list, use the --all switch.Example usage:$ mix credo # display standard report $ mix credo suggest # same thing, since it's the default command $ mix credo --strict --format=json # include low priority issues, output as JSON $ mix credo suggest --help # more optionsLearn more ....listlist also suggests issues, but it groups them by file and does NOT cut the list to a certain count.Example usage:$ mix credo list # show issues grouped by file $ mix credo list --format oneline # show issues grouped by file, one issue per line $ mix credo list --format oneline -a # same thing, include low priority issues $ mix credo list --help # more optionsLearn more ....explainexplain allows you to dig deeper into an issue, by showing you details about the issue and the reasoning by it being reported. To be convenient, you can just copy-paste the filename:line_number:column string from the report behind the Credo command to check it out.Example usage:$ mix credo lib/my_app/server.ex:10:24 # show explanation for the issue $ mix credo explain lib/my_app/server.ex:10:24 # same thingCredit where credit is due: This is inspired by how you can snap the info from failed tests behind mix test.Learn more ....categoriescategories shows you all issue categories and explains their semantics.There are no additional options.infoinfo shows you information relevant to investigating errors and submitting bug reports.Example usage:$ mix credo info $ mix credo info --verbose $ mix credo info --verbose --format=jsonFurther readingIf you are interested in more ways to configure Credo, continue reading in the following sections:CLI switchesConfiguration file","ref":"basic_usage.html#commands","title":"Basic Usage - Commands","type":"extras"},{"doc":"Exit StatusCredo fails with an exit status != 0 if it shows any issues. This enables shell based pipeline workflows (e.g. on CI systems) which test Credo compliance.The exit status of each check is used to construct a bit map of the types of issues which were encountered by or-ing them together to produce the final result:use Bitwise issues |&gt; Enum.map(&amp;(&amp;1.exit_status)) |&gt; Enum.reduce(0, &amp;(&amp;1 ||| &amp;2))This way you can reason about the encountered issues right from the exit status.Default values for the checks are based on their category:consistency: 1 design: 2 readability: 4 refactor: 8 warning: 16Let's see what this means using an example:$ mix credo [...snip...] $ echo $? 12So an exit status of 12 tells you that you have only Readability Issues (4) and Refactoring Opportunities (8), but e.g. no Warnings.Naturally, custom checks and plugins can provide their own exit statuses.","ref":"exit_statuses.html","title":"Exit Status","type":"extras"},{"doc":"Mix TasksAfter incuding Credo in a project's dependencies (see Installation), there are a number of built-in mix tasks available:$ mix help | grep -i credo mix credo # Run code analysis (use `--help` for options) mix credo.gen.check # Generate a new custom check for Credo mix credo.gen.config # Generate a new config for CredoIf you want to know more about mix, check out Introduction to Mix.mix credoRuns Credo's analysis. Check out Configuration on how to customize inputs and outputs.mix credo.gen.checkGenerates a custom Credo check.mix credo.gen.configGenerates a Credo config file. Check out Configuration on how to customize it.","ref":"mix_tasks.html","title":"Mix Tasks","type":"extras"},{"doc":".credo.exsCredo is configured via a file called .credo.exs.You can use mix credo gen.config to generate a complete example configuration.$ mix credo gen.config * creating .credo.exsThis file can live in your project's config/ or root folder, both is fine.","ref":"config_file.html","title":".credo.exs","type":"extras"},{"doc":"Credo's config is a plain .exs file, no magic here. It contains a map with a single key (:configs), which contains a list of maps that represent the individual configs (most of the time, it's just one, named &quot;default&quot;).# .credo.exs or config/.credo.exs %{ configs: [ %{ name: &quot;default&quot;, files: %{ included: [&quot;lib/&quot;, &quot;src/&quot;, &quot;web/&quot;, &quot;apps/&quot;], excluded: [] }, plugins: [], requires: [], strict: false, parse_timeout: 5000, color: true, checks: [ {Credo.Check.Design.AliasUsage, priority: :low}, # ... other checks omitted for readability ... ] } ] }The config keys available are::name:checks:color:files:parse_timeout:plugins:requires:strict:nameCredo configs are given names. The default configuration is named default.You can specify which config to use on the command line (again, default is run by ... default):mix credo --config-name &lt;NAME_OF_CONFIG&gt;For example, say we have a directory lib/that_big_namespace with tons of issues and we do want to split our regular linting and the necessary clean up in that directory.We can exclude the directory from our default config and add another config for just that directory.# .credo.exs %{ configs: [ %{ name: &quot;default&quot;, files: %{ included: [&quot;lib/&quot;, &quot;src/&quot;, &quot;web/&quot;, &quot;apps/&quot;], excluded: [&quot;lib/that_big_namespace&quot;] } }, %{ name: &quot;spring-cleaning&quot;, files: %{ included: [&quot;lib/that_big_namespace&quot;], excluded: [] } } ] }Now you can usemix credo --config-name spring-cleaningto run the custom configuration we added.:files# .credo.exs %{ configs: [ %{ name: &quot;default&quot;, files: %{ included: [&quot;mix.exs&quot;, &quot;lib/&quot;, &quot;src/&quot;, &quot;web/&quot;, &quot;apps/&quot;], excluded: [&quot;test/&quot;] }, # checks etc. } ] }The :files map can have two fields::included contains a list of files, directories and globs (as in &quot;**/*_test.exs&quot;):excluded contains a list of files, directories, globs (as in &quot;**/*_test.exs&quot;) and regular expressions (as in ~r&quot;/_build/&quot;):pluginsConfigures plugin modules that Credo should load at start up (defaults to []).This is needed to enable and configure plugins in the analysis.# .credo.exs %{ configs: [ %{ name: &quot;default&quot;, plugins: [ {CredoDemoPlugin, []} ], # files, checks etc. } ] }All plugins are configured using a two-element tuple:{MyApp.PluginModule, params}MyApp.PluginModule - the module representing the plugin to be configuredparams - can be either false (to disable the plugin) or a keyword list of parameters (to configure the plugin):requiresConfigures Elixir source files that Credo should require at start up (defaults to []).This is needed to add local custom checks in the analysis.# .credo.exs %{ configs: [ %{ name: &quot;default&quot;, requires: [&quot;lib/check/my_check.ex&quot;], # files, checks etc. } ] }:strictSet to true to enable low priority checks (defaults to false).This is equivalent to using the --strict CLI switch.# .credo.exs %{ configs: [ %{ name: &quot;default&quot;, strict: true, # files, checks etc. } ] }:parse_timeoutConfigures a timeout for parsing source files in milliseconds (defaults to 5000 milliseconds).# .credo.exs %{ configs: [ %{ name: &quot;default&quot;, parse_timeout: 60_000, # files, checks etc. } ] }:colorSet to false to disable colored output (defaults to true).This is equivalent to using the --no-color CLI switch.# .credo.exs %{ configs: [ %{ name: &quot;default&quot;, color: false, # files, checks etc. } ] }:checksConfigures plugin modules that Credo should load at start up (defaults to []).This is needed to enable and configure checks in the analysis.# .credo.exs %{ configs: [ %{ name: &quot;default&quot;, checks: [ {Credo.Check.Consistency.TabsOrSpaces, false}, {Credo.Check.Design.AliasUsage, priority: :low}, ], # files etc. } ] }All checks are configured using a two-element tuple:{MyApp.CheckModule, params}MyApp.CheckModule - the module representing the check to be configuredparams - can be either false (to disable the check) or a keyword list of parameters (to configure the check)","ref":"config_file.html#config-keys","title":".credo.exs - Config Keys","type":"extras"},{"doc":"You can tell Creod to use a specific config file anywhere in the file system:mix credo --config-file &lt;PATH_TO_CONFIG_FILE&gt;Please note that when specifying a config file this way, only that config files contents are loaded. The &quot;Transitive configuration files&quot; mechanism described in the next section does not apply in this case.","ref":"config_file.html#using-a-specific-configuration-file","title":".credo.exs - Using a specific configuration file","type":"extras"},{"doc":"Credo traverses the filesystem's folder structure upwards to find additional config files which it applies to the current project.Consider the following directory structure:/ home/ rrrene/ projects/ foo/ .credo.exs bar/ .credo.exsIn this example, there is a Credo config file in my home folder and one in my project.For project foo/, the contents of /home/rrrene/projects/foo/.credo.exs are merged with the settings in /home/rrrene/.credo.exs and Credo's default config.For project bar/, the contents of /home/rrrene/.credo.exs and Credo's default config are relevant.Please not that, as mentioned above, Credo's config can also resive in a config/ subdirectory at every step of the way.Given this directory structure:/ home/ rrrene/ config/ .credo.exs projects/ bar/ foo/ config/ .credo.exsFor project foo/, the contents of /home/rrrene/projects/foo/config/.credo.exs are merged with the settings in /home/rrrene/config/.credo.exs and Credo's default config.This works great for umbrella projects, where you can have individual .credo.exs files for each app and/or a global one in the umbrella's config/ or root folder. This way, you can enable/disable settings on a per-app basis.","ref":"config_file.html#transitive-configuration-files","title":".credo.exs - Transitive configuration files","type":"extras"},{"doc":"Command line switchesMost configuration options are also available as command line switches, so that you can e.g. only run certain checks at a time to focus attention on those issues.","ref":"cli_switches.html","title":"Command line switches","type":"extras"},{"doc":"Here are a couple of common use case and their respective command line switches:Output FormatsUse --format to format the output in one of the following formats:--format flycheck for Flycheck output--format json for JSON outputOnly run some checksTo run only a subset of checks, you can use the --checks or the -c alias (also aliased as --only).# to only run the Readability checks, use: $ mix credo --only readability # to only run Readability checks and Warnings, use: $ mix credo --only readability,warningThe second example illustrates how the command takes a comma-separated list. All commands matching any of the passed items will be run.You can use partial names to quickly run checks. mix credo --only todo will show all # TODO comments since todo will match Credo.Check.Design.TagTODO. mix credo --only inspect will show you all calls to IO.inspect since it matches Credo.Check.Warning.IoInspect.Ignore some checksTo ignore selected checks, you can use the --ignore-checks or the -i alias (also aliased as --ignore).# to ignore all Readability checks, use: $ mix credo --ignore readability # to ignore all Readability checks and the DuplicatedCode check, use: $ mix credo --ignore readability,duplicatedThe second example illustrates how the command takes a comma-separated list. All commands matching any of the passed items will be ignored.You can use partial names to quickly exclude checks. mix credo --ignore nameredec will exclude all checks for variables/parameters having the same name as declared functions by matching Credo.Check.Warning.NameRedeclarationBy...Re-enable disabled checksUse --enable-disabled-checks [pattern] to re-enable checks that were disabled in the config using {CheckModule, false}. This comes in handy when using checks on a case-by-case basisAs with other check-related switches, pattern is a comma-delimted list of patterns:$ mix credo info --enable-disabled-checks Credo.Check.Readability.Specs,Credo.Check.Refactor.DoubleBooleanNegationOf course, we can have the same effect by choosing the pattern less explicitly:$ mix credo info --enable-disabled-checks specs,doubleParsing source from STDINYou can also use Credo to parse source that has been piped directly into it. This is especially useful when integrating with external editors. You can use this feature by passing the --read-from-stdin option as follows:$ echo 'IO.puts(&quot;hello world&quot;);' | mix credo --format flycheck --read-from-stdin # stdin:1: C: There is no whitespace around parentheses/brackets most of the time, but here there is.Notice the origin if the source is coming annotated as stdin, you can change this annotation by passing it along after option like so:$ echo 'IO.puts(&quot;hello world&quot;);' | mix credo --format flycheck --read-from-stdin /path/representing/the_current/source.ex # /path/representing/the_current/source.ex:1: C: There is no whitespace around parentheses/brackets most of the time, but here there is.Do note with the passed option as filename is a stub that is just used to prefix the error and so certain editors can annotate the original file.Show all issues (including low priority ones)By default, Credo's CLI output shows only the 5 most important issues per category. Using --all, you can show all the important issues in each category.Use the --all-priorities switch to include low priority issues in the output (aliased as --strict).","ref":"cli_switches.html#common-use-cases","title":"Command line switches - Common use cases","type":"extras"},{"doc":"Most configuration options are also available as command line switches.➜ mix credo suggest --help Usage: mix credo suggest [paths] [options] Suggests objects from every category that Credo thinks can be improved. Example: $ mix credo suggest lib/**/*.ex --only consistency --format json Arrows (↑ ↗ → ↘ ↓) hint at the importance of an issue. Suggest options: -a, --all Show all issues -A, --all-priorities Show all issues including low priority ones -c, --checks Only include checks that match the given strings --checks-with-tag Only include checks that match the given tag (can be used multiple times) --checks-without-tag Ignore checks that match the given tag (can be used multiple times) --config-file Use the given config file -C, --config-name Use the given config instead of &quot;default&quot; --enable-disabled-checks Re-enable disabled checks that match the given strings --files-included Only include these files (accepts globs, can be used multiple times) --files-excluded Exclude these files (accepts globs, can be used multiple times) --format Display the list in a specific format (json,flycheck,oneline) -i, --ignore-checks Ignore checks that match the given strings --ignore Alias for --ignore-checks --min-priority Minimum priority to show issues (high,medium,normal,low,lower or number) --mute-exit-status Exit with status zero even if there are issues --only Alias for --checks --strict Alias for --all-priorities General options: --[no-]color Toggle colored output -v, --version Show version -h, --help Show this helpSome of these are not available as configuration options in .credo.exs:--enable-disabled-checks [PATTERN] activates disabled checks on the fly--mute-exit-status forces Credo to exit with an exit status of 0","ref":"cli_switches.html#command-line-switches-and-config-file","title":"Command line switches - Command line switches and config file","type":"extras"},{"doc":"Inline Config CommentsUsers of Credo can now disable individual lines or files for all or just specific checks.defp do_stuff() do # credo:disable-for-next-line IO.inspect {:we_want_this_inspect_in_production!} endThere are four config comments:# credo:disable-for-this-file - to disable for the entire file# credo:disable-for-next-line - to disable for the next line# credo:disable-for-previous-line - to disable for the previous line# credo:disable-for-lines:&lt;count&gt; - to disable for the given number of lines (negative for previous lines)Each of these can also take the name of the check you want to disable:defp my_fun() do # credo:disable-for-next-line Credo.Check.Warning.IoInspect IO.inspect {:we_want_this_inspect_in_production!} endLastly, you can put a regular expression (/.+/) instead of a check name to disable multiple checks (or if you do not want to type out the checks):defp my_fun() do # credo:disable-for-next-line /\\.Warning\\./ IO.inspect {:we_want_this_inspect_in_production!} end","ref":"config_comments.html","title":"Inline Config Comments","type":"extras"},{"doc":"mix credo suggestsuggest suggests issues to fix in your code, but it cuts the list to a digestable count. It is the default command of Credo.If you want to see the full list, use the --all switch.Example usage:$ mix credo # display standard report $ mix credo suggest # same thing, since it's the default command $ mix credo --strict --format=json # include low priority issues, output as JSON $ mix credo suggest --help # more options $ mix credo suggest --format json $ mix credo suggest lib/**/*.ex --only consistency --strict $ mix credo suggest --checks-without-tag formatter --checks-without-tag controversial","ref":"suggest_command.html","title":"mix credo suggest","type":"extras"},{"doc":"mix credo explainexplain allows you to dig deeper into an issue, by showing you details about the issue and the reasoning by it being reported. To be convenient, you can just copy-paste the filename:line_number:column string from the report behind the Credo command to check it out.Credits: This is inspired by how you can snap the info from failed tests behind mix test.Example usage:$ mix credo lib/my_app/server.ex:10:24 # show explanation for the issue $ mix credo explain lib/my_app/server.ex:10:24 # same thingThere are no additional options.","ref":"explain_command.html","title":"mix credo explain","type":"extras"},{"doc":"mix credo listlist also suggests issues, but it groups them by file and does NOT cut the list to a certain count.Example usage:$ mix credo list # show issues grouped by file $ mix credo list --format oneline # show issues grouped by file, one issue per line $ mix credo list --format oneline -a # same thing, include low priority issues $ mix credo list --help # more options","ref":"list_command.html","title":"mix credo list","type":"extras"},{"doc":"Adding Custom ChecksThere comes a time when Credo does not feature the check you need or where you want to test a project- or domain-specific aspect of your codebase.This is when you should consider implementing a Custom Check.Custom checks are simply modules implementing the Credo.Check behaviour, which most of the time means that it is a module with a run/2 function returning a list of Credo.Issue structs:# lib/checks/my_check.ex defmodule MyProject.Checks.MyCheck do use Credo.Check def run(%SourceFile{} = source_file, params) do # end endCheck Credo.Check for more technical information.Our first check: Policing module attributesSometimes the conventions for names of module attributes change within a development team and you want to encourage people to stop using the old naming scheme for module attributes to avoid endless bikeshedding about whether or not the new naming policy was needed in the first place.So, let's implement a check for this completely made up scenario!Minimal check &amp; configFirst, we add the necessary Elixir module for the check and, for now, just return an empty list of issues.# lib/my_project/checks/reject_module_attributes.ex defmodule MyProject.Checks.RejectModuleAttributes do # Set up the behaviour and make this module a &quot;check&quot;: use Credo.Check # The minimum each check has to implement is a `run/2` function which returns the found issues: def run(source_file, params \\\\ []) do [] end endTo run our new check, we also need to add the necessary :requires and :checks in our Credo config file:# .credo.exs %{ configs: [ %{ name: &quot;default&quot;, requires: [&quot;./lib/my_project/checks/**/*.ex&quot;], checks: [ {MyProject.Checks.RejectModuleAttributes, []} ] } ] }This tells Credo to require all files in our checks directory and to enable the RejectModuleAttributes check.Getting it workingFor a first implementation, our check should look into all modules and report &quot;violations&quot; against a list of rejected names.# lib/my_project/checks/reject_module_attributes.ex defmodule MyProject.Checks.RejectModuleAttributes do use Credo.Check # Let&#39;s say we want to report module attributes named `@checkdoc` @rejected_names [:checkdoc] def run(source_file, params \\\\ []) do # IssueMeta helps keeping track of the source file and the check&#39;s params # (technically, it&#39;s just a custom tagged tuple) issue_meta = IssueMeta.for(source_file, params) # we&#39;ll walk the `source_file`&#39;s AST and look for module attributes matching `@rejected_names` Credo.Code.prewalk(source_file, &amp;traverse(&amp;1, &amp;2, @rejected_names, issue_meta)) end # This matches on the AST structure of module attributes. defp traverse({:@, _, [{name, meta, [_string]} | _]} = ast, issues, rejected_names, issue_meta) do if Enum.member?(rejected_names, name) do {ast, issues ++ issue_for(name, meta[:line], issue_meta)} else {ast, issues} end end # For all AST nodes not matching the pattern above, we simply do nothing: defp traverse(ast, issues, _rejected_names, _issue_meta) do {ast, issues} end defp issue_for(trigger, line_no, issue_meta) do format_issue( issue_meta, message: &quot;There should be no `@\#{trigger}` module attributes.&quot;, trigger: &quot;@\#{trigger}&quot;, line_no: line_no ) end endTraversal of the AST is done via Credo.Code.prewalk/2, which is a light wrapper around Macro.prewalk/3, taking a Credo.SourceFile struct instead of an AST.You can use Code.string_to_quoted!/1 to look at the AST structure for code snippets:iex&gt; Code.string_to_quoted!(&quot;@my_attribute 23&quot;) {:@, [line: 1], [{:my_attribute, [line: 1], [23]}]}Adding configuration parametersNext, we should have a config parameter which allows us to define which module attribute names are no longer allowed.defmodule MyProject.Checks.RejectModuleAttributes do # To add a parameter, we use the `:param_defaults` keyword with `use Credo.Check`: use Credo.Check, param_defaults: [reject: [:checkdoc]] def run(source_file, params \\\\ []) do # To get a parameter, we use `Params.get/3`, which returns the given parameter from the config # or the default we registered above: reject = Params.get(params, :reject, __MODULE__) issue_meta = IssueMeta.for(source_file, params) Credo.Code.prewalk(source_file, &amp;traverse(&amp;1, &amp;2, reject, issue_meta)) end # ... endWe can now use .credo.exs to configure the :reject param.If the param is not declared ...{MyProject.Checks.RejectModuleAttributes, []}... then the default from your check is used.If the param is declared, it overwrites the default, meaning that this ...{MyProject.Checks.RejectModuleAttributes, [reject: [:shortdoc]]}... forbids @shortdoc, but allows @checkdoc again.Our final .credo.exs might look something like this:# .credo.exs %{ configs: [ %{ name: &quot;default&quot;, requires: [&quot;./lib/my_project/checks/**/*.ex&quot;], checks: [ {MyProject.Checks.RejectModuleAttributes, [reject: [:checkdoc, :other_attr]]} ] } ] }Finalizing the checkTo really make this a full-fledged Credo check, we have to configure its priority, category and describe what it does (you can find a description of the options in Credo.Check).defmodule MyProject.Checks.RejectModuleAttributes do use Credo.Check, base_priority: :high, category: :readability, param_defaults: [reject: []], explanations: [ check: &quot;&quot;&quot; Look, sometimes the policies for names of module attributes change. We want to make sure that all module attributes adhere to the newest standards of ACME Corp. We do not want to discuss this policy, we just want to stop you from using the old module attributes :) &quot;&quot;&quot;, params: [reject: &quot;This check warns about module attributes with any of the given names.&quot;] ] # ... endYou can now use Credo's explain command ...$ mix credo explain MyProject.Checks.RejectModuleAttributes... to show a description of your new check: MyProject.Checks.MyIExPry ┃ ┃ [R] Category: readability ┃ ↗ Priority: high ┃ ┃ __ WHY IT MATTERS ┃ ┃ Look, sometimes the policies for names of module attributes change. ┃ We want to make sure that all module attributes adhere to the newest standards of ACME Corp. ┃ ┃ We do not want to discuss this policy, we just want to stop you from using the old ┃ module attributes :) ┃ ┃ __ CONFIGURATION OPTIONS ┃ ┃ To configure this check, use this tuple ┃ ┃ {MyProject.Checks.RejectModuleAttributes, &lt;params&gt;} ┃ ┃ with &lt;params&gt; being false or any combination of these keywords: ┃ ┃ reject: Names of module attributes that are no longer allowed ┃ (defaults to []) ┃ And that's it. Here's the final check:defmodule MyProject.Checks.RejectModuleAttributes do use Credo.Check, base_priority: :high, category: :readability, param_defaults: [reject: []], explanations: [ check: &quot;&quot;&quot; Look, sometimes the policies for names of module attributes change. We want to make sure that all module attributes adhere to the newest standards of ACME Corp. We do not want to discuss this policy, we just want to stop you from using the old module attributes :) &quot;&quot;&quot;, params: [reject: &quot;Names of module attributes that are no longer allowed&quot;] ] def run(source_file, params \\\\ []) do reject = Params.get(params, :reject, __MODULE__) issue_meta = IssueMeta.for(source_file, params) Credo.Code.prewalk(source_file, &amp;traverse(&amp;1, &amp;2, reject, issue_meta)) end defp traverse({:@, _, [{name, meta, [_string]} | _]} = ast, issues, rejected_names, issue_meta) do if Enum.member?(rejected_names, name) do {ast, issues ++ issue_for(name, meta[:line], issue_meta)} else {ast, issues} end end defp traverse(ast, issues, _rejected_names, _issue_meta) do {ast, issues} end defp issue_for(trigger, line_no, issue_meta) do format_issue( issue_meta, message: &quot;There should be no `@\#{trigger}` module attributes.&quot;, trigger: trigger, line_no: line_no ) end endNext, let's see how we can write tests for our custom check!","ref":"adding_checks.html","title":"Adding Custom Checks","type":"extras"},{"doc":"Testing Custom ChecksCredo.Test.Case provides conveniences for testing Credo custom checks and plugins.This module can be used in your test cases, like this:use Credo.Test.CaseUsing this module will:import all the functions from this modulemake the test case :async by default (use async: false to opt out of this behaviour)Let's test the RejectModuleAttributes check that we implemented in Adding custom checks.Basic custom check testsTo test a check, we can use Credo.Test.Case for convenience:defmodule MyProject.Checks.RejectModuleAttributesTest do use Credo.Test.Case alias MyProject.Checks.RejectModuleAttributes test &quot;it should NOT report expected code&quot; do &quot;&quot;&quot; defmodule CredoSampleModule do @somedoc &quot;This is somedoc&quot; end &quot;&quot;&quot; |&gt; to_source_file() |&gt; run_check(RejectModuleAttributes) |&gt; refute_issues() end test &quot;it should report code that includes rejected module attribute names&quot; do &quot;&quot;&quot; defmodule CredoSampleModule do @checkdoc &quot;This is checkdoc&quot; end &quot;&quot;&quot; |&gt; to_source_file() |&gt; run_check(RejectModuleAttributes) |&gt; assert_issues() end endWe have two tests: one for the good case, one for the bad case. In each, we create a source file representation from a heredoc, run our custom check and assert/refute the issues we expect.Using custom params in testsWe can (and should) also test the params of our check by passing them to run_check/2:defmodule MyProject.Checks.RejectModuleAttributesTest do use Credo.Test.Case alias MyProject.Checks.RejectModuleAttributes # ... test &quot;it should NOT report code that includes default rejected module attribute names when a custom set of rejected names is provided&quot; do &quot;&quot;&quot; defmodule CredoSampleModule do @checkdoc &quot;This is checkdoc&quot; end &quot;&quot;&quot; |&gt; to_source_file() |&gt; run_check(RejectModuleAttributes, reject: [:somedoc]) |&gt; refute_issues() end test &quot;it should report expected code when a custom set of rejected names is provided&quot; do &quot;&quot;&quot; defmodule CredoSampleModule do @somedoc &quot;This is somedoc&quot; end &quot;&quot;&quot; |&gt; to_source_file() |&gt; run_check(RejectModuleAttributes, reject: [:somedoc]) |&gt; assert_issues() end endAsserting found issuesOnce we get to know domain a little better, we can add more tests, typically testing for other bad cases in which our check should produce issues.Note that there are two assertion functions for this: assert_issue/2 and assert_issues/2, where the first one ensures that there is a single issue and the second asserts that there are at least two issues.Both functions take an optional callback as their second parameter, which is called with the issue or the list of issues found, which makes it convenient to check for the issues properties ...&quot;&quot;&quot; # ... any Elixir code ... &quot;&quot;&quot; |&gt; to_source_file() |&gt; run_check(RejectModuleAttributes) |&gt; assert_issue(fn issue -&gt; assert issue.trigger == &quot;@checkdoc&quot; end)... or properties of the list of issues:&quot;&quot;&quot; # ... any Elixir code ... &quot;&quot;&quot; |&gt; to_source_file() |&gt; run_check(RejectModuleAttributes) |&gt; assert_issue(fn issues -&gt; assert Enum.count(issues) == 3 end)Testing checks that analyse multiple source filesFor checks that analyse multiple source files, like Credo's consistency checks, we can use to_source_files/1 to create[ &quot;&quot;&quot; # source file 1 &quot;&quot;&quot;, &quot;&quot;&quot; # source file 2 &quot;&quot;&quot; ] |&gt; to_source_files() |&gt; run_check(RejectModuleAttributes) |&gt; refute_issues()If our check needs named source files, we can always use to_source_file/2 to create individually named source files and combine them into a list:source_file1 = &quot;&quot;&quot; # source file 1 &quot;&quot;&quot; |&gt; to_source_file(&quot;foo.ex&quot;) source_file2 = &quot;&quot;&quot; # source file 2 &quot;&quot;&quot; |&gt; to_source_file(&quot;bar.ex&quot;) [source_file1, source_file2] |&gt; run_check(RejectModuleAttributes) |&gt; assert_issue(fn issue -&gt; assert issue.filename == &quot;foo.ex&quot; end)","ref":"testing_checks.html","title":"Testing Custom Checks","type":"extras"},{"doc":"Plugins 101Plugins can provide additional functionality to Credo.This functionality can include:adding new commandsoverriding existing commands (e.g. implement better Explain command)modifying the default configadding checks, which can add their own issues, with their own categories,prepending/appending steps to Credo's execution processadding new CLI optionsUsing pluginsPlugins are just modules. Most of the time, a Credo plugin will be published on Hex. You include it as a dependency:{:credo_demo_plugin, &quot;~&gt; 0.1.0&quot;},Plugins, like checks, are just modules and functions. They can be included by listing them under the :plugins field in Credo's configuration file.%{ configs: [ %{ name: &quot;default&quot;, plugins: [ {CredoDemoPlugin, []} ] } ] }Configuring pluginsPlugins can be configured via params, just like checks. Each entry consists of a two-element tuple: the plugin's module and a keyword list of parameters, which can be used to configure the plugin itself.%{ configs: [ %{ name: &quot;default&quot;, plugins: [ {CredoDemoPlugin, [castle: &quot;Grayskull&quot;]} ] } ] }Plugins can be deactivated by setting the second tuple element to false.%{ configs: [ %{ name: &quot;default&quot;, plugins: [ {CredoDemoPlugin, []}, {CredoYetAnotherPlugin, false} # &lt;-- don&#39;t load this for now ] } ] }Creating a pluginA plugin is basically just a module that provides an init/1 callback.defmodule CredoDemoPlugin do def init(exec) do # but what do we do here?? exec end endThe Credo.Plugin module provides a number of functions for extending Credo's core features.defmodule CredoDemoPlugin do @config_file File.read!(&quot;.credo.exs&quot;) import Credo.Plugin def init(exec) do exec |&gt; register_default_config(@config_file) |&gt; register_command(&quot;demo&quot;, CredoDemoPlugin.DemoCommand) |&gt; register_cli_switch(:castle, :string, :X) |&gt; append_task(:convert_cli_options_to_config, CredoDemoPlugin.ConvertCliSwitchesToPluginParams) |&gt; prepend_task(:set_default_command, CredoDemoPlugin.SetDemoAsDefaultCommand) end endAdd new commandsCommands are just modules with a call function and adding new commands is easy.# credo_demo_plugin.ex defmodule CredoDemoPlugin do import Credo.Plugin def init(exec) do register_command(exec, &quot;demo&quot;, CredoDemoPlugin.DemoCommand) end end# credo_demo_plugin/demo_command.ex defmodule CredoDemoPlugin.DemoCommand do alias Credo.CLI.Output.UI alias Credo.Execution def call(exec, _) do castle = Execution.get_plugin_param(exec, CredoPlus, :castle) UI.puts(&quot;By the power of \#{castle}!&quot;) exec end endUsers can use this command by typing$ mix credo demo By the power of !Override an existing commandSince commands are just modules with a call function, overriding existing commands is easy.defmodule CredoDemoPlugin do import Credo.Plugin def init(exec) do register_command(exec, &quot;explain&quot;, CredoDemoPlugin.MyBetterExplainCommand) end endThis example would have the effect that typing mix credo lib/my_file.ex:42 would no longer run the built-in Explain command, but rather our plugin's MyBetterExplain command.Modifying the default configPlugins can add default configuration to Credo.defmodule CredoDemoPlugin do import Credo.Plugin def init(exec) do register_default_config(exec, @config_file) end endThe configuration's loading order is this:Credo's own default configDefault configs added by pluginsConfig files in the user's file systemConfig values set in later stages are overwriting values from earlier ones.Adding checksTo add checks from your plugin, simply extend the default config ...# credo_demo_plugin.ex defmodule CredoDemoPlugin do @config_file File.read!(&quot;.credo.exs&quot;) import Credo.Plugin def init(exec) do register_default_config(exec, @config_file) end end... and then add the new checks there:# .credo.exs %{ configs: [ %{ name: &quot;default&quot;, checks: [ {CredoDemoPlugin.MyNewCheck, []} ] } ] }Since we are extending the default config, we can also deactivate checks and &quot;replace&quot; them with new ones:# .credo.exs %{ configs: [ %{ name: &quot;default&quot;, checks: [ {Credo.Check.Readability.ModuleDoc, false}, {CredoDemoPlugin.BetterModuleDoc, []} ] } ] }Inserting tasks into Credo's execution processCredo's execution process consists of several steps, each with a set of tasks, which you can hook into.Prepending or appending tasks to these steps is easy:# credo_demo_plugin.ex defmodule CredoDemoPlugin do import Credo.Plugin def init(exec) do prepend_task(exec, :set_default_command, CredoDemoPlugin.SetDemoAsDefaultCommand) end end# credo_demo_plugin/set_demo_as_default_command.ex defmodule CredoPlus.SetDemoAsDefaultCommand do use Credo.Execution.Task alias Credo.CLI.Options def call(exec, _opts) do set_command(exec, exec.cli_options.command || &quot;demo&quot;) end defp set_command(exec, command) do %Execution{exec | cli_options: %Options{exec.cli_options | command: command}} end endThis example would have the effect that typing mix credo would no longer run the built-in Suggest command, but rather our plugin's Demo command.Adding new CLI optionsWe saw how plugins can be configured via params in the &quot;Configuring plugins&quot; section:{CredoDemoPlugin, [castle: &quot;Grayskull&quot;]}But what about those situations where we want to be able to configure things on-the-fly via the CLI? Plugins should be able to provide custom CLI options as well, so we can do something like:$ mix credo --castle Winterfell Unknown switch: --castleRegistering a custom CLI switch is easy:defmodule CredoDemoPlugin do import Credo.Plugin def init(exec) do register_cli_switch(exec, :castle, :string, :X) end endOf course, having a CLI option is not worth much if we can not utilize it. This is why every registered CLI switch is automatically converted into a plugin param of the same name.$ mix credo --castle Winterfell By the power of Winterfell!Plugin authors can also provide a function to control the plugin param's name and value more granularly:defmodule CredoDemoPlugin do import Credo.Plugin def init(exec) do register_cli_switch(exec, :kastle, :string, :K, fn(switch_value) -&gt; {:castle, switch_value} end) end end","ref":"plugins.html","title":"Plugins 101","type":"extras"}]